#include <cstdio>
#include <cassert>
using namespace std;

int n;

bool corr(int x, int l) {
    int bal = 0;
    for (int i = 0; i < l; i++) {
        int cur = (x >> i) & 1;
        cur = 2 * cur - 1;
        bal += cur;
        if (bal < 0)
            return false;
    }
    if (bal != 0)
        return false;
    return true;
}

const int N = 20;
bool ans[N][N];

bool check(int x) {
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            int y = (x & ((1 << (j + 1)) - 1)) >> i;
            if (ans[i][j] != corr(y, j - i + 1)) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    scanf("%d", &n);
    assert(n <= 16);
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            printf("? %d %d\n", i + 1, j + 1);
            fflush(stdout);
            char buf[5];
            scanf("%s", buf);
            ans[i][j] = buf[0] == 'Y';
        }
    }
    int ans = -1;
    for (int i = 0; i < (1 << n); i++) {
        if (!corr(i, n))
            continue;
        if (check(i)) {
            assert(ans == -1);
            ans = i;
        }
    }
    assert(ans != -1);
    printf("! ");
    for (int i = 0; i < n; i++) {
        printf("%c", ")("[(ans >> i) & 1]);
    }
    printf("\n");
    fflush(stdout);
}

