/*
File name: rg_n_tinf.cpp
Tag: REJECTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:24:16 MSK 2017

*/
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long double ld;

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct seg {
	int can, l, r;
};

struct edge {
	int l, r;
};

seg merge(seg a, seg b) {
	if (!a.can || !b.can) return {0, 0, 0};
	if (a.r > b.l || b.r > a.l) return {0, 0, 0};
	return {1, max(a.l, b.l), min(a.r, b.r)};
}

seg merge(seg a, edge b, int t) {
	if (!a.can) return {0, 0, 0};
	if (a.r < b.l || b.r < a.l) return {0, 0, 0};
	if (b.l < a.l) return {1, a.l, min(a.r, b.r)};
	else return {1, b.l - t, min(a.r, b.r)};
}

int n, t[nmax], l[nmax], r[nmax];
edge a[nmax];
bool used[nmax];

int main() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", t + i);
	}
	for (int i = 0; i < n - 1; i++) {
		scanf("%d%d", &a[i].l, &a[i].r);
	}
	int r = inf;
	for (int i = 0; i < n - 1; i++) {
		if (r < a[i].l) {
			for (int j = i + 1; j < n; j++) {
				used[j] = true;
			}
			break;
		} else {
			r = min(a[i].r, r);
		}
	}
	r = inf;
	for (int i = n - 2; i >= 0; i--) {
		if (r < a[i].l) {
			for (int j = i; j >= 0; j--) {
				used[j] = true;
			}
			break;
		} else {
			r = min(a[i].r, r);
		}
	}
	for (int i = 0; i < n; i++) {
		printf("%d\n", (used[i] ? -1 : 0));
	}
	return 0;
}


