/*
File name: rg_n_tinf_wa.cpp
Tag: REJECTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:24:21 MSK 2017

*/
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long double ld;

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct seg {
	int can, l, r;
};

struct edge {
	int l, r;
};

seg merge(seg a, seg b) {
	if (!a.can || !b.can) return {0, 0, 0};
	if (a.r > b.l || b.r > a.l) return {0, 0, 0};
	return {1, max(a.l, b.l), min(a.r, b.r)};
}

seg merge(seg a, edge b, int t) {
	if (!a.can) return {0, 0, 0};
	if (a.r < b.l || b.r < a.l) return {0, 0, 0};
	if (b.l < a.l) return {1, a.l, min(a.r, b.r)};
	else return {1, b.l - t, min(a.r, b.r)};
}

int n, t[nmax];
edge a[nmax];
vector<int> ll, lr, rl, rr;

int main() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", t + i);
	}
	for (int i = 0; i < n - 1; i++) {
		scanf("%d%d", &a[i].l, &a[i].r);
	}
	ll.assign(n + 1, 0);
	lr.assign(n + 1, inf);
	rl.assign(n + 1, 0);
	rr.assign(n + 1, inf);
	for (int i = 0; i < n - 1; i++) {
		ll[i + 1] = max(ll[i], a[i].l);
		lr[i + 1] = min(lr[i], a[i].r);
	}
	for (int i = n - 1; i >= 0; i--) {
		rl[i] = max(rl[i + 1], a[i].l);
		rr[i] = min(rr[i + 1], a[i].r);
	}
	for (int i = 0; i < n; i++) {
		if (ll[i] > lr[i] || rl[i + 1] > rr[i + 1]) printf("-1\n");
		else printf("0\n");
	}
	return 0;
}


