#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const ll INF = 2e18;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Node {
	int l, r, mn;

	// inline bool friend operator <(const Node &a, const Node &b) {
	// 	return a.mn > b.mn || (a.mn == b.mn && make_pair(a.l, a.r) < make_pair(b.l, b.r));
	// }
};

// inline ll pack(Node a) {
// 	return ((ll)a.l << 35) + ((ll)a.r << 17) + a.mn;
// }

inline int pack(int a, int b) {
	return (a << 17) + b;
}

inline pair<int, int> unpack(int a) {
	pair<int, int> t;
	t.first = (a >> 17);
	t.second = a - (t.first << 17);
	return t;
}

int n, a;
vector<Node> steps;
unordered_map<int, int> dp;
// vector<vector<ll> > dp;

inline ll calc(int a) {
	pair<int, int> t = unpack(a);
	return (ll)t.first * (ll)1e9 - t.second;
}

inline int mn(int a, int b) {
	if (a == -1) return b;

	if (calc(a) > calc(b)) {
		return b;
	} else {
		return a;
	}
}

inline int mx(int a, int b) {
	if (a == -1) return b;

	if (calc(a) > calc(b)) {
		return a;
	} else {
		return b;
	}
}

int getAns(int now, int c) {
	if ((int)dp.size() > 1e6) return 0;
	if (dp.count(pack(now, c))) return dp[pack(now, c)];

	int ans = pack(now, c);

	for (auto s : steps) {
		if (now + s.r > a) continue;

		int tmp = -1;

		for (int i = s.l; i <= s.r; i++) {
			tmp = mn(tmp, getAns(now + i, c + s.mn));
		}

		ans = mx(ans, tmp);
	}

	return (dp[pack(now, c)] = ans);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("anti.in", "r", stdin);
	freopen("anti.out", "w", stdout);
#endif

	cin >> n >> a;

	steps.resize(n);

	for (int i = 0; i < n; i++) {
		int l, r, c;
		cin >> l >> r >> c;
		steps[i] = {l, r, c};
	}

	cout << calc(getAns(0, 0)) << "\n";

	return 0;
}
