#include <iostream>

using namespace std;

#define f first
#define s second

const int INF = 1e9;

int n;
pair<int, int> tunnel[1000000];
int arr[1000000];
pair<int, int> result[1000000];
pair<int, int> result2[1000000];

void act1()
{
    result[0].f = 0;
    result[0].s = INF;
    for(int i = 1; i < n; i++){
        result[i].f = max(result[i-1].f, tunnel[i-1].f);
        result[i].s = min(result[i-1].s, tunnel[i-1].s);
        if(result[i].f == tunnel[i-1].f and tunnel[i-1].f <= result[i].s)
            result[i].f -= arr[i];
    }
}

void act2()
{
    result2[n-1].f = 0;
    result2[n-1].s = INF;
    for(int i = n-2; i >= 0; i--){
        result2[i].f = max(result2[i+1].f, tunnel[i].f);
        result2[i].s = min(result2[i+1].s, tunnel[i].s);
        if(result2[i].f == tunnel[i].f and tunnel[i].f <= result2[i].s)
            result2[i].f -= arr[i];
    }
}

int main()
{

    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> arr[i];
    }
    for(int i = 0; i < n-1; i++)
        cin >> tunnel[i].f >> tunnel[i].s;
    act1();
    act2();
    int my_left;
    int my_right;
    for(int i = 0; i < n; i++){
        my_left = max(result[i].f, result2[i].f);
        my_right = min(result[i].s, result2[i].s);
        if(my_left > my_right)
            cout << -1 << endl;
        else
            cout << my_left << endl;
    }
    return 0;
}
