#include <bits/stdc++.h>

using namespace std;

int n;
vector<pair<int, int> > limits;
vector<int> f;

vector<pair<int, int> > sol()
{
    int L = 0, R = 1e9;
    vector<pair<int, int> > ret(1, { L, R });
    for (int i = 1; i < n; i++)
    {
        if (L == -1)
        {
            ret.push_back({ -1, -1 });
            continue;
        }
        if (limits[i - 1].first >= L)
        {
            if (limits[i - 1].first > R)
            {
                L = -1;
                ret.push_back({ -1, -1 });
                continue;
            }
            L = max(limits[i - 1].first - f[i], 0);
        }
        if (limits[i - 1].second < R)
            R = limits[i - 1].second;
        if (L > R)
        {
            L = -1;
            ret.push_back({ -1, -1 });
            continue;
        }
        ret.push_back({ L, R });
    }
    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    limits.resize(n - 1);
    f.resize(n);
    for (auto &i : f)
        cin >> i;
    for (auto &i : limits)
        cin >> i.first >> i.second;
    auto L = sol();
    reverse(limits.begin(), limits.end());
    reverse(f.begin(), f.end());
    auto R = sol();
    reverse(R.begin(), R.end());
    for (int i = 0; i < n; i++)
    {
        if (R[i].first == -1 || L[i].first == -1)
        {
            cout << "-1\n";
            continue;
        }
        if (R[i].first > L[i].second || L[i].first > R[i].second)
            cout << "-1\n";
        else
            cout << max(L[i].first, R[i].first) << "\n";
    }
    return 0;
}
