#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

vector<vector<pair<int, int> > > gr;
vector<bool> was;

long long ans1 = -1, ans2 = 0, n_ans1 = 0, n_ans2 = 0;
int n;


void dfs(int v){
    if (was[v]){
        return;
    }
    was[v] = 1;
    if (v == n - 1){
        if (n_ans1 < ans1 || (n_ans1 == ans1 && n_ans2 > ans2) || ans1 == -1){
            ans1 = n_ans1;
            ans2 = n_ans2;
        }
    }
    else{
        for (auto i : gr[v]){
            n_ans1 += i.second;
            n_ans2 += i.second * i.second;
            if (!was[i.first])
                dfs(i.first);
            n_ans1 -= i.second;
            n_ans2 -= i.second * i.second;
        }
    }
    was[v] = 0;
}


int main()
{
    ios::sync_with_stdio(0);
    int m;
    cin >> n >> m;
    gr.resize(n);
    was.resize(n);
    for (int i = 0; i < n; i++){
        was[i] = 0;
    }
    vector<vector<int> > inp(n, vector<int>(n, 2000));
    int last = -1;
    for (int i = 0; i < m; i++){
        int s;
        cin >> s;
        cin >> last;
        last--;
        int time, to;
        for (int j = 0; j < s; j ++){
            cin >> time >> to;
            to--;
            inp[last][to] = min(inp[last][to], time);
            last = to;
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (inp[i][j] != 2000){
                gr[i].push_back({j, inp[i][j]});
            }
        }
    }
    dfs(0);
    cout << ans1 << ' ' << ans2;
    return 0;
}
