// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>

using namespace std;

const int LEN = 102;

string s;
vector <int> a, b, res;
bool p1, p2;
string sign = "";

void conv(string s, vector <int> &v)
{
	for (int i = 0; i < s.length(); i++)\
		v[i] = s[s.length() - i - 1] - '0';
}

vector <int> minusv(vector <int> a, vector <int> b)
{
	vector <int> res = a;
	int md = 0;
	for (int i = 0; i < LEN; i++)
	{
		res[i] = a[i] - b[i] - md;
		md = (res[i] < 0 ? 1 : 0);
		if (md)
			res[i] += 10;
	}
	return res;
}

bool more(vector <int> a, vector <int> b)
{
	for (int i = LEN - 1; i >= 0; i--)
	{
		if (a[i] > b[i])
			return true;
		if (a[i] < b[i])
			return false;
	}
	return false;
}

int main()
{
	a.clear();
	a.resize(LEN, 0);
	b = a;

	cin >> s;
	p1 = (s[0] != '-');
	if (!p1)
		s.erase(0, 1);
	conv(s, a);
	cin >> s;
	p2 = (s[0] != '-');
	if (!p2)
		s.erase(0, 1);
	conv(s, b);

	if (p1 && p2 || !p1 && !p2)
	{
		res = a;
		int mind = 0;
		for (int i = 0; i < LEN; i++)
		{
			res[i] = a[i] + b[i] + mind;
			mind = res[i] / 10;
			res[i] %= 10;
		}
		if (!p1)
			sign = "-";
	}
	else
	{
		if (a == b)
		{
			cout << 0;
			return 0;
		}
		if (!more(a, b))
		{
			swap(a, b);
			swap(p1, p2);
		}
		if (!p1)
			sign = "-";
		res = minusv(a, b);
	}

	cout << sign;
	int k = LEN - 1;
	while (k >= 0 && !res[k])
		k--;
	if (k == -1)
		cout << 0;
	for (; k >= 0; k--)
		cout << res[k];

	return 0;
}