#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

bool check(string s, bool s1, bool s2) {
    int c = 1;
    vector <int> p;
    if (s1 && s[0] == '-')
        p.push_back(0);
    for (int i = 1; i < (int)s.length(); i++) {
        if (s[i] != s[i - 1]) {
            p.push_back(c);
            c = 1;
        } else
            c++;
    }
    p.push_back(c);
    if (s2 && s[(int)s.length() - 1] == '-')
        p.push_back(0);

    vector <int> curp;
    for (int i = 0; i < (int)p.size(); i++) {
        curp.push_back(p[i]);
        int sz = (int)curp.size();
        if (i % 2 == 0) {
            while (sz >= 3 && (curp[sz - 2] < curp[sz - 1] || curp[sz - 2] < curp[sz - 3])) {
                curp[sz - 3] += curp[sz - 2] + curp[sz - 1];
                curp.pop_back();
                curp.pop_back();
                sz -= 2;
            }
        }
    }

    return (int)curp.size() == 1;
}

bool solve(string &s1, string &s2) {
    int n = (int)s1.length();
    vector <int> g;
    for (int i = 1; i < n; i++) {
        if (s2[i] != s2[i - 1] && (s2[i] != s1[i] || s2[i - 1] != s1[i - 1]))
            return false;
        if (s2[i] != s2[i - 1])
            g.push_back(i - 1);
    }
    g.push_back(n - 1);

    int last = 0;
    for (int i = 0; i < (int)g.size(); i++) {
        string s = "";
        for (int j = last; j <= g[i]; j++)
            s += s1[j];
        if (s2[last] == '-') {
            for (int j = 0; j < (int)s.length(); j++)
                s[j] = (s[j] == '+') ? '-' : '+';
        }
        if (!check(s, (i == 0), (i == (int)g.size() - 1)))
            return false;
        last = g[i] + 1;
    }

    return true;
}

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int q; cin >> q;
    for (int kek228 = 0; kek228 < q; kek228++) {
        string s1, s2; cin >> s1 >> s2;

        if (solve(s1, s2))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }

    return 0;
}
