#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

const int MAXN = 2e6;

int l[MAXN], r[MAXN], t[MAXN];
int n;

int dpl[MAXN];
int dpr[MAXN];

int ansl[MAXN], ansr[MAXN];

int32_t main() {
    //freopen("input.txt", "r", stdin);
    //assert(freopen("servers.in", "r", stdin));
    //assert(freopen("servers.out", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < n - 1; i++)
        cin >> l[i] >> r[i];
    dpl[n - 1] = 0, dpr[n - 1] = 2e9;

    for (int i = n - 2; i >= 0; i--) {
        int q = dpl[i + 1], w = dpr[i + 1];
        dpl[i] = 2e9, dpr[i] = 0;
        for (int k = max(0, l[i] - t[i]); k <= r[i]; k++)
            if (q <= max(k, l[i]) && max(k, l[i]) <= w) {
                dpl[i] = k;
                break;
            }
        for (int k = max(0, l[i] - t[i]); k <= r[i]; k++)
            if (q <= max(k, l[i]) && max(k, l[i]) <= w)
                dpr[i] = k;
    }

    for (int i = 0; i < n; i++)
        ansl[i] = dpl[i], ansr[i] = dpr[i];

    dpl[0] = 0, dpr[0] = 2e9;
    for (int i = 1; i < n; i++) {
        int q = dpl[i - 1], w = dpr[i - 1];
        dpl[i] = 2e9, dpr[i] = 0;
        for (int k = max(0, l[i - 1] - t[i]); k <= r[i - 1]; k++) {
            if (q <= max(k, l[i - 1]) && max(k, l[i - 1]) <= w) {
                dpl[i] = k;
                break;
            }
        }
        for (int k = max(0, l[i - 1] - t[i]); k <= r[i - 1]; k++)
            if (q <= max(k, l[i - 1]) && max(k, l[i - 1]) <= w)
                dpr[i] = k;
    }

    for (int i = 0; i < n; i++) {
        ansl[i] = max(ansl[i], dpl[i]);
        ansr[i] = min(ansr[i], dpr[i]);
    }

    for (int i = 0; i < n; i++) {
        if (ansl[i] > ansr[i])
            cout << -1 << endl;
        else
            cout << ansl[i] << endl;
    }

    return 0;
}
