#include <bits/stdc++.h>

using namespace std;

bool operator < (pair<int, long long> a, pair<int, long long> b)
{
    return a.first < b.first || (a.first == b.first && a.second > b.second);
}

int main() {
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, long long>>> g(n + 1);
    for (int i = 0; i < m; i++)
    {
        int s;
        cin >> s;
        vector<int> v(s + 1);
        vector<int> t(s);
        for (int j = 0; j < s; j++)
        {
            cin >> v[j] >> t[j];
        }
        cin >> v[s];
        for (int j = 0; j < s; j++)
        {
            long long curr = t[j];
            for (int k = j + 1; k <= s; k++)
            {
                g[v[j]].push_back({v[k], curr});
                if (k < s)
                    curr += t[k];
            }
        }
    }
    vector<pair<int, long long>> d(n + 1, {1e9, 0});
    d[1] = {0, 0};
    set<pair<pair<int, long long>, int>> heap;
    heap.insert({{0, 0}, 1});
    while (!heap.empty())
    {
        int curr = heap.begin()->second;
        if (d[curr] != heap.begin()->first)
        {
            heap.erase(heap.begin());
            continue;
        }
        heap.erase(heap.begin());
        for (auto u : g[curr])
        {
            pair<int, long long> New = {d[curr].first + u.second, d[curr].second + u.second * u.second};
            if (New < d[u.first])
            {
                d[u.first] = New;
                heap.insert({New, u.first});
            }
        }
    }
    cout << d[n].first << " " << d[n].second;
}