#include<iostream>
#include<vector>
#include<string>
#include<queue>
#include<map>
#include<cassert>
#include<cmath>
#include<algorithm>

using namespace std;

#define int long long

const int d = 1e9;
const int inf = 4e18;
const int maxlim = 2e6;
const int lg = 20;
vector<int> l, r, c;
int t[lg + 1][maxlim];
int ln[maxlim + 1];
int n, lim;
int nn;

int get(int l, int r) {
	int p = ln[r - l];
	return min(t[p][l], t[p][r - (1 << p)]);
}

void setup(int ind, int val) {
	t[0][ind] = val;
	for (int i = 1; i <= lg; i++) {
		int len = 1 << ln[lim - ind];
		if (ind + len >= lim)
			break;
		t[i][ind] = min(t[i - 1][ind], t[i - 1][ind + len]);
	}
}

/*int f(int w, int cc) {
	if (ff.count({ w, cc }))
		return ff[{w, cc}];
	int mx = w * d - cc;
	for (int i = 0; i < n; i++) {
		if (w + r[i] > lim)
			continue;
		int mn = inf;
		for (int x = l[i]; x <= r[i]; x++)
			mn = min(mn, f(w + x, cc + c[i]));
		mx = max(mx, mn);
	}
	ff[{w, cc}] = mx;
	return mx;
}*/

int32_t main() {
	//freopen("input.in", "r", stdin);
	ios_base::sync_with_stdio(false);
	cin >> n >> lim;

	ln[0] = ln[1] = 0;
	for (int i = 2; i <= lim; i++)
		ln[i] = ln[i / 2] + 1;

	l.resize(n);
	r.resize(n);
	c.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> c[i];
	}

	for (int i = lim; i >= 0; i--) {
		int cx = i * d;
		for (int j = 0; j < n; j++) {
			if (i + r[j] > lim)
				continue;
			int mn = get(i + l[j], i + r[j] + 1);
			cx = max(cx, mn - c[j]);
		}
		setup(i, cx);
	}
	cout << get(0, 1) << "\n";
}