#include <iostream>
#include <vector>
#include <cmath>

#define ll long long

using namespace std;
int n;
vector<pair<int, int>> points;
vector<pair<pair<int, int>, int>> figures;

double s(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    double pl = 0;
    pl += (abs(a.second)+abs(b.second)) / 2 * (b.first - a.first);
    pl += (abs(b.second)+abs(c.second)) / 2 * (c.first - b.first);
    pl += (abs(c.second)+abs(a.second)) / 2 * (a.first - c.first);
    return abs(pl);
}

int main() {
    cin >> n;
    string ans;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        points.push_back(make_pair(a, b));
    }
    int q;
    cin >> q;
    int i, j, k;
    bool find = true;
    for (i = 1; i <= n - 2; i++) {
        for (j = i + 1; j <= n - 1; j++) {
            for (k = j + 1; k <= n; k++) {
                bool find = true;

                double s1 = s(points[i - 1], points[j - 1], points[k - 1]);
                for (int z = 0; z < n; z++) {
                    if (z != i - 1 && z != j - 1 && z != k - 1) {
                        double pl = (s(points[z], points[j - 1], points[k - 1]) +
                                     s(points[i - 1], points[z], points[k - 1]) +
                                     s(points[i - 1], points[j - 1], points[z]));

                        if (abs(pl - s1) < (1e-9)) {
                            find = false;
                            break;
                        }
                    }
                }
                if (find) {
                    figures.push_back(make_pair(make_pair(i, j), k));
                }

            }
        }
    }

    for (int t = 0; t < q; t++) {
        bool find = false;
        for (ll i = 0; i < figures.size(); i++) {
            cout << "? 3 " << figures[i].first.first << " " << figures[i].first.second << " " << figures[i].second
                 << endl;
            cin >> ans;
            if (ans[0] == 'Y') {
                cout << "! 3 " << figures[i].first.first << " " << figures[i].first.second+1 << " " << figures[i].second
                     << endl;
                break;
            }
        }
    }
    return 0;
}