#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

int n, q;
vector<int> a;
vector<vector<bool> > bin;
vector<int> ans(31, -1);

bool find_b(int cur, int l, int r)
{
    if (cur >= 31){
        return true;
    }
    int pred = bin[l][cur], cnt = 1;
    int m;
    for (int i = l + 1; i < r && cnt <= 2; ++i){
        if (pred == bin[i][cur]){
            continue;
        }
        pred = bin[i][cur];
        cnt++;
        m = i;
    }
    if (cnt == 1){
        return find_b(cur + 1, l, r);
    }
    bool need;
    if (pred == 1){
        need = 0;
    }
    else{
        need = 1;
    }
    if (ans[cur] == -1){
        ans[cur] = need;
    }
    if (cnt > 2 || ans[cur] != need){
        return false;
    }
    return find_b(cur + 1, l, m) && find_b(cur + 1, m, r);
}

void fill_b(int pos){
    int cur = a[pos];
    int pos_b = 0;
    while (cur != 0){
        bin[pos][pos_b] = cur % 2;
        pos_b++;
        cur >>= 1;
    }
    for (int i = pos_b; i < 31; ++i){
        bin[pos][i] = false;
    }
    reverse(bin[pos].begin(), bin[pos].end());
}

void prt_b()
{
    int res = 0;
    for (int i = 0; i < 31; ++i){
        if (ans[i] == -1){
            continue;
        }
        res += (ans[i] << (30 - i));
    }
    printf("%d\n", res);
}

int main()
{
    //freopen("order.in", "r", stdin);
    //freopen("order.out", "w", stdout);
    scanf("%d", &n);
    a.resize(n + 1);
    bin.resize(n + 1, vector<bool>(31, false));
    for (int i = 0; i < n; ++i){
        scanf("%d", &a[i]);
        fill_b(i);
    }
    if (!find_b(0, 0, n)){
        printf("-1\n");
    }
    else{
        prt_b();
    }
    scanf("%d", &q);
    for (int i = 0; i < q; ++i){
        int pos, val;
        scanf("%d%d", &pos, &val);
        a[pos - 1] = val;
        fill_b(pos - 1);
        for (int j = 0; j < 31; ++j){
            ans[j] = -1;
        }
        if (!find_b(0, 0, n)){
            printf("-1\n");
        }
        else{
            prt_b();
        }
    }
    /*cin >> q;
    for (int i = 0; i < q; ++i){
        int pos, val;
    }*/
    fclose(stdout);
    return 0;
}
