#include <bits/stdc++.h>
using namespace std;

#define int long long

struct node{
	int x, y;
	bool rev = 0;
	node *l = 0, *r = 0;
	node(int _x){ x = _x, y = rand(); }
};

void push(treap *v){
	if(v->rev){
		v->rev = 0;
		swap(v->l, v->r);
	}
}

void traverse(treap *v){
	if(!v) return;
	push(v);
	traverse(v->l);
	cout << v->x << " ";
	traverse(v->r);
}

node* merge(node *u, node *v){
	if(!u) return v;
	if(!v) return u;
	if(u->y > v->y){
		u->r = merge(u->r, v);
		return u;
	}
	else{
		v->l = merge(u, v->l);
		return v;
	}
}

treap *root = 0;

main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    int x;
    while(cin >> x) root = merge(root, new treap(x)); 
    
    root->rev = 1;
    
    traverse(root);

    return 0;
}
