#include <iostream>
#include <map>
#include <set>

using namespace std;
const int MAXN = 1e3 * 5 + 100;

long long get_pref[MAXN];

long long get_preff(int a, int b){
    a--;
    if (a == -1){
        return get_pref[b];
    } else {
        return get_pref[b] - get_pref[a];
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    pair<int, long long> un1[MAXN];
    pair<int, long long> un2[MAXN];
    map<int, int> zn_to_pos;

    for (int i = 0; i < n; ++i){
        cin >> un1[i].first;
    }

    for (int i = 0; i < n; ++i){
        cin >> un1[i].second;
    }

    for (int i = 0; i < m; ++i){
        cin >> un2[i].first;
        zn_to_pos[un2[i].first] = i;
    }

    for (int i = 0; i < m; ++i){
        cin >> un2[i].second;
    }

    get_pref[0] = un2[0].second;

    for (int i = 1; i < m; ++i){
        get_pref[i] = get_pref[i - 1] + un2[i].second;
    }

    long long ans = get_pref[m - 1];
    int l1 = -1, r1 = -1, l2 = 0, r2 = m - 1;

    for (int i = 0; i < n; ++i){
        set<pair<pair<int, int>, long long>> st;
        set<pair<long long, pair<int, int>>> answ;

        st.insert({{0, m}, get_pref[m - 1]});
        answ.insert({-get_pref[m - 1], {0, m}});

        long long cur_sum = 0;


        for (int j = i; j < n; ++j){
            int ch = un1[j].first;
            cur_sum += un1[j].second;

            if (zn_to_pos.count(ch) > 0){
                int cur_ind = zn_to_pos[ch];

                auto it = st.lower_bound({{cur_ind, cur_ind}, 0});

                if (it == st.end() || it->first.first > cur_ind){
                    it--;
                }

                auto koks = *it;
                st.erase(koks);

                answ.erase({-koks.second, {koks.first.first, koks.first.second}});

                pair<pair<int, int>, long long> koks1 = {{koks.first.first, cur_ind}, get_preff(koks.first.first, cur_ind - 1)};
                pair<pair<int, int>, long long> koks2 = {{cur_ind + 1, koks.first.second}, get_preff(cur_ind + 1, koks.first.second - 1)};

                if (koks1.first.first < koks1.first.second){
                    st.insert(koks1);
                    answ.insert({-koks1.second, {koks1.first.first, koks1.first.second}});
                }


                if (koks2.first.first < koks2.first.second){
                    st.insert(koks2);
                    answ.insert({-koks2.second, {koks2.first.first, koks2.first.second}});
                }
            }

            if (answ.size() == 0){
                if (ans < cur_sum){
                    ans = cur_sum;
                    l1 = i;
                    r1 = j;
                    l2 = -1;
                    r2 = -1;
                }
            } else {
                long long ch = answ.begin()->first;
                auto pr = answ.begin()->second;
                if (ans < cur_sum - ch){
                    ans = cur_sum - ch;
                    l1 = i;
                    r1 = j;
                    l2 = pr.first;
                    r2 = pr.second - 1;
                }
            }
        }
    }

    cout << ans << endl;

    cout << l1 + 1 << ' ' << r1 + 1 << endl;
    cout << l2 + 1 << ' ' << r2 + 1 << endl;

    return 0;
}
