#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <iostream>

#pragma warning(disable: 4996)
#pragma comment(linker, "/STACK:265000000")

#define ff first
#define ss second
#define forn(i_, s_t, f_i) for (int i_ = s_t; i_ < f_i;i_++)

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

const ll INF = 1000 * 1000 * (1ll) * 1000 * 1000 * (1ll) * 1000 * 1000;
const int VERT = 710;
ll dst[VERT][VERT];

int main() {
	freopen("sum.in", "r", stdin);
	freopen("sum.out", "w", stdout);
	int n = VERT - 1;

	forn(i, 0, n) {
		forn(j, 0, n) {
			dst[i][j] = i + j;
		}
		dst[i][i] = INF;
	}
	ll a, b;
	cin >> a >> b;
	dst[0][1] = a;
	dst[1][2] = b;
 
	forn(k, 0, n) {
		forn(i, 0, n) {
			forn(j, 0, n) {
				if (i != k && j != k && dst[i][k] + dst[k][j] < dst[i][j]) {
					dst[i][j] = dst[i][k] + dst[k][j];
				}
			}
		}
	}
	
	printf("%d\n", dst[0][2]);
	

	return 0;
}