#include <bits/stdc++.h>
using namespace std;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)

template <typename T>
inline ostream &operator << (ostream &out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << '\n';
    return out;
}

vector <int> arr;
vector <int> prefix_sum;

string s;

bool solve (int index, int last) {
    //DB(index); DB(last);
    if(index == 0)
        return true;
    if(index == 1) {
        return (last > arr[0]);
    }

    if(last > arr[index - 1]) {
        return (solve(index - 2, last + arr[index - 1] + arr[index - 2]));
    }
    return (solve(index - 2, arr[index - 2]) && prefix_sum[index - 2] > arr[index - 1]);
}

void make_arr () {
    arr.clear();
    prefix_sum.clear();
    for(int i = 0;i < sz(s); ++i) {
        int j = i;
        while(j < sz(s) - 1 && s[j + 1] == s[j])
            j++;
        arr.push_back(j - i + 1);
        i = j;
    }
    prefix_sum.resize(sz(arr));
    prefix_sum[0] = arr[0];
    for(int i = 1;i < sz(arr); ++i) {
        prefix_sum[i] = prefix_sum[i - 1] + arr[i];
    }
}

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    int Q; cin >> Q;

    string t;
    For(q, 1, Q) {
        cin >> s >> t;
        make_arr();
        bool ans;
        if(s[sz(s) - 1] == '+') {
            int index = sz(arr) - 1;
            ans = solve(index, arr[index]);
        }
        else {
            arr.push_back(0);
            int index = sz(arr) - 1;
            ans = solve(index, arr[index]);
        }

        if(ans)
            cout << "Yes";
        else
            cout << "No";
        cout << '\n';
    }
    return 0;
}
