#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)5e4 + 7;

char ans[dd], cur[4];

bool ok(int l, int r) {
	printf("? %d %d\n", l + 1, r + 1);
	fflush(stdout);
	scanf("%s", cur);
	return cur[0] == 'Y';
}

int solve() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n - 1;) {
		int l = i, r = i + 1;
		while (l >= 0 && r < n && ok(l, r))
			--l, ++r;
		++l, --r;
		if (l < r) {
			for (int j = l; j <= i; ++j)
				ans[j] = '(';
			for (int j = i + 1; j <= r; ++j)
				ans[j] = ')';
			if (l - 1 >= 0 && ans[l - 1] != ')') ans[l - 1] = '(';
			if (r + 1 < n) ans[r + 1] = ')';
		}
		i = r + 1;
	}

	printf("! %s\n", ans);
	fflush(stdout);
	return 0;
}