#define _CRT_SECURE_NO_WARNINGS

#include<vector>
#include<string>
#include<iostream>
#include<queue>

using namespace std;

#define X first
#define Y second

const int MAXN = 1000 + 100, INF = 1000000000;
int n, m, s, a, b, c, to, v;
vector< pair<int, int> > g[MAXN];
pair<int, int> d[MAXN];
bool used[MAXN];

void dei()
{
	priority_queue< pair<int, int> > q;
	q.push( {0, 0} );
	for (int i = 0; i < n; i++)
	{
		d[i].X = INF;
	}
	d[0].X = 0;
	d[0].Y = 0;
	while (q.size())
	{
		v = q.top().Y;
		q.pop();
		if (used[v])
			continue;
		used[v] = true;
		for (int i = 0; i < g[v].size(); i++)
		{
			to = g[v][i].X;
			if ((d[to].X > d[v].X + g[v][i].Y)
				|| ((d[to].X == d[v].X + g[v][i].Y)
					&& d[to].Y < d[v].Y + g[v][i].Y * g[v][i].Y))
			{
				d[to].X = d[v].X + g[v][i].Y;
				d[to].Y = d[v].Y + g[v][i].Y * g[v][i].Y;
				q.push({ -d[to].X, to });
			}
		}
	}
	cout << d[n - 1].X << " " << d[n - 1].Y;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
#endif
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		cin >> s >> a >> c >> b;
		a--;
		b--;
		g[a].push_back({ b, c });
	}
	dei();
	return 0;
}