#include <bits/stdc++.h>

#define X first
#define Y second
#define pb push_back
#define REP(i, a, b) for (int  i = (a); i <= (b); ++i)
#define sz(v) int((v).size())
#define all(v) (v).begin(), (v).end()

using namespace std;

typedef long long ll;

string s;

struct pt
{
    ll x, y;
    pt (ll x, ll y) : x(x), y(y) {}
    pt () {}
} data[100];

pt operator - (pt a, pt b)
{
    return pt(a.x - b.x, a.y - b.y);
}

ll operator ^ (pt a, pt b)
{
    return a.x*b.y - a.y*b.x;
}

void ask(int i, int j, int k)
{
    cout << "? 3 " << i << ' ' << j << ' ' << k << endl;
}

bool get()
{
    cin >> s;
    return s[0] == 'Y';
}

int n;

bool angle(pt v1, pt v2, pt x)
{
    return (v1 ^ x)*(v2 ^ x) < 0;
}

bool check(int i, int j, int k, int t)
{
    bool res = true;
    res &= angle(data[j] - data[i], data[k] - data[i], data[t] - data[i]);
    res &= angle(data[i] - data[j], data[k] - data[j], data[t] - data[j]);
    res &= angle(data[i] - data[k], data[j] - data[k], data[t] - data[k]);
    return res;
}

void solve()
{
    REP (i, 0, n - 1)
        REP (j, 0, n - 1)
            REP (k, 0, n - 1)
            {
                ask(i + 1, j + 1, k + 1);
                if (i == j || i == k) continue;
                if (j == k) continue;

                bool ans = get();
                if (!ans) continue;

                bool ok = true;
                REP (t, 0, n - 1)
                {
                    if (t == i || t == j || t == k)
                        continue;

                    if (check(i, j, k, t))
                    {
                        ok = false;
                        break;
                    }
                }

                if (ok)
                {
                    cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                    return;
                }
            }
    assert(true);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n;
    REP (i, 0, n - 1)
        cin >> data[i].x >> data[i].y;

    int q;
    cin >> q;

    REP (i, 0, q - 1)
    {
        solve();
    }
    return 0;
}
