#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n;
vector<pll> vec;

bool cw(int a, int b, int c) {
    ll ank = vec[a].first * (vec[b].second - vec[c].second) +
             vec[b].first * (vec[c].second - vec[a].second) +
             vec[c].first * (vec[a].second - vec[b].second);
    return ank < 0;
}

bool ccw(int a, int b, int c) {
    ll ank = vec[a].first * (vec[b].second - vec[c].second) +
             vec[b].first * (vec[c].second - vec[a].second) +
             vec[c].first * (vec[a].second - vec[b].second);
    return ank > 0;
}

vector<pii> convex_hull(vector<pii> vec) {

}

ll sqr(int a, int b, int c) {
    ll ank = vec[a].first * (vec[b].second - vec[c].second) +
             vec[b].first * (vec[c].second - vec[a].second) +
             vec[c].first * (vec[a].second - vec[b].second);
    return abs(ank);
}

bool correct(int a, int b, int c) {
    ll sq = sqr(a, b, c);
    for (int i = 0; i < n; i++) {
        if (i == a || i == b || i == c)
            continue;

        ll tmp = sq;

        tmp -= sqr(a, b, i);
        if (tmp < 0)
            continue;

        tmp -= sqr(a, i, c);
        if (tmp < 0)
            continue;

        tmp -= sqr(i, b, c);
        if (tmp < 0)
            continue;

        if (tmp == 0)
            return false;
    }

    return true;
}

bool can(int a, int b, int c) {
    cout << "? 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

void ans(int a, int b, int c) {
    cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
}

int main() {
    cin >> n;
    vec.resize(n);
    for (int i = 0; i < n; i++)
        cin >> vec[i].first >> vec[i].second;
    int q; cin >> q;

    vector<int> as, bs, cs;
    vector<int> range;

    for (int a = 0; a < n; a++) {
        for (int b = a + 1; b < n; b++) {
            for (int c = b + 1; c < n; c++) {
                if (correct(a, b, c)) {
                    as.push_back(a);
                    bs.push_back(b);
                    cs.push_back(c);
                    range.push_back(range.size());
                }
            }
        }
    }
    srand(228);
    random_shuffle(range.begin(), range.end());

    for (int i = 0; i < q; i++) {
        bool cc = false;
        for (auto it : range) {
            if (can(as[it], bs[it], cs[it])) {
                ans(as[it], bs[it], cs[it]);
                break;
            }
        }
    }
}