#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 1e6 + 23;
vector<int> a;
vector<bool> type;
int solve() {
	int n;
	cin >> n;
	string s, t;
	for (int tt = 0; tt < n; tt++) {
		cin >> s >> t;
		bool fl = 1;
		for (int i = 0; i < (int)s.size();) {
			if (s[i] == t[i]) { 
				i++;
				continue; 
			}

			int cnt = 1, beg = i;
			int prev = 0, forw = 0;

			while (i + 1 < (int)s.size() && s[i] == s[i + 1]) { cnt++, i++; }


			if (beg - 1 >= 0 && s[beg - 1] != s[beg]) {
				prev = 1;
				for (int j = beg - 1; j - 1 >= 0; j--) {
					if (s[j] == s[j - 1]) prev++;
					else { break; }
				}
			}

			if (i + 1 < s.size() && s[i + 1] != s[i]) {
				forw = 1;
				for (int j = i + 1; j + 1 < s.size(); j++) {
					if (s[j] == s[j + 1]) forw++;
					else break;
				}
			}
			s[i] = t[i];
			i = beg;
			while (i + 1 < (int)s.size() && s[i] != s[i + 1]) { cnt++, i++; s[i] = t[beg]; }
			if (cnt >= forw && prev <= cnt) {
				fl = 0;
				cout << "No\n"; break;
			}
		}
		if (fl) cout << "Yes\n";
	}
	return 0;
}