#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
typedef pair <long long, long long> par;

bool operator < (par a, par b) {
	return ((a.first * b.second - a.second * b.first) > 0);
}

struct pnt {
	par pos; int num;
	pnt() {}
	pnt(par pos, int num) : pos(pos), num(num) {}
	bool operator <(pnt const& o) const {
		return pos < o.pos;
	}
};

pnt r[65];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		r[i] = pnt({ x, y }, i + 1);
	}
	sort(r, r + n);
	int q;
	cin >> q;
	for (int t = 0; t < q; t++) {
		bool got = false;
		for (int i = 0; i < n - 2; i++) {
			for (int j = i + 1; j < n - 1; j++) {
				int k = j + 1;
				cout << "? 3 " << r[i].num << " " << r[j].num << " " << r[k].num << endl;
				string ans;
				cin >> ans;
				if (ans == "Yes") {
					got = true;
					cout << "! 3 " << r[i].num << " " << r[j].num << " " << r[k].num << endl;
					break;
				}
			}
			if (got) break;
		}
	}
}