#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <cmath>
#include <queue>
#include <map>

using namespace std;
typedef long long ll;
typedef pair <long long, long long> par;
bool operator <(par a, par b) {
	return a.first < b.first || (a.first == b.first && a.second > b.second);
}

vector <par> g[1010];
par d[1010];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int k;
		cin >> k;
		int v;
		cin >> v;
		for (int j = 0; j < k; j++) {
			int t, w;
			cin >> t >> w;
			g[v].push_back({ w, t });
			v = w;
		}
	}
	queue <pair <ll, par> > q;
	q.push({ 1, {0, 0} });
	d[1] = { 0, 0 };
	for (int i = 2; i <= n; i++) d[i] = { 1e18, 1e18 };
	while (!q.empty()) {
		pair <ll, par> cur = q.front();
		q.pop();
		if (cur.first == n) {
			d[cur.first] = min(d[cur.first], cur.second);
			continue;
		}
		for (par to : g[cur.first]) {
			pair <ll, par> nw = { to.first, {cur.second.first + to.second, cur.second.second + to.second * to.second } };
			if (d[to.first] > nw.second) {
				d[to.first] = nw.second;
				q.push(nw);
			}
		}
	}
	cout << d[n].first << " " << d[n].second;
	return 0;
}