#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;
typedef pair <int, int> par;

vector <pair <int, char> > form(string & s) {
	vector <pair <int, char> > res;
	res.clear();
	pair <int, char> cur = { 0, s[0] };
	for (int i = 0; i < s.size(); i++) {
		if (cur.second == s[i]) cur.first++; else {
			res.push_back(cur);
			cur.first = 1;
			if (cur.second == '-') cur.second = '+'; else cur.second = '-';
		}
	}
	if (cur.first) res.push_back(cur);
	return res;
}

vector <pair <int, bool> > mv;
int lft;
bool was[200100];

void coll(int id) {
	int ns = mv[id].first;
	if (id) ns += mv[id - 1].first;
	if (id < mv.size() - 1) ns += mv[id + 1].first;
	if (id) {
		mv[id - 1].first = ns;
		was[id - 1] = false;
	}
	mv[id].first = ns;
	if (id < mv.size() - 1) {
		mv[id + 1].first = ns;
		was[id + 1] = false;
	}
}

void rel(par cur) {
	coll(cur.second);
	was[cur.second] = true;
	if (cur.second && mv[cur.second - 1].second && mv[cur.second - 1].first < cur.first) {
		mv[cur.second - 1].second = false;
		lft--;
		coll(cur.second - 1);
		if (cur.second > 1) rel({ mv[cur.second - 2].first, cur.second - 2 });
	}
	if (cur.second && !was[cur.second - 1]) rel({ mv[cur.second - 1].first, cur.second - 1 });
	if (cur.second < mv.size() - 1 && mv[cur.second + 1].second && mv[cur.second + 1].first < cur.first) {
		mv[cur.second + 1].second = false;
		lft--;
		coll(cur.second + 1);
		if (cur.second < mv.size() - 2) rel({ mv[cur.second + 2].first, cur.second + 2 });
	}
	if (cur.second < mv.size() - 1 && !was[cur.second + 1]) rel({ mv[cur.second + 1].first, cur.second + 1 });
}

int main() {
	//freopen("input.txt", "r", stdin);
	ios::sync_with_stdio(false);
	int q;
	cin >> q;
	for (int t = 0; t < q; t++) {
		string s, f;
		cin >> s >> f;
		vector <pair <int, char> > ts;
		ts = form(s);
		int i = 0;
		bool un = false;
		for (pair <int, char> cur : ts) {
			char prev = f[i++];
			for (int count = 1; count < cur.first; count++) {
				if (f[i++] != prev) {
					un = true;
					break;
				}
			}
			if (un) break;
		}
		if (un) {
			cout << "No\n";
		}
		else {
			lft = 0;
			i = 0;
			mv.clear();
			for (pair <int, char> cur : ts) {
				pair <int, bool> tp;
				tp.first = cur.first;
				tp.second = (f[i] != cur.second);
				i += cur.first;
				lft += (tp.second);
				mv.push_back(tp);
			}
			vector <par> vs;

			for (int j = 0; j < mv.size(); j++) {
				vs.push_back({ mv[j].first, j });
				was[j] = false;
			}
			sort(vs.begin(), vs.end());
			reverse(vs.begin(), vs.end());
			for (par cur : vs) {
				if (!was[cur.second] && !mv[cur.second].second) rel(cur);
			}
			if (lft) cout << "No\n"; else cout << "Yes\n";
		}
	}
	return 0;
}