#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <utility>
#include <iterator>
#include <sstream>
#include <fstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//SAY HELLO TO MY LIL' FRIEND

struct point {
	ll x, y;

	point() {}
	point(ll x, ll y) : x(x), y(y) {}
};

struct vt {
	ll x, y;
	
	vt() {}
	vt(ll x, ll y) : x(x), y(y) {}
	vt(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}

	ll operator^(vt v) {
		return x * v.y - v.x * y;
	}
};

ll area(point a, point b, point c) {
	return abs(vt(a, b) ^ vt(a, c));
}

bool inside(point p, point a, point b, point c) {
	return (area(a, b, c) == area(p, a, b) + area(p, b, c) + area(p, c, a));
}

bool ask(int a, int b, int c) {
	cout << "? 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;

	string res;
	cin >> res;
	
	return res[0] == 'Y';
}

void say(int a, int b, int c) {
	cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	iostream::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	vector<point> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
	}

	vector<pair<pii, int> > t;
	bool flag;
	for (int a = 0; a < n; a++) {
		for (int b = a + 1; b < n; b++) {
			for (int c = b + 1; c < n; c++) {
				flag = true;

				for (int i = 0; i < n; i++) {
					if (i == a || i == b || i == c)
						continue;

					if (inside(p[i], p[a], p[b], p[c])) {
						flag = false;
						break;
					}
				}

				if (flag) {
					t.push_back(mp(mp(a, b), c));
				}
			}
		}
	}

	int q;
	cin >> q;
	for (int x = 0; x < q; x++) {
		for (int i = 0; i < t.size(); i++) {
			int a = t[i].X.X, b = t[i].X.Y, c = t[i].Y;

			if (ask(a, b, c)) {
				say(a, b, c);
				break;
			}
		}
	}

	return 0;
}