#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <algorithm>
#include <set>
#include <map>
#include <time.h>
#include <assert.h>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 1e6 + 10;
const int INF = 1e9;

vector<pair<int, bool>> d[30];
int t[5][30], a[SZ];

int gettype(int lv, int l, int r) {
	int taken = 0, tmask = 0;
	auto e = upper_bound(d[lv].begin(), d[lv].end(), make_pair(l, true));
	e--;
	while (e != d[lv].end() && e->first < r) {
		tmask += (1 << taken) * int(e->second);
		taken++;
		e++;
	}
	if (taken == 1) {
		if (tmask == 0)
			return 2;
		else
			return 3;
	}
	else if (taken == 2) {
		if (tmask == 2)
			return 0;
		else
			return 1;
	}
	else
		return 4;
}

void build(int lv, int l, int r) {
	if (lv == -1)
		return;
	auto e = upper_bound(d[lv].begin(), d[lv].end(), make_pair(l, true));
	e--;
	while (e != d[lv].end() && e->first < r) {
		auto f = e;
		f++;
		build(lv - 1, max(l, e->first), (f == d[lv].end() ? r : min(r, f->first)));
		e = f;
	}
	t[gettype(lv, l, r)][lv]++;
}

int getans() {
	int ans = 0;
	for (int i = 29; i >= 0; i--) {
		if (t[0][i] && t[1][i])
			return -1;
		if (t[4][i])
			return -1;
		if (t[1][i])
			ans += (1 << i);
	}
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);

	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int q;
	cin >> q;

	for (int i = 0; i < 30; i++) {
		d[i].clear();
		d[i].push_back({ 0, ((a[0] >> i) & 1) });
		for (int j = 1; j < n; j++)
			if (((a[j] >> i) & 1) != d[i].rbegin()->second)
				d[i].push_back({ j, ((a[j] >> i) & 1) });
	}
	build(29, 0, n);

	cout << getans() << "\n";

	while (q--) {
		int x, y;
		cin >> x >> y;
		x--;
		a[x] = y;
		for (int i = 0; i < 30; i++) {
			for (int j = 0; j < 5; j++)
				t[j][i] = 0;
			d[i].clear();
			d[i].push_back({ 0, ((a[0] >> i) & 1) });
			for (int j = 1; j < n; j++)
				if (((a[j] >> i) & 1) != d[i].rbegin()->second)
					d[i].push_back({ j, ((a[j] >> i) & 1) });
		}
		build(29, 0, n);
		
		cout << getans() << "\n";
		/*
		int l = 0, r = n;
		for (int i = 29; i >= 0; i--) {
		t[gettype(i, l, r)][i]--;
		auto e = d[i].upper_bound({ x, 1 });
		e--;
		auto f = e;
		f++;
		int ol = x, or = x + 1;
		if ((f == d[i].end() && or != n) || f->first != or) {
		d[i].insert({ or , e->second });
		f--;
		}
		bool bt = ((y >> i) & 1);
		if (bt == e->second) {
		ol = e->first;
		d[i].erase(e);
		}
		if (f != d[i].end() && bt == f->second) {
		auto g = f;
		g++;
		or = (g == d[i].end() ? n : g->first);
		d[i].erase(f);
		}
		d[i].insert({ ol, bt });

		t[gettype(i, l, r)][i]++;
		l = max(ol, l);
		r = min(or, r);
		}

		cout << getans() << "\n";
		*/
	}

	return 0;
}