#define make_pair mp
#define push_back pb
#define pop_back pob
#define first X
#define second Y
#define _p(x, y) pair<x, y>

#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <queue>
#include <climits>

using namespace std;

typedef long long i64;
const int INF = 1000000007;
const i64 LINF = 1000000000000000007;
#define endl '\n'

int check(vector < vector < short > > &a, int l, int r, int d = 0) {

	if (r - l <= 1 || d > 29)
		return 0;

	int ans = 0;
	bool met = false;
	int m = -1;
	int j = 29 - d;
	for (int i = l; i < r; i++) {
		if (i - l) {
			if (a[i][j] != a[i - 1][j]) {

				if (met)
					return -1;

				met = true;
				if (a[i][j] == 0 && a[i - 1][j] == 1) {
					ans |= (1 << j);
					m = i;
				}
				else {
					m = i;
				}
			}
		}
	}

	if (m == -1) {
		return check(a, l, r, d + 1);
	}

	int r1 = check(a, l, m, d + 1);
	int r2 = check(a, m, r, d + 1);

	if (r1 == -1 || r2 == -1)
		return -1;

	int c1, c2;
	if (r1 != r2) {
		for (int i = 0; i < 30; i++) {

			c1 = (r1 >> i) & 1;
			c2 = (r2 >> i) & 1;

			if (c1 != c2) {
				if (c1 == 0 && (m - l) > 1 || c2 == 0 && (r - m) > 1)
					return -1;
			}

		}
	}

	return ans | (r1 | r2);
}
//
//int check(vector < vector < short > > &a) {
//	int n = a.size();
//	vector < int > id(n, 0);
//	int cl = 0;
//	int ans = 0;
//	bool met = false;
//	for (int j = 29; j >= 0; j--) {
//		for (int i = 0; i < n; i++) {
//
//			if (!i || id[i - 1] != id[i])
//				met = false;
//
//			if (i && a[i][j] != a[i - 1][j] && id[i - 1] == id[i]) {
//				if (a[i][j] == 1 && a[i - 1][j] == 0)
//					met = true;
//				if (a[i][j] == 0 && a[i - 1][j] == 1) {
//					if (met)
//						return -1;
//					else
//						ans |= (1 << j);
//				}
//				cl++;
//				id[i] = cl;
//			}
//			else {
//				if (i) {
//					id[i] = id[i - 1];
//				}
//			}
//		}
//	}
//
//	return ans;
//}

int main() {

#ifdef _DEBUG
	freopen("B.txt", "r", stdin);
#endif

	int n;
	scanf("%d", &n);

	vector < vector < short > > a(n, vector < short >(30));

	int c, buff;
	for (int i = 0; i < n; i++) {
		scanf("%d", &buff);
		c = 0;
		while (buff) {
			a[i][c] = buff % 2;
			c++;
			buff /= 2;
		}
	}

	printf("%d\n", check(a, 0, n));

	int q;
	scanf("%d", &q);

	int pos, to;
	for (int i = 0; i < q; i++) {
		scanf("%d%d", &pos, &to);
		pos--;
		c = 0;
		a[pos].assign(30, 0);
		while (to) {
			a[pos][c] = to % 2;
			to /= 2;
			c++;
		}
		printf("%d\n", check(a, 0, n));
	}

	return 0;
}