#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define vec vector
#define pb push_back

#define mp make_pair

#define endl '\n'

#define all(x) (x).begin(), (x).end()

struct ptr {
    ll x, y;
    int num;
};

ptr operator -(const ptr &a, const ptr &b) {
    return ptr{a.x - b.x, a.y - b.y, -1};
}

ll operator*(const ptr &a, const ptr &b) {
    return a.x*b.y - a.y*b.x;
}

const int N = 5555;

ptr mas[N];

int db;

vec<int> vo(const vec<int> &t) {
    vec<int> cur;
    int n = (int)t.size();
    cur.pb(t.back());
    for(int i = 0; i < n; i++) {
        while(cur.size() >= 2 && (mas[cur.back()] - mas[cur[cur.size() - 2]])*(mas[t[i]] - mas[cur.back()]) < 0) cur.pop_back();
        cur.pb(t[i]);
    }
    cur.pop_back();
    return cur;
}
bool check(const vec<int> &t) {
    vec<int> cur = vo(t);
    cout << "? " << cur.size() << ' ';
    for(int i = 0; i < cur.size(); i++) cout << mas[cur[i]].num << ' ';
    cout << endl;
    cout.flush();
    string s;
    cin >> s;
    return s == "Yes";
}

bool cmp(const ptr &a, const ptr &b) {
    if(a.x != b.x) return a.x < b.x;
    return a.y < b.y;
}

ptr zr;

bool cmp2(int a, int b) {
    return (mas[a] - zr)*(mas[b]- zr) > 0;
}

void setAns( vec<int> ans, int g) {
    assert(ans.size() == 3 && ans[0] != ans[1] && ans[1] != ans[2] && ans[2] != ans[0]);
    for(int i = 0; i < db; i++) {
        if(i == ans[0] || i == ans[1] || i == ans[2]) continue;
        bool f = 0;
        for(int j = 0; j < 3; j++) {
            f |= (mas[ans[(j+1)%3]] - mas[ans[j]])*(mas[i] - mas[ans[j]]) <= 0;
        }
        assert(f);
    }
    cout << "? 3 ";
    for(int i = 0; i < ans.size(); i++) {
        cout << mas[ans[i]].num << ' ';
    }
    cout << endl;
    cout.flush();
    string s;
    cin >> s;
    assert(g || s == "Yes");
    cout << "! " << ans.size() << ' ';
    for(int i = 0; i < ans.size(); i++) {
        cout << mas[ans[i]].num << ' ';
    }
    cout << endl;
    cout.flush();
}

int nx(int a, int n) {
    a++;
    if(a >= n) a -= n;
    return a;
}

int pr(int a, int n) {
    a--;
    if(a < 0) a += n;
    return a;
}

int md(int l, int r, int n) {
    if(l > r) r += n;
    int m = (l+r+1)/2;
    while(m >= n) m -= n;
    return m;
}

int md2(int l, int r, int n) {
    if(l > r) r += n;
    int m = (l+r)/2;
    while(m >= n) m -= n;
    return m;
}

bool mcheck(const vec<int> &cnt) {
    cout << "? " << cnt.size() << ' ';
    for(int i = 0; i < cnt.size(); i++) cout << mas[cnt[i]].num << ' ';
    cout << endl;
    cout.flush();
    string s;
    cin >> s;
    return s == "Yes";
}

int main()
{
    #ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    #endif // LOCAL
    int n;
    cin >> n;
    db = n;
    for(int i = 0; i < n; i++) {
        cin >> mas[i].x >> mas[i].y;
        mas[i].num = i+1;
    }
    //sort(mas, mas + n, cmp);
    for(int i = 1; i < n; i++) if(cmp(mas[i], mas[0])) swap(mas[i], mas[0]);
    vec<int> per(n-1);
    for(int i = 1; i < n; i++) {
        per[i-1] = i;
    }
    zr = mas[0];
    sort(all(per), cmp2);
    int q;
    cin >> q;
    for(int fff = 0; fff < q; fff++) {
        vec<int> cur = per;
        while(cur.size() >= 3) {
            //sort(all(cur), cmp2);
            vec<int> t;
            vec<int> t1, t2;
            t1.pb(0);
            t2.pb(0);
            for(int i = 0; i <= cur.size()/2; i++) t1.pb(cur[i]);
            if(check(t1)) {
                for(int i = 1; i < t1.size(); i++) cur[i-1] = t1[i];
                cur.resize(t1.size() - 1);
            } else {
                //t.resize(1);
                for(int i = cur.size()/2; i < cur.size(); i++) t2.pb(cur[i]);
                if(check(t2)) {
                    for(int i = 1; i < t2.size(); i++) cur[i-1] = t2[i];
                    cur.resize(t2.size() - 1);
                } else {
                    int a1, a2, a3;
                    a3 = cur[cur.size()/2];
                    t1 = vo(t1);
                    t2 = vo(t2);
                    cur.insert(cur.begin(), 0); ///TODO
                    cur = vo(cur);
                    set<int> usd;
                    for(auto i : cur) usd.insert(i);
                    int p1 = t1.size() - 1;
                    while(!usd.count(t1[p1])) p1 = pr(p1, t1.size());
                    int p2 = 2;
                    while(!usd.count(t2[p2])) p2 = nx(p2, t2.size());
                    int l = p1, r = t1.size() - 1;
                    while(l != r) {
                        int m = md(l, r, t1.size());
                        if(mcheck({a3, t1[m], t2[p2]})) {
                            l = m;
                        } else r = pr(m, t1.size());
                    }
                    p1 = l;
                    l = 3;
                    r = p2;
                    while(l != r) {
                        int m = md2(l, r, t2.size());
                        if(mcheck({a3, t1[p1], t2[m]})) {
                            r = m;
                        } else l = nx(m, t2.size());
                    }
                    cur.clear();
                    cur.pb(t1[nx(p1, t1.size())]);
                    cur.pb(t1[p1]);
                    cur.pb(t2[p2]);
                    if(!mcheck(cur)) {
                        exit(1);
                        cur[1] = t2[pr(p2, t2.size())];
                    }
                    break;
                }
            }

        }
        //cout << "! 3 ";
        int g = 0;
        if(cur.size() == 2) {
            cur.pb(0);
            g = 1;
        }
        setAns(cur, g);
    }
    return 0;
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
*/
