#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;

int main()
{
	ll n;
	cin >> n;

	vector<char> v(n + 1);
	v[1] = '(';

	stack<int> op;
	op.push(1);

	for (int i = 2; i <= n; ++i)
	{
		if (v[i - 1] == '(')
		{
			cout << "? " << i - 1 << " " << i << endl;
		}
		else
		{
			cout << "? " << op.top() << " " << i << endl;
		}

		string ans;
		cin >> ans;

		if (ans == "Yes")
		{
			op.pop();
			v[i] = ')';

			if (op.size() == 0 && i + 1 <= n)
			{
				v[i + 1] = '(';
				op.push(i + 1);
				++i;
			}
		}
		else
		{
			op.push(i);
			v[i] = '(';
		}
	}

	cout << "! ";
	for (int i = 1; i <= n; ++i)
	{
		cout << v[i];
	}

	cout << endl;

	return 0;
}

/*

*/