#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (auto & i : arr)
        in >> i;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (auto i : arr)
        out << i << " ";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

const int INF = 1000000000000000000;
vector <vector <int> > g;
int ans_t = INF, ans_kach = -1;


void brootforce(set <int> s, int pr, int time = 0, int kach = 0, int dp = 0)
{
    if (dp > 10)
        return;
    if (s.size() == 0)
        return;
    vector <int> now;
    for (auto x : s)
        now.push_back(x);
    for (auto x : arr)
    {
        if (x == (int)g.size() - 1)
        {
            if (time + g[pr][x] < ans_t)
            {
                ans_t = time + g[pr][x];
                ans_kach = kach + g[pr][x] * g[pr][x];
            }
            else if (time + g[pr][x] == ans_t)
            {
                ans_kach = max(ans_kach, kach + g[pr][x] * g[pr][x]);
            }
        }
        else
        {
            s.erase(x);
            brootforce(s, x, time + g[pr][x], kach + g[pr][x] * g[pr][x], dp + 1);
            s.insert(x);
        }
    }
}

signed main()
{
    int n, m;
    cin >> n >> m;
    g.resize(n, vector <int> (n, INF));
    for (int itt = 0; itt < m; ++itt)
    {
        int s;
        cin >> s;
        int u, v, w;
        cin >> v >> w >> u;
        --v;
        --u;
        g[v][u] = min(g[v][u], w);
        g[u][v] = g[v][u];
    }
    set <int> s;
    for (int i = 1; i < n; ++i)
        s.insert(i);
    brootforce(s, 0);
    cout << ans_t << " " << ans_kach << endl;
    return 0;
}
