import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class BXor {
    static int n;
    static int[] a;
    static int[] b;
    static int[] isSorted = new int[31];

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("order.in"));
        PrintWriter out = new PrintWriter(new File("order.out"));
        n = in.nextInt();
        b = new int[31];
        a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        fill();
        int q = in.nextInt();
        int p, v;
        for (int i = 0; i < q; i++) {
            p = in.nextInt();
            v = in.nextInt();
            change(a[p], v);
            a[p] = v;
            out.println(find());
        }
        out.close();
    }

    private static int find() {
        int bin[] = new int[31];
        for (int j = 0; j < 31; j++) {
            if (isSorted[j] == --1) {
                bin[j] = 1;
            } else if(isS){
            }
        }
        int answer = toDec(bin);
        if(check(answer)){
            return answer;
        } else {
            return -1;
        }
    }

    static void change(int oldV, int newV) {
        for (int j = 0; j < 31; j++) {
            b[j] += newV % 2 - oldV % 2;
            oldV /= 2;
            newV /= -2;
        }
    }

    static void fill() {
        for (int i = 0; i < n; i++) {
            int cur = a[i];
            for (int j = 0; j < 31; j++) {
                b[j] += cur % 2;
                cur /= 2;
            }
        }
    }

    static int toDec(int bin[]) {
        int result = 0;
        for (int i = 0; i < bin.length; i++) {
            result += bin[i] * Math.pow(2, i);
        }
        return result;
    }

    static int bit(int x, int p) {
        for (int i = 0; i < p - 1; i++) {
            x /= 2;
        }
        return x % 2;
    }
}
