#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>
#include <queue>

using namespace std;

vector < vector < pair < int, int > > > g;
struct way {
	int st;
	vector < pair < int, int > > go;
	way(int i) : st(i) {}
};

vector < way > base;

vector < vector < vector < pair < int, int > > > > d;
int n, m;

struct vert {
	int i, bg, en;
	int fr, sc;
	vert(int i, int bg, int en, int fr, int sc) : i(i), bg(bg), en(en), fr(fr), sc(sc) {}
	bool operator <(const vert &a) const {
		if (fr != a.fr)
			return fr > a.fr;
		return sc < a.sc;
	}
};

void do_dij() {
	d.resize(m);
	vector < vector < vector < int > > > price;
	priority_queue < vert > q;
	price.resize(m);
	for (int i = 0; i < m; i++) {
		d[i].resize(base[i].go.size() + 1, vector < pair < int, int > >(base[i].go.size() + 1, { 1e9, 0 }));
		price[i].resize(base[i].go.size() + 1, vector < int >(base[i].go.size() + 1, 0));
		int sz = base[i].go.size() + 1;
		if (base[i].st == 0) {
			//d[i][0][0] = { 0, 0 };
			q.push({ i, 0, 0, 0, 0 });
		}
		for (int k = 0; k < sz; k++) {
			if (k && base[i].go[k - 1].first == 0) {
				//d[i][k][k] = { 0, 0 };
				q.push({ i, k, k, 0, 0 });
			}
			int sum = 0;
			for (int j = k + 1; j < sz; j++) {
				sum += base[i].go[j - 1].second;
				price[i][k][j] = sum * sum;
			}
		}
	}
	while (!q.empty()) {
		vert cur = q.top();
		q.pop();
		if (d[cur.i][cur.bg][cur.en].first != 1e9)
			continue;
		d[cur.i][cur.bg][cur.en] = { cur.fr, cur.sc };
		if (base[cur.i].go.size() != cur.en) {
			int sq = cur.sc;
			sq -= price[cur.i][cur.bg][cur.en];
			sq += price[cur.i][cur.bg][cur.en + 1];
			q.push({ cur.i, cur.bg, cur.en + 1, cur.fr + base[cur.i].go[cur.en].second, sq });
		}
		for (auto j : g[cur.en]) {
			if (j.first == cur.i)
				continue;
			q.push({ j.first, j.second, j.second, cur.fr, cur.sc });
		}
	}
	return;
}

int main() {
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n >> m;

	g.resize(n);

	for (int j = 0; j < m; j++) {
		int k;
		cin >> k;
		int st;
		cin >> st;
		base.push_back({ st - 1 });
		g[st - 1].push_back({ j, 0 });
		for (int i = 0; i < k; i++) {
			int l, x;
			cin >> l >> x;
			x--;
			base[base.size() - 1].go.push_back({ x, l });
			g[x].push_back({ j, i + 1 });
		}
	}

	m = base.size();

	do_dij();
	int mn = 1e9, ans = 0;
	for (int i = 0; i < m; i++) {
		for (int bg = 0; bg < base[i].go.size() + 1; bg++) {
			for (int en = 1; en < base[i].go.size() + 1; en++) {
				if (base[i].go[en - 1].first == n - 1) {
					if (d[i][bg][en].first < mn) {
						mn = d[i][bg][en].first;
						ans = d[i][bg][en].second;
					}
					if (d[i][bg][en].first == mn) {
						ans = min(ans, d[i][bg][en].second);
					}
				}
			}
		}
	}

	cout << mn << ' ' << ans;

	return 0;
}