#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void operator delete (void *) {}
const long long MX = 1e4;
long long a[MX], b[MX], in_a[MX], in_b[MX], pa[MX], pb[MX], ra[MX], rb[MX];

long long get(long long *pr, long long l, long long r) {
	return pr[r] - (l ? pr[l - 1] : 0);
}

inline void del(long long x, set < pair < long long, long long > > &cur, set < pair < long long, pair < long long, long long > > > &sum) {
	auto j = cur.upper_bound({ x, 1e9 });
	j--;
	sum.erase(sum.find({ get(pb, j->first, j->second), *j }));
	long long l = j->first, r = j->second;
	pair < long long, long long > n1 = { l, x - 1 }, n2 = { x + 1, r };
	if (n1.first <= n1.second) {
		sum.insert({ get(pb, l, x - 1), {l, x - 1} });
		cur.insert(n1);
	}
	if (n2.first <= n2.second) {
		sum.insert({ get(pb, x + 1, r), {x + 1, r} });
		cur.insert(n2);
	}
	cur.erase(j);
	return;
}

int main() {
	iostream::sync_with_stdio(0);

	long long n, m;
	cin >> n >> m;
	
	for (long long i = 0; i < MX; i++)
		in_a[i] = in_b[i] = -1;

	for (long long i = 0; i < n; i++) {
		long long cur;
		cin >> cur;
		cur--;
		a[i] = cur;
		in_a[cur] = i;
	}
	for (long long i = 0; i < n; i++) {
		long long t;
		cin >> t;
		pa[i] = (i ? pa[i - 1] : 0) + t;
	}
	for (long long i = 0; i < m; i++) {
		long long cur;
		cin >> cur;
		cur--;
		b[i] = cur;
		in_b[cur] = i;
	}
	for (long long i = 0; i < m; i++) {
		long long t;
		cin >> t;
		pb[i] = (i ? pb[i - 1] : 0) + t;
	}
	long long ans = 0;
	long long a1, a2, b1, b2;
	for (long long i = 0; i < n; i++) {
		set < pair < long long, long long > > cur;
		set < pair < long long, pair < long long, long long > > > sum;
		cur.insert({ 0, m - 1 });
		sum.insert({ pb[m - 1], {0, m - 1} });
		for (long long j = i; j < n; j++) {
			if (in_b[a[j]] != -1) {
				long long x = in_b[a[j]];
				del(x, cur, sum);
			}
			if (!sum.empty()) {
				auto k = sum.end();
				k--;
				long long x = k->first + get(pa, i, j);
				if (x > ans) {
					ans = x;
					a1 = i, a2 = j;
					b1 = k->second.first, b2 = k->second.second;
				}
			}
		}
	}

	if (pa[n - 1] > ans) {
		ans = pa[n - 1];
		a1 = 0, a2 = n - 1;
		b1 = -1, b2 = -1;
	}
	if (pb[m - 1] > ans) {
		ans = pb[m - 1];
		b1 = 0, b2 = m - 1;
		a1 = -1, a2 = -1;
	}

	cout << ans << '\n';

	cout << a1 + 1 << ' ' << a2 + 1 << ' ' << b1 + 1 << ' ' << b2 + 1;

	return 0;
}