#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;


int main()
{
	long long n, m;
	cin >> n >> m;
	vector<long long> d1(n);
	vector<long long> d2(m);
	vector<long long> p1(n);
	vector<long long> p2(m);

	long long sp1 = 0;
	long long sp2 = 0;

	for (long long i = 0; i < n; ++i)
	{
		cin >> d1[i];
	}
	for (long long i = 0; i < n; ++i)
	{
		cin >> p1[i];
		sp1 += p1[i];
	}
	for (long long i = 0; i < m; ++i)
	{
		cin >> d2[i];
	}
	for (long long i = 0; i < m; ++i)
	{
		cin >> p2[i];
		sp2 += p2[i];
	}

	long long mp = -1;
	long long ml1, ml2, mr1, mr2;

	for (long long l1 = 0; l1 < n; ++l1)
	{
		for (long long r1 = l1; r1 < n; ++r1)
		{
			for (long long l2 = 0; l2 < m; ++l2)
			{
				for (long long r2 = l2; r2 < m; ++r2)
				{
					long long total = (r1 - l1 + 1) + (r2 - l2 + 1);
					unordered_set<long long> buf;
					long long dist;
					for (long long i = l1; i <= r1; ++i)
					{
						if (buf.find(d1[i]) == buf.end())
							buf.insert(d1[i]);
						else
							break;
					}
					for (long long i = l2; i <= r2; ++i)
					{
						if (buf.find(d2[i]) == buf.end())
							buf.insert(d2[i]);
						else
							break;
					}
					dist = buf.size();
					if (dist < total)
						continue;
					long long pr = 0;
					for (long long i = l1; i <= r1; ++i)
					{
						pr += p1[i];
					}
					for (long long i = l2; i <= r2; ++i)
					{
						pr += p2[i];
					}
					if (mp < pr)
					{
						mp = pr;
						ml1 = l1;
						ml2 = l2;
						mr1 = r1;
						mr2 = r2;
					}
				}
			}
		}
	}

	if (sp1 > mp)
	{
		mp = sp1;
		ml1 = 0;
		mr1 = n - 1;
		ml2 = -1;
		mr2 = -1;
	}

	if (sp2 > mp)
	{
		mp = sp2;
		ml1 = -1;
		mr1 = -1;
		ml2 = 0;
		mr2 = m - 1;
	}

	cout << mp << endl;
	cout << ml1 + 1 << " " << mr1 + 1 << endl;
	cout << ml2 + 1 << " " << mr2 + 1 << endl;
	return 0;
}