#include <bits/stdc++.h>

using namespace std;

#define Y second
#define X first

vector<int> arr(2e5 + 1), l(2e5 + 1), r(2e5 + 1);
vector<pair<int, int>> dl(2e5 + 1, {-1, -1}), dr(2e5 + 1, {-1, -1});

pair<int, int> cross(pair<int, int> a, pair<int, int> b) {
    pair<int, int> res = {max(a.X, b.X), min(a.Y, b.Y)};
    if (res.X > res.Y) {
        return {-1, -1};
    }
    return res;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        cin >> l[i] >> r[i];
    }

    dl[0] = {0, 2e9};
    for (int i = 1; i < n; ++i) {
        if (dl[i - 1] == make_pair(-1, -1)) {
            break;
        }
        if (cross(dl[i - 1], {l[i - 1], r[i - 1]}) == make_pair(-1, -1)) {
            dl[i] = {-1, -1};
        } else {
            auto x = cross(dl[i - 1], {l[i - 1], r[i - 1]});
            if (x.X <= l[i - 1]) {
                dl[i] = {max(x.X - arr[i], 0), x.Y};
            } else {
                dl[i] = x;
            }
        }
    }

    dr[n - 1] = {0, 2e9};
    for (int i = n - 2; i >= 0; --i) {
        if (dr[i + 1] == make_pair(-1, -1)) {
            break;
        }
        if (cross(dr[i + 1], {l[i], r[i]}) == make_pair(-1, -1)) {
            dr[i] = {-1, -1};
        } else {
            auto x = cross(dr[i + 1], {l[i], r[i]});
            if (x.X <= l[i]) {
                dr[i] = {max(x.X - arr[i], 0), x.Y};
            } else {
                dr[i] = x;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << cross(dl[i], dr[i]).X << endl;
    }

    return 0;
}
