#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <cmath>
using namespace std;
typedef long long int ll;

void pause() {
#ifdef _MSC_VER
	std::system("pause");
#endif;
}

/*vector<frag> arr;
		arr.reserve(s1.size());
		vector<frag> arrr2;
		arrr2.reserve(s2.size());
		frag cur;
		cur.starrt = s1[0];
		cur.qs++;
		for (int i = 1; i < s1.size(); i++) {
			if (s1[i] != cur.starrt) {
				cur.qe++;
			}
			else if (cur.qe) {
				arr.push_back(cur);
				cur.starrt = !cur.starrt;
				cur.qs = cur.qe;
				cur.qe = 0;
			}
			else {
				cur.qs++;
			}
		}
		if (cur.qe) {
			arr.push_back(cur);
		}
		cur = frag();
		cur.starrt = s2[0];
		cur.qs++;
		for (int i = 1; i < s2.size(); i++) {
			if (s2[i] != cur.starrt) {
				cur.qe++;
			}
			else if (cur.qe) {
				arrr2.push_back(cur);
				cur.starrt = !cur.starrt;
				cur.qs = cur.qe;
				cur.qe = 0;
			}
			else {
				cur.qs++;
			}
		}
		if (cur.qe) {
			arrr2.push_back(cur);
		}


struct frag {
	bool starrt;
	int qs;
	int qe;

	frag() {
		starrt = 0;
		qs = 0;
		qe = 0;
	}
};

struct frag {
bool val;
int q;
int lid;
int rid;

frag() {
val = 0;
q = 0;
lid = 0;
rid = 0;
}

frag(bool v, int qq, int l, int r) {
val = v;
q = qq;
lid = l;
rid = r;
}
};

void change(vector<bool>& second, vector<frag>& arr, vector<int>& frags) {
int n = second.size();
for (int i = 0; i < n; i++) {
int v = frags[i];
if (arr[v].val != second[i]) {
int ls = 0;
int rs = 0;
if (arr[v].lid >= 0) {
ls = arr[arr[v].lid].q;
}
if (arr[v].rid < arr.size()) {
rs = arr[arr[v].rid].q;
}
int curs = arr[v].q;
if (ls > curs || rs > curs) {
if (arr[v].lid >= 0) {
arr[arr[v].lid].q += curs + rs;
if (arr[v].rid < arr.size()) {
arr[arr[v].lid].rid = arr[arr[v].rid].rid;
}
else {
arr[arr[v].lid].rid = arr[v].rid;
}
int j = i;
while (j < n && (frags[j] == v || frags[j] == arr[v].rid)) {
frags[j] = arr[v].lid;
j++;
}
}
else {
arr[v].val = !arr[v].val;
arr[v].q += rs;
if (arr[v].rid < arr.size()) {
arr[v].rid = arr[arr[v].rid].rid;
}
int j = i;
while (j < n && (frags[j] == v || frags[j] == arr[v].rid)) {
frags[j] = v;
j++;
}
}
}
}
}
}

bool good(string &s1, string &s2) {
vector<bool> first(s1.size());
vector<bool> second(s2.size());
for (int i = 0; i < s1.size(); i++) {
first[i] = s1[i] == '+';
}
for (int i = 0; i < s2.size(); i++) {
second[i] = s2[i] == '+';
}
int n = s1.size();
vector<frag> arr;
vector<int> frags(n);
arr.reserve(n);
arr.push_back(frag(first[0], 1, -1, 1));
frags[0] = 0;
for (int i = 1; i < n; i++) {
if (arr.back().val == first[i]) {
arr.back().q++;
}
else {
arr.push_back(frag(first[i], 1, arr.size() - 1, arr.size() + 1));
}
frags[i] = arr.size() - 1;
}
change(second, arr, frags);
reverse(second.begin(), second.end());
reverse(frags.begin(), frags.end());
change(second, arr, frags);
for (int i = 0; i < n; i++) {
int v = frags[i];
if (arr[v].val != second[i]) {
return false;
}
}
return true;
}
*/

struct frag {
	bool val;
	int q;
	int lid;
	int rid;

	frag() {
		val = 0;
		q = 0;
		lid = 0;
		rid = 0;
	}

	frag(bool v, int qq, int l, int r) {
		val = v;
		q = qq;
		lid = l;
		rid = r;
	}
};

void change(vector<bool>& second, vector<frag>& arr, vector<int>& frags) {
	int n = second.size();
	for (int i = 0; i < n; i++) {
		int v = frags[i];
		if (arr[v].val != second[i]) {
			int ls = 0;
			int rs = 0;
			if (arr[v].lid >= 0) {
				ls = arr[arr[v].lid].q;
			}
			if (arr[v].rid < arr.size()) {
				rs = arr[arr[v].rid].q;
			}
			int curs = arr[v].q;
			if (ls > curs || rs > curs) {
				if (arr[v].lid >= 0) {
					arr[arr[v].lid].q += curs + rs;
					if (arr[v].rid < arr.size()) {
						if (arr[arr[v].rid].rid < arr.size()) {
							arr[arr[arr[v].rid].rid].lid = arr[v].lid;
						}
						arr[arr[v].lid].rid = arr[arr[v].rid].rid;
					}
					else {
						arr[arr[v].lid].rid = arr[v].rid;
					}
					int j = i;
					while (j < n && (frags[j] == v || frags[j] == arr[v].rid)) {
						frags[j] = arr[v].lid;
						j++;
					}
				}
				else {
					arr[v].val = !arr[v].val;
					arr[v].q += rs;
					if (arr[v].rid < arr.size()) {
						if (arr[arr[v].rid].rid < arr.size()) {
							arr[arr[arr[v].rid].rid].lid = v;
						}
						arr[v].rid = arr[arr[v].rid].rid; 
					}
					int j = i;
					while (j < n && (frags[j] == v || frags[j] == arr[v].rid)) {
						frags[j] = v;
						j++;
					}
				}
			}
		}
	}
}

bool good(string &s1, string &s2) {
	vector<bool> first(s1.size());
	vector<bool> second(s2.size());
	for (int i = 0; i < s1.size(); i++) {
		first[i] = s1[i] == '+';
	}
	for (int i = 0; i < s2.size(); i++) {
		second[i] = s2[i] == '+';
	}
	int n = s1.size();
	vector<frag> arr;
	vector<int> frags(n);
	arr.reserve(n);
	arr.push_back(frag(first[0], 1, -1, 1));
	frags[0] = 0;
	for (int i = 1; i < n; i++) {
		if (arr.back().val == first[i]) {
			arr.back().q++;
		}
		else {
			arr.push_back(frag(first[i], 1, arr.size() - 1, arr.size() + 1));
		}
		frags[i] = arr.size() - 1;
	}
	change(second, arr, frags);
	reverse(second.begin(), second.end());
	reverse(frags.begin(), frags.end());
	change(second, arr, frags);
	reverse(second.begin(), second.end());
	reverse(frags.begin(), frags.end());
	change(second, arr, frags);
	for (int i = 0; i < n; i++) {
		int v = frags[i];
		if (arr[v].val != second[i]) {
			vector<bool> first(s1.size());
			vector<bool> second(s2.size());
			for (int i = 0; i < s1.size(); i++) {
				first[i] = s1[i] == '+';
			}
			for (int i = 0; i < s2.size(); i++) {
				second[i] = s2[i] == '+';
			}
			int n = s1.size();
			vector<frag> arr;
			vector<int> frags(n);
			arr.reserve(n);
			arr.push_back(frag(first[0], 1, -1, 1));
			frags[0] = 0;
			for (int i = 1; i < n; i++) {
				if (arr.back().val == first[i]) {
					arr.back().q++;
				}
				else {
					arr.push_back(frag(first[i], 1, arr.size() - 1, arr.size() + 1));
				}
				frags[i] = arr.size() - 1;
			}
			reverse(second.begin(), second.end());
			reverse(frags.begin(), frags.end());
			change(second, arr, frags);
			reverse(second.begin(), second.end());
			reverse(frags.begin(), frags.end());
			change(second, arr, frags);
			for (int kk = 0; kk < 50; kk++) {
				bool bad = 0;
				for (int i = 0; i < n; i++) {
					int v = frags[i];
					if (arr[v].val != second[i]) {
						if (kk == 9) return false;
						reverse(second.begin(), second.end());
						reverse(frags.begin(), frags.end());
						change(second, arr, frags);
						bad = 1;
						break;
					}
				}
				if (!bad) {
					return 1;
				}
			}
			return true;
		}
	}
	return true;
}

int main() {
	int ab;
	cin >> ab;
	for (int abc = 0; abc < ab; abc++) {
		string s1, s2;
		cin >> s1 >> s2;
		if (good(s1, s2)) {
			cout << "Yes" << endl;
		}
		else {
			cout << "No" << endl;
		}
	}
	pause();
	return 0;
}