
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

vector<long long> x;
vector<long long> y;

long long sq(long long a, long long b, long long c) {
    return fabs((x[b] - x[a]) * (y[c] - y[a]) - (y[b] - y[a]) * (x[c] - x[a]));
}

int main() {
    long long n, q;
    cin >> n;
    x.resize(n);
    y.resize(n);
    for (long long i = 0; i < n; ++i)
        cin >> x[i] >> y[i];
    cin >> q;
    string c;
    for (long long i = 0; i < q; ++i) {
        bool br = false;
        long long a1, a2, a3;
        long long cs = -1;
        for (long long t1 = 1; t1 <= n; ++t1) {
            for (long long t2 = t1 + 1; t2 <= n; ++t2) {
                for (long long t3 = t2 + 1; t3 <= n; ++t3) {
                    cout << "? 3 " << t1 << ' ' << t2 << ' ' << t3 << endl;
                    cin >> c;
                    if (c[0] == 'Y') {
                        if (cs == -1 || sq(t1 - 1, t2 - 1, t3 - 1) < cs)
                        a1 = t1;
                        a2 = t2;
                        a3 = t3;
                        cs = sq(t1 - 1, t2 - 1, t3 - 1);
                    }
                }
            }
        }
        cout << "! 3 " << a1 << ' ' << a2 << ' ' << a3 << endl;
    }
}

