#include <iostream>
#include <vector>
#include <array>

using namespace std;

const long long c = 1000000000;
const long long INF = 1000000000000000000;

int main()
{
	int n, a;
	cin >> n >> a;
	vector<array<int, 3> > v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i][0] >> v[i][1] >> v[i][2];
	}
	vector<long long> dp(a + 1);
	for (int i = a; i >= 0; i--) {
		for (int j = 0; j < n; j++) {
			int l = v[j][0];
			int r = v[j][1];
			int w = v[j][2];
			if (i + r > a) {
				continue;
			}
			long long now_c = INF;
			for (int k = i + l; k <= i + r; k++) {
				now_c = min(now_c, dp[k] + c * (k - i) - w);
			}
			dp[i] = max(dp[i], now_c);
		}
	}
	cout << dp[0] << endl;
    return 0;
}

