#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>

using namespace std;

typedef long long ll;

const int N = 1e6 + 9;

string s;
char a[N];
stack <int> l, r;

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n / 2; ++i)
    {
        cout << "? " << i << ' ' << n - i + 1 << endl;
        cin >> s;
        if (s == "Yes")
        {
            a[i] = '(';
            a[n - i + 1] = ')';
            l.push(i);
            r.push(n - i + 1);
        }
        else
        {
            if (!l.empty())
            {
                cout << "? " << l.top() << ' ' << i << endl;
                cin >> s;
                if (s == "Yes")
                {
                    a[i] = ')';
                    l.pop();
                }
                else
                {
                    a[i] = '(';
                    l.push(i);
                }
            }
            else
            {
                a[i] = '(';
                l.push(i);
            }

            if (!r.empty())
            {
                cout << "? " << n - i + 1 << ' ' << r.top() << endl;
                cin >> s;
                if (s == "Yes")
                {
                    a[n - i + 1] = '(';
                    r.pop();
                }
                else
                {
                    a[n - i + 1] = ')';
                    r.push(n - i + 1);
                }
            }
            else
            {
                a[n - i + 1] = ')';
                r.push(n - i + 1);
            }
        }
    }
    cout << "! ";
    for (int i = 1; i <= n; ++i)
        cout << a[i];
    cout << endl;
    return 0;
}
