#include <fstream>
#include <cstdio>
#include <vector>
#include <stdio.h>
#include <queue>
#include <stack>
#include <string>
#include <algorithm>

//#include <iostream>

using namespace std;


#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef pair <ll, ll> pii;
typedef long double ld;

#define all(a) a.begin(), a.end()

int n, q;
vector <vector <int> > pole;

void toSecCount(int s, int a) {
	for (int i = 29; i >= 0; i--) {
		if (a >= (1 << i)) {
			a -= (1 << i);
			pole[29 - i][s] = 1;
		}
	}
	return;
}

vector <int> ans;

ll toTen() {
	ll Nans = 0;
	for (int i = 29; i >= 0; i--) {
		if (ans[29 - i] == -2) {
			ans[29 - i] = 0;
		}
		if (ans[29 - i] == -1) {
			return -1;
		}
		Nans += (1 << i) * ans[29 - i];
	}
	return Nans;
}

void toSec(int s, int a) {
	for (int i = 0; i < 30; i++) {
		pole[i][s] = 0;
		if (a >= (1 << (29 - i))) {
			a -= (1 << (29 - i));
			pole[i][s] = 1;
		}
	}
	return;
}

void predCount() {
	pole.assign(30, vector <int>(n));
	for (int i = 0; i < n; i++) {
		int temp;
		cin >> temp;
		toSecCount(i, temp);
	}
}



void f(int s, int l, int r) {
	if (s == 30) {
		return;
	}
	bool fl = false;
	int stop = -1;
	for (int i = l + 1; i < r + 1; i++) {
		if (pole[s][i] == pole[s][i - 1]) {
			continue;
		}
		if (fl) {
			ans[s] = -1;
			return;
		}
		else {
			fl = true;
			stop = i;
		}
	}
	if (ans[s] == -1) {
		return;
	}
	if (stop == -1) {
		f(s + 1, l, r);
	}
	else {
		f(s + 1, l, stop - 1);
		f(s + 1, stop, r);
	}
	int nowAns = 0;
	if (!fl) {
		return;
	}
	if (ans[s] == -2) {
		ans[s] = pole[s][l];
	}
	else {
		if (ans[s] != pole[s][l]) {
			ans[s] = -1;
		}
	}
	return;
}

void doOp() {
	ans.assign(30, -2);
	int s, temp;
	cin >> s >> temp;
	toSec(s - 1, temp);
	f(0, 0, n - 1);
	cout << toTen() << endl;
}

int main(){
	cin >> n;
	predCount();
	cin >> q;
	ans.assign(30, -2);
	f(0, 0, n - 1);
	cout << toTen() << endl;
	for (int i = 0; i < q; i++) {
		doOp();
	}
	return 0;
}