#include <iostream>
#include <vector>
#include <deque>


using namespace std;

struct dl{
    int a;
    int b;
    int cost;
};

vector<vector<pair<int, int> > > path(1000, vector<pair<int, int> > (0));
vector<dl> q(1000);

const int INF = 100000000;

int dejxtra(int v, int n) {
    vector<pair<int, int> > t(n, make_pair(INF, INF));
    t[v].first = 0;
    vector<pair<int, int> > r(n, make_pair(INF, INF));
    r[v].first = -2;
    for (auto k : path[v]) {
        r[k.first].first = k.second;
        r[k.first].second = k.second * k.second;
    }
    while (true) {
        int min_dist = INF;
        int u1 = -1;
        int u2 = -1;
        for (int i = 0; i < n; i++) {
            if ((min_dist > r[i].first or (min_dist == r[i].first and u2 > r[i].second)) and r[i].first >= 0) {
                u1 = i;
                u2 = r[i].second;
                min_dist = r[i].first;
            }
        }
        if (min_dist == INF) break;
        t[u1].first = min_dist;
        t[u1].second = u2;
        r[u1].first = -2;
        for (auto k : path[u1]) {
            if (r[k.first].first != -2) {
                if (min_dist + k.second <= r[k.first].first) {
                    r[k.first].first = min_dist + k.second;
                    r[k.first].second = min(r[k.first].second, u2 + k.second * k.second);
                }

            }
        }
    }
    cout << t[n - 1].first << " " << t[n - 1].second;
    return t[n - 1].first;
}


int main() {
    int u;
    int n, m, a, b, c, d;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c >> d;
        path[b - 1].push_back(make_pair(d - 1, c));
        //path[d - 1].push_back(make_pair(b - 1, c));
        q[i].a = b - 1;
        q[i].b = a - 1;
        q[i].cost = c * c;
    }
    u = dejxtra(0, n);
    //cout << u << " " << fordman(u, n, m) << endl;
}
