#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <deque>

using namespace std;

long long n, m, v, x, y, z;
vector <pair <long long, long long > > used;
vector <pair <long long, long long > > ans;
vector <vector <long long > > a;

void dijkstra()
{
    used.resize(n + 1);
    ans.resize(n);
    for (int i = 0; i <= n; i++)
        used[i] = make_pair(1e9 + 7, -1);
    used[0] = make_pair(0, 0);
    ans[0] = used[0];
    for (int i = 0; i < n; i++)
        if (a[0][i] != -1 && used[i].first >= ans[0].first + a[0][i])
        {
            used[i].first = ans[0].first + a[0][i];
            used[i].second = max(used[i].second, ans[0].second + a[0][i] * a[0][i]);
        }
    while(1)
    {
        v = n;
        for (int i = 0; i < n; i++)
            if (used[i].first != 0 && (used[i].first < used[v].first || (used[i].first == used[v].first && used[i].second > used[v].second)))
                v = i;
        if (v == n)
            return;
        ans[v] = used[v];
        used[v].first = 0;
        for (int i = 0; i < n; i++)
            if (a[v][i] != -1 && used[i].first >= ans[v].first + a[v][i])
            {
                used[i].first = ans[v].first + a[v][i];
                used[i].second = max(used[i].second, ans[v].second + a[v][i] * a[v][i]);
            }
    }
}

int main()
{
  //  freopen("input.txt", "r", stdin);
 //   freopen("output.txt", "w", stdout);
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        a[i].resize(n);
        for (int j = 0; j < n; j++)
            a[i][j] = -1;
    }
    for (int i = 0; i < m; i++)
    {
        cin >> x >> x >> y >> z;
        a[x - 1][z - 1] = y;
    }
    dijkstra();
    cout << ans[n - 1].first << ' ' << ans[n - 1].second;

    return 0;
}
