#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N = 2 * 1e5 + 1;
const int INF = 1e18;

int n;
vector<vector<int> > v(MAX_N);
vector<vector<int> > w(MAX_N);

void init()
{
    int m;
    scanf("%d", &m);
    for (int i = 0; i < m; i++)
    {
        int s;
        scanf("%d", &s);
        vector<int> d, l;
        for (int i = 0; i < 2 * s + 1; i++)
        {
            int x;
            scanf("%d", &x);
            if (i & 1)
            {
                l.push_back(x);
            }
            else
            {
                d.push_back(x - 1);
            }
        }
        //for (int x : d)
        //    cerr << x << " ";
        //cerr << endl;
        for (int i = 0; i < s; i++)
        {
            int f = d[i];
            int sum = 0;
            for (int j = i + 1; j < s + 1; j++)
            {
                sum += l[j - 1];
                v[f].push_back(d[j]);
                w[f].push_back(sum);
            }
        }
    }
}

pair<ll, ll> dist[MAX_N];
set<pair<pair<ll, ll>, int> > q;

int main()
{
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);
    scanf("%d", &n);
    init();
    /*for (int i = 0; i < n; i++)
    {
        cerr << "it is " << i << "\n";
        for (int j : v[i])
            cerr << j << " ";
        cerr << endl;
    }*/
    for (int i = 0; i < n; i++)
        dist[i] = make_pair(INF, -INF);
    dist[0] = make_pair(0, 0);
    for (int i = 0; i < n; i++)
        q.insert(make_pair(dist[i], i));
    while (!q.empty())
    {
        int now = q.begin()->second;
        pair<ll, ll> x = dist[now];
        //cerr << "!! " << now + 1 << " " << x.first << " " << -x.second << "\n";
        q.erase(q.begin());
        for (int i = 0; i < v[now].size(); i++)
        {
            int to = v[now][i];
            int wr = w[now][i];
            pair<ll, ll> go = make_pair((ll)wr + x.first, -(ll)wr * (ll)wr + x.second);
            if (go < dist[to])
            {
                q.erase(make_pair(dist[to], to));
                dist[to] = go;
                q.insert(make_pair(dist[to], to));
            }
        }
    }
    //for (int i = 0; i < n; i++)
    //    cerr << "!! " << i << " " << dist[i].first << " " << -dist[i].second << "\n";
    cout << dist[n - 1].first << " " << -dist[n - 1].second;
    return 0;
}
