#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef long double ld;

void go()
{
    ll x;
    if (scanf("%I64d", &x) != EOF)
    {
        go();
        cout << x << " ";
    }
    return;
}

const int M = 800;
int a[M][M];

void test()
{
    for (int i = 0; i < M; i++)
        for (int j = 0; j < M; j++)
            if (i != j)
                a[i][j] = ((i ^ 239) * 10 + (j * 7)) % 1000;
    for (int h = 0; h < M; h++)
        for (int i = 0; i < M; i++)
            for (int j = 0; j < M; j++)
                a[i][j] = min(a[i][j], a[i][h] + a[h][j]);
}

int main()
{
    #define fname "sequence"
    freopen(fname".in", "r", stdin);
    freopen(fname".out", "w", stdout);
    cin.sync_with_stdio(0);
    test();
    go();
    return 0;
}
