#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <stack>
#include <map>
#include <random>
typedef long long ll;

using namespace std;
bool check(ll l, ll r) {
	cout << "? " << l + 1 << ' ' << r + 1 << endl;
	string s;
	cin >> s;
	return (s == "Yes");
}
int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ll n;
	cin >> n;
	vector<bool> v(n);
	v[0] = 0;
	stack<ll> st;
	st.push(0);
	for (ll i = 1; i < n; i++) {
		if (check(i-1, i)) {
			v[i] = 1;
			st.pop();
			continue;
		}
		if (st.size() == 0) {
			v[i] = 0;
			st.push(i);
			continue;
		}
		ll ind = st.top();
		if (check(ind, i)) {
			v[i] = 1;
			st.pop();
		}
		else {
			v[i] = 0;
			st.push(i);
		}
	}
	string s = "()";
	cout << "! ";
	for (ll i = 0; i < n; i++)
		cout << s[v[i]];
	return 0;
}