#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#define X first
#define Y second
typedef long long ll;
using namespace std;
vector<vector<pair<ll,ll > > > gg,rg,g;
struct rebr {
	ll u, v, len, id;
	rebr(ll v, ll u, ll len, ll id) :
		v(v), u(u), len(len), id(id) {}
};
vector<rebr> r;
vector<ll> d;
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll n, m;
	cin >> n >> m;
	gg.resize(n);
	rg.resize(n);
	g.resize(n);
	d.resize(n, 1e18);
	for (ll i = 0; i < m; i++) {
		ll k;
		cin >> k;
		ll last;
		cin >> last;
		last--;
		for (ll j = 0; j < k; j++) {
			ll t, now;
			cin >> t >> now;
			now--;
			gg[last].emplace_back(now, t);
			rg[now].emplace_back(last, t);
			last = now;
			r.emplace_back(last, now, t, i);
		}
	}
	d[0] = 0;
	vector<ll> dd(n,-1);
	dd[0] = 0;
	set<pair<ll, ll> > st;
	st.insert({ 0,0 });
	while (!st.empty()) {
		ll v = st.begin()->Y;
		st.erase(st.begin());
		for (ll i = 0; i < gg[v].size(); i++) {
			ll to = gg[v][i].X, len = gg[v][i].Y;
			if (d[v] + len < d[to] || (d[v]+len==d[to] && dd[v]+len*len>dd[to])) {
				st.erase({ d[to],to });
				d[to] = d[v] + len;
				dd[to] = dd[v] + len*len;
				st.insert({ d[to],to });
			}
		}
	}
	vector<bool> used(n, false);
	used[n - 1] = 1;
	queue<ll> q;
	q.push(n - 1);
	while (!q.empty()) {
		ll v = q.front();
		q.pop();
		for (ll i = 0; i < rg[v].size(); i++) {
			ll to = rg[v][i].X, len = rg[v][i].Y;
			if (!used[to] && d[to] + len == d[v]) {
				used[to] = 1;
				q.push(to);
			}
		}
	}
	for (ll i = 0; i < r.size(); i++) {
		if (used[r[i].v] && used[r[i].u])
			g[r[i].v].push_back({ r[i].u,r[i].id });
	}	
	cout << d[n-1] << ' ' << dd[n-1];
	return 0;
}