#include <iostream>

using namespace std;
const int MAXN = 5001;
int t[MAXN];
int l[MAXN];
int r[MAXN];
bool dl[MAXN][MAXN];
bool dr[MAXN][MAXN];

int get(int x, int t, int l, int r) {
    if (l > x + t || x > r) return -1;
    else return max(l, x);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> l[i] >> r[i];
    }
    for (int i = 0; i < n; i++) {
        for (int tt = 0; tt < MAXN; tt++) {
            if (i == 0) dl[i][tt] = true;
            else {
                int q = get(tt, t[i], l[i - 1], r[i - 1]);
                dl[i][tt] = (q == -1 ? false : dl[i - 1][q]);
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int tt = 0; tt < MAXN; tt++) {
            if (i == n - 1) dr[i][tt] = true;
            else {
                int q = get(tt, t[i], l[i], r[i]);
                dr[i][tt] = (q == -1 ? false : dr[i + 1][q]);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        bool good = false;
        for (int tt = 0; tt < MAXN; tt++) {
            if (dl[i][tt] && dr[i][tt]) {
                good = true;
                cout << tt << "\n";
                break;
            }
        }
        if (!good) cout << "-1\n";
    }
    return 0;
}
