#include <bits/stdc++.h>
 
using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;
 
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
 
#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) {\
    std::stringstream _ss(#as);\
    vector<string> _v;\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(), as);\
}
#else 
#define dbg(as...) {}
#endif
 
template<typename T> 
void err(vector<string>::iterator it, T a) {
    cerr << *it << " = " << a << '\n';
}
 
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << *it << " = " << a << ',';
    err(++it, as...);
}
 
struct init{
    init() {
        std::iostream::sync_with_stdio(0);
        cin.tie(0);
        cout << std::fixed << std::setprecision(10);
        cerr << std::fixed << std::setprecision(3);
        srand(300);
    }
} init;
 
const int MAXN = 1e6 + 1, INF = 1e9 + 7;
vector<pll> g[MAXN];
pll d[MAXN];
bool used[MAXN];
pll best(pll a, pll b) {
	if(a.ff == b.ff ? a.ss > b.ss : a.ff < b.ff) return a;
	return b;
}
int32_t main() {
 	int n, m;
 	cin >> n >> m;
 	for (int i = 0; i < m; ++i) {
 		int si, a;
 		cin >> si >> a;
 		vector<pii> way(si);
 		for (pii & p : way) 
 			cin >> p.ff >> p.ss;
 	    int sum = 0; 
		for (int k = 0; k < si; ++k) {
			sum += way[k].ff;
			g[a].pb(way[k].ss, sum);
		}
 		for (int j = 0; j < si; ++j) {
 			sum = 0; 
 			for (int k = j + 1; k < si; ++k) {
 				sum += way[k].ff;
 				g[way[j].ss].pb(way[k].ss, sum);
 			}
 		}
	 	// for (int v = 1; v <= n; ++v)
	 	// 	for (pll to : g[v])
	 	// 		dbg(v, to.ff, to.ss);
	 	// dbg("===");
 	}
 	d[1] = {0, 0};
 	for (int i = 2; i <= n; ++i) 
 		d[i] = {INF, -INF};
 	for (int i = 0; i < n; ++i) {
 		dbg(i);
 		int v = -1;
 		for (int j = 1; j <= n; ++j) {
 			if (!used[j] && (v == -1 || best(d[j], d[v]) == d[j]))
 				v = j;
 		}
 		dbg(v, d[v].ff);
 		used[v] = true;
 		for (pll to : g[v]) {
 			ll ndf = d[v].ff + to.ss;
 			ll nds = d[v].ss + sqr(to.ss); 
 			dbg(to.ff, to.ss);
 			d[to.ff] = best(d[to.ff], {ndf, nds});
 		}
 	}

 	cout << d[n].ff << ' ' << d[n].ss << '\n';

    return 0;
}