#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int quest(int x) {
    int ans;
    cout << x << '\n';
    fflush(stdout);
    cin >> ans;
    return ans;
}

const int n = 1020;
const int max_num = 10000;

int main() {
    int left, right, mid, tmp, m;
    bool flag = true;
    vector <vector <int> > v(n, vector <int> (n, max_num));
    for (int i = 0; i < n - 1; i++) {
        v[i][i + 1] = v[i + 1][i] = 1;
    }
    v[0][1] = v[1][0] = 3;
    v[1][2] = v[2][1] = 2;
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                v[i][j] = min(v[i][j], v[i][k] + v[k][j]);
            }
        }
    }
    //cout << v[0][2] << '\n';
    cin >> m;
    left = 0;
    right = m + 1;
    while (flag) {
        mid = (left + right) / 2;
        tmp = quest(mid);
        if (tmp < 0) {
            right = mid;
        }
        else if (tmp == 0) {
            flag = false;
        }
        else {
            left = mid;
        }
    }
    return 0;
}
