#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ldouble;

#define mk make_pair
#define eps 1e-8
#define linf 8e18
#define inf 2e9
#define Size 1000006

struct ev {
	int l, r, c;
	ev(int l, int r, int c) : l(l), r(r), c(c) {}
};

int N;
ll A;
vector<ev> E;
ll ans = 0;


void rec(ll l, ll r, ll curs, int i, ll an) {
	if (i == E.size()) {
		ans = max(ans, an * 1000000000 - curs);
		return;
	}
	int k = 0;
	ll cl = l, cr = r;
	rec(cl, cr, curs, i + 1, an);
	ll rk = (A - cr - E[i].r + E[i].l - 1) / E[i].l;
	for (int k = 1; k <= rk; k++) {
		cl += E[i].l;
		cr += E[i].r;
		rec(cl, cr, curs + E[i].c * k, i + 1, an + k);
	}

}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#else
	//freopen("test.in", "r", stdin); freopen("B.out", "w", stdout);
#endif

	cin >> N >> A;
	
	for (int i = 0; i < N; i++) {
		int l, r, c;
		cin >> l >> r >> c;
		E.push_back(ev(l, r, c));
	}

	rec(0, 0, 0, 0, 0);

	cout << ans << "\n";

	return 0;
}