#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring>
#include <queue>
#include <stack>
#include <set>

using namespace std;

const int INF = 1e+9;

int main() {
    freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int ,int> > > a(n);
    for (int i = 0; i < m; ++i) {
        int s;
        cin >> s;
        int x, t, y;
        cin >> x >> t >> y;
        a[--x].push_back(make_pair(--y, t));
        a[y].push_back(make_pair(x, t));
    }
    vector<bool> use(n, false);
    vector<pair<int, long long> > d(n, make_pair(INF, 0));
    d[0] = make_pair(0, 0);
    while(true) {
        int v = -1;
        for (int i = 0; i < n; ++i) {
            if (use[i]) continue;
            if (v == -1 && d[i].first != INF) {
                v = i;
                continue;
            }
            if (v != -1 && d[i].first < d[v].first)
                v = i;
        }
        if (v == -1) break;
        use[v] = true;
        for (int i = 0; i < a[v].size(); ++i) {
            int u = a[v][i].first;
            long long t = a[v][i].second;
            if (d[u].first == d[v].first + t)
                d[u].second = max(d[u].second, d[v].second + t * t);
            else if(d[u].first > d[v].first + t)
                d[u] = make_pair(d[v].first + t, d[v].second + t * t);
        }
    }

    cout << d[n - 1].first << " " << d[n - 1].second;
    return 0;
}
