#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <cstring>

using namespace std;

const int INF = 1e+9 + 1000;

pair<int, int> per(pair<int, int> p1, pair<int, int> p2) {
    int l = max(p1.first, p2.first);
    int r = min(p1.second, p2.second);
    if (l > r) return make_pair(-1, -1);
    return make_pair(l, r);
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen("errput.txt", "w", stderr);
    int n;
    cin >> n;
    if (n == 1) {
        cout << "0" << endl;
        return 0;
    }
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<pair<int, int> > mov(n - 1);
    for (int i = 0; i < n - 1; ++i)
        cin >> mov[i].first >> mov[i].second;
    vector<pair<int, int> > left(n);
    vector<pair<int, int> > right(n);
    left[0] = make_pair(0, INF);
    for (int i = 1; i < n; ++i) {
        left[i] = per(left[i - 1], make_pair(mov[i - 1].first, mov[i - 1].second));
        if (left[i].first != -1) {
            left[i].first = max(0, max(left[i].first - t[i], left[i - 1].first));
        }
    }
    right[n - 1] = make_pair(0, INF);
    for (int i = n - 2; i >= 0; --i) {
        right[i] = per(right[i + 1], make_pair(mov[i].first, mov[i].second));
         if (right[i].first != -1) {
            right[i].first = max(0, max(right[i].first - t[i], right[i + 1].first));
        }
    }
    /*
    for (int i = 0; i < n; ++i) {
        cerr << left[i].first << " " << left[i].second << endl;
    }
    cerr << endl;
    for (int i = 0; i < n; ++i) {
        cerr << right[i].first << " " << right[i].second << endl;
    }*/
    for (int i = 0; i < n; ++i) {
        pair<int, int> p = per(left[i], right[i]);
        cout << p.first << endl;
    }
}
