#include <bits/stdc++.h>

using namespace std;
typedef long long LL;
const LL sz = 1e6 + 5;

int find_elder_bit(LL a, LL b)
{
    bitset<32> a1 = a;
    bitset<32> a2 = b;
    for (int i = 30; i >= 0; --i)
    {
        if (a1[i] != a2[i])  return i;
    }
    return -1;
}

LL get_result(vector <bitset<sz> > & yes, vector <bitset<sz> > & no)
{
    LL res = 0;
    for (int i = 0; i < 31; ++i)
    {
        if (yes[i].any())
        {
            if (no[i].any())
            {
                res = -1;
                break;
            }
            else res += (1 << i);
        }
    }

    return res;
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);


    int n,q;
    cin >> n;
    vector <bitset<sz> > yes(32);
    vector <bitset<sz> > no(32);

    vector <LL> a(n + 1);
    vector <pair <int,int> > b(n + 1, {-1,31});

    for (int i = 1; i < n + 1; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i < n; ++i)
    {
        int bt = find_elder_bit(a[i],a[i + 1]);
        if (bt == -1) continue;
        if (a[i] > a[i + 1])
        {
            yes[bt][i] = 1;
            b[i] = {1, bt};
        }
        else
        {
            no[bt][i] = 1;
            b[i] = {-1, bt};
        }
    }

    cout << get_result(yes,no) << '\n';

    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int pos, v;
        cin >> pos >> v;
         a[pos] = v;

        if (pos > 1)
        {
            if (b[pos - 1].second != -1)
            if (b[pos - 1].first == 1)
            {
                yes[b[pos - 1].second][pos - 1] = 0;
            }
            else
            {
                no[b[pos - 1].second][pos - 1] = 0;
            }

            b[pos - 1] = {-1, 31};
            int bt = find_elder_bit(a[pos - 1], a[pos]);

             if (bt != -1)
             if (a[pos - 1] > a[pos])
            {
                yes[bt][pos - 1] = 1;
                b[pos - 1] = {1, bt};
            }
            else
            {
                no[bt][pos - 1] = 1;
                b[pos - 1] = {-1, bt};
            }

        }
        if (pos < n)
        {
              if (b[pos].second != -1)
             if (b[pos].first == 1)
            {
                yes[b[pos].second][pos] = 0;
            }
            else
            {
                no[b[pos].second][pos] = 0;
            }

            b[pos] = {-1, 31};
            int bt = find_elder_bit(a[pos], a[pos + 1]);

            if (bt != -1)
             if (a[pos] > a[pos + 1])
            {
                yes[bt][pos] = 1;
                 b[pos] = {1, bt};
            }
            else
            {
                no[bt][pos] = 1;
                b[pos] = {-1, bt};
            }
        }

        cout << get_result(yes,no) << '\n';
    }

    return 0;
}
