#include <iostream>
#include <string>
#include <cmath>
#include <algorithm>


using namespace std;

int t[200000];
int inf = 1000000000;
int n;
long long int x = 0;
long long int min1[200000], min2[200000], max1[200000], max2[200000];
pair <long long int, long long int> g[200000];



int main() {
	ios_base::sync_with_stdio(false);

	cin >> n;

	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	long long int l, r;
	for (int i = 0; i < n - 1; ++i) {
		cin >> l >> r;
		g[i].first = l;
		g[i].second = r;
	}

	min1[0] = 0;
	max1[0] = inf;
	for (int i = 1; i < n; ++i) {
		if (min1[i - 1] > g[i - 1].second || max1[i - 1] < g[i - 1].first) {
			min1[i] = inf + 1;
			max1[i] = 0;
			continue;
		}

		if (min1[i - 1] > g[i - 1].first) {
			min1[i] = min1[i - 1];
			max1[i] = min1[i - 1];
			continue;
		}

		min1[i] = max(x, g[i - 1].first - t[i]);
		max1[i] = min(g[i - 1].second, max1[i - 1]);
	}

	min2[n - 1] = 0;
	max2[n - 1] = inf;
	for (int i = n - 2; i >= 0; --i) {
		if (min2[i + 1] > g[i].second || max2[i + 1] < g[i].first) {
			min2[i] = inf + 1;
			max2[i] = 0;
			continue;
		}

		if (min2[i + 1] > g[i].first) {
			min2[i] = min2[i + 1];
			max2[i] = min2[i + 1];
			continue;
		}

		min2[i] = max(x, g[i].first - t[i]);
		max2[i] = min(g[i].second, max2[i + 1]);
	}

	long long int ans;
	for (int i = 0; i < n; ++i) {
		ans = max(min1[i], min2[i]);
		if (ans >= inf) {
			cout << "-1\n";
			continue;
		}

		cout << ans << "\n";
	}


	return 0;
}