#include <iostream>
#include <vector>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

int n;
vector<int> a;
vector<int> pair0(30, 0), pair1(30, 0);

void compare_bits(int a1, int a2, int add) {
    int bit = 29;
    while (bit > -1 && ((a1 >> bit) & 1) == ((a2 >> bit) & 1)) {
        bit--;
    }

    if (bit > -1) {
        if (((a1 >> bit) & 1) == 1) {
            pair1[bit] += add;
        } else {
            pair0[bit] += add;
        }
    }
}

int calculate() {
    int b = 0;
    for (int bit = 29; bit > -1; bit--) {
        if (pair1[bit] > 0) {
            if (pair0[bit] > 0) {
                return -1;
            } else {
                b |= 1 << bit;
            }
        }
    }

    return b;
}

int result() {
    for (int i = 0; i < n - 1; i++) {
        compare_bits(a[i], a[i + 1], 1);
    }

    return calculate();
}

int main() {

    freopen("order.in", "r", stdin);
    freopen("order.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    a = vector<int>(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    cout << result() << '\n';
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v;
        p--;

        if (p > 0) {
            compare_bits(a[p - 1], a[p], -1);
            compare_bits(a[p - 1], v, 1);
        }
        if (p < n - 1) {
            compare_bits(a[p], a[p + 1], -1);
            compare_bits(v, a[p + 1], 1);
        }

        a[p] = v;
        cout << calculate() << '\n';
    }

    return 0;

}

#pragma clang diagnostic pop