#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e18 + 7;

int main() {
    ll n, q;
    cin >> n >> q;
    vector <vector <ll> > gr(n, vector <ll> (n, INF));
    vector <vector <ll> > data(q);
    for (ll i = 0; i < q; i++) {
        ll s;
        cin >> s;
        for (ll j = 0; j < 2 * s + 1; j++) {
            ll x;
            cin >> x;
            data[i].push_back(x);
            if (j % 2 == 0) {
                data[i].back()--;
            }
        }
    }
    for (ll k = 0; k < n; k++) {
        for (ll i = 0; i < q; i++) {
            ll now = 0;
            bool fl = 0;
            for (ll j = 0; j < data[i].size(); j += 2) {
                if (data[i][j] == k) {
                    fl = 1;
                    if (j < data[i].size() - 1) {
                        now += data[i][j + 1];
                    }
                } else if (fl) {
                    gr[k][data[i][j]] = min(now, gr[k][data[i][j]]);
                    if (j < data[i].size() - 1) {
                        now += data[i][j + 1];
                    }
                }
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << gr[i][j] << " ";
        }
        cout << endl;
    }*/
    set <pair <pair <ll ,ll>, ll> > s;
    vector <pair <ll, ll> > dist(n, {INF, INF});
    dist[0] = {0, 0};
    s.insert({dist[0], 0});
    while (!s.empty()) {
        auto p = *s.begin();
        s.erase(p);
        ll v = p.second;
       // cout << v << " " << dist[v].first << " " << dist[v].second << endl;
        for (ll u = 0; u < n; u++) {
            if (v == u) continue;
            ll w = gr[v][u];
            if (dist[u].first > dist[v].first + w) {
                s.erase({dist[u], u});
                dist[u].first = dist[v].first + w;
                dist[u].second = dist[v].second + w * w;
                s.insert({dist[u], u});
            } else if (dist[u].first == dist[v].first + w && dist[u].second < dist[v].second + w * w) {
                s.erase({dist[u], u});
                dist[u].first = dist[v].first + w;
                dist[u].second = dist[v].second + w * w;
                s.insert({dist[u], u});
            }
        }
    }
    cout << dist[n - 1].first << " " << dist[n - 1].second << endl;
}
/*
2 1
1 1 3 2

5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5
*/
