#include <bits/stdc++.h>


using namespace std;


template<typename T1, typename T2>inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2>inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 100001;
const int INF = 1000000001;


int n;
int sons[MAXN * 60][2];
int minnum[MAXN * 60];
int maxnum[MAXN * 60];
set<int> s[MAXN];
int uk = 1;


void adds(int a, int id) {
	vector<int> g;
	for (int i = 0; i < 30; i++) {
		g.push_back(a & 1);
		a >>= 1;
	}
	reverse(all(g));
	vector<int> path;
	int cur = 1;
	for (int i = 0; i < 30; i++) {
		path.push_back(cur);
		if (sons[cur][g[i]]) {
			cur = sons[cur][g[i]];
		} else {
			uk++;
			sons[cur][g[i]] = uk;
			cur = uk;
		}
	}
	s[cur].insert(id);
	if (minnum[cur] == 0) {
		minnum[cur] = id;
	} else {
		chkmin(minnum[cur], id);
	}
	if (maxnum[cur] == 0) {
		maxnum[cur] = id;
	} else {
		chkmax(maxnum[cur], id);
	}
	for (int i = 29; i >= 0; i--) {
		int x = path[i];
		minnum[x] = INF;
		maxnum[x] = -INF;
		for (int t = 0; t < 2; t++) {
			if (sons[x][t]) {
				chkmin(minnum[x], minnum[sons[x][t]]);
				chkmax(maxnum[x], maxnum[sons[x][t]]);
			}
		}
	}
}


int cntneeds[30][2];
int cntbads = 0;


inline void proceed(int v, int deep, int t) {
	if (minnum[v] == INF) {
		return;
	}
	if (!sons[v][0] || !sons[v][1]) {
		return;
	}
	if (minnum[sons[v][0]] > minnum[sons[v][1]]) {
		cntneeds[deep][1]+= t;
		if (maxnum[sons[v][1]] != minnum[sons[v][0]] - 1) {
			cntbads+= t;
		}
	} else {
		cntneeds[deep][0]+= t;
		if (maxnum[sons[v][0]] != minnum[sons[v][1]] - 1) {
			cntbads+= t;
		}
	}
}


void dfs(int v, int deep = 0) {
	proceed(v, deep, 1);
	for (int t = 0; t < 2; t++) {
		if (sons[v][t]) {
			dfs(sons[v][t], deep + 1);
		}
	}
}


inline int calc() {
	//cout << cntbads << endl;
	if (cntbads) {
		return -1;
	}
	int ans = 0;
	int t = 1 << 29;
	for (int i = 0; i < 30; i++) {
		if (cntneeds[i][0] && cntneeds[i][1]) {
			return -1;
		}
		if (cntneeds[i][1]) {
			ans += t;
		}
		t >>= 1;
	}
	return ans;
}


void add(int a, int id) {
	vector<int> g;
	for (int i = 0; i < 30; i++) {
		g.push_back(a & 1);
		a >>= 1;
	}
	reverse(all(g));
	vector<int> path;
	int cur = 1;
	for (int i = 0; i < 30; i++) {
		proceed(cur, i, -1);
		path.push_back(cur);
		if (sons[cur][g[i]]) {
			cur = sons[cur][g[i]];
		} else {
			uk++;
			sons[cur][g[i]] = uk;
			cur = uk;
		}
	}
	s[cur].insert(id);
	minnum[cur] = *s[cur].begin();
	maxnum[cur] = *s[cur].rbegin();
	for (int i = 29; i >= 0; i--) {
		int x = path[i];
		minnum[x] = INF;
		maxnum[x] = -INF;
		for (int t = 0; t < 2; t++) {
			if (sons[x][t]) {
				chkmin(minnum[x], minnum[sons[x][t]]);
				chkmax(maxnum[x], maxnum[sons[x][t]]);
			}
		}
		proceed(x, i, 1);
	}
}


void del(int a, int id) {
	vector<int> g;
	for (int i = 0; i < 30; i++) {
		g.push_back(a & 1);
		a >>= 1;
	}
	reverse(all(g));
	vector<int> path;
	int cur = 1;
	for (int i = 0; i < 30; i++) {
		proceed(cur, i, -1);
		path.push_back(cur);
		cur = sons[cur][g[i]];
	}
	s[cur].erase(id);
	minnum[cur] = (s[cur].empty() ? INF: *s[cur].begin());
	maxnum[cur] = (s[cur].empty() ? -INF: *s[cur].rbegin());
	for (int i = 29; i >= 0; i--) {
		int x = path[i];
		if (minnum[sons[x][g[i]]] == INF) {
			sons[x][g[i]] = 0;
		}
		minnum[x] = INF;
		maxnum[x] = -INF;
		for (int t = 0; t < 2; t++) {
			if (sons[x][t]) {
				chkmin(minnum[x], minnum[sons[x][t]]);
				chkmax(maxnum[x], maxnum[sons[x][t]]);
			}
		}
		proceed(x, i, 1);
	}
}


int a[MAXN];


int main() {
	ios_base::sync_with_stdio(false);
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		adds(a[i], i + 1);
	}
	dfs(1);
	cout << calc() << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int id, num;
		cin >> id >> num;
		id--;
		del(a[id], id + 1);
		a[id] = num;
		add(a[id], id + 1);
		cout << calc() << '\n';
	}
	return 0;
}
