#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("internship.in", "r", stdin);
	freopen("internship.out", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;

	vector<int> a(n), x(n), b(m), y(m);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}

	for (int i = 0; i < n; i++) {
		cin >> x[i];
	}

	vector<vector<int> > wh(n + m);

	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;

		wh[b[i]].push_back(i);
	}

	for (int i = 0; i < m; i++) {
		cin >> y[i];

		if (i) y[i] += y[i - 1];
	}

	int ans = 0, lx = 0, rx = 0, ly = 0, ry = 0;

	for (int l = 0; l < n; l++) {
		int sm = 0;
		vector<int> bnds;

		for (int r = l; r < n; r++) {
			sm += x[r];
			vector<int> tmp = bnds;
			bnds.resize(bnds.size() + wh[a[r]].size());

			merge(all(tmp), all(wh[a[r]]), bnds.begin());

			if (sm > ans) {
				ans = sm;
				lx = l, rx = r, ly = ry = 0;
			}

			for (int i = 1; i < (int)bnds.size(); i++) {
				if (bnds[i]) {
					int cnt = y[bnds[i] - 1] - y[bnds[i - 1]];

					if (sm + cnt > ans) {
						ans = sm + cnt;
						lx = l, rx = r, ly = bnds[i - 1] + 1, ry = bnds[i] - 1;
					}
				}
			}
		}
	}

	if (y[m - 1] > ans) {
		cout << y[m - 1] << "\n0 0\n1 " << m << "\n";
	} else {
		cout << ans << "\n" << lx + 1 << " " << rx + 1 << "\n" << ly + 1 << " " << ry + 1 << "\n";
	}

	return 0;
}
