#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const ll INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("internship.in", "r", stdin);
	freopen("internship.out", "w", stdout);
#endif

	ll n, m;
	cin >> n >> m;

	vector<ll> a(n), x(n), b(m), y(m);

	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}

	for (ll i = 0; i < n; i++) {
		cin >> x[i];
	}

	vector<vector<ll> > wh(n + m);

	for (ll i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;

		wh[b[i]].push_back(i);
	}

	for (ll i = 0; i < m; i++) {
		cin >> y[i];

		if (i) y[i] += y[i - 1];
	}

	vector<int> was1(n + m), was2(n + m);
	int last1 = 0, last2 = 0;

	ll ans = 0, lx = 0, rx = 0, ly = 0, ry = 0;

	for (ll l = 0; l < n; l++) {
		ll sm = 0;
		vector<ll> bnds(2, -1);
		bnds[1] = m;
		last1++;

		for (ll r = l; r < n; r++) {
			if (was1[a[r]] == last1) break;
			was1[a[r]] = last1;

			sm += x[r];
			vector<ll> tmp = bnds;
			bnds.resize(bnds.size() + wh[a[r]].size());

			merge(all(tmp), all(wh[a[r]]), bnds.begin());

			if (sm > ans) {
				ans = sm;
				lx = l, rx = r, ly = ry = 0;
			}

			for (ll i = 1; i < (ll)bnds.size(); i++) {
				if (bnds[i]) {
					last2++;
					ll cnt = y[bnds[i] - 1] - (bnds[i - 1] >= 0 ? y[bnds[i - 1]] : 0);
					bool bad = 0;

					for (int j = bnds[i - 1] + 1; j < bnds[i]; j++) {
						if (was2[b[j]] == last2) {
							bad = 1;
							break;
						} else {
							was2[b[j]] = last2;
						}
					}

					if (sm + cnt > ans && !bad) {
						ans = sm + cnt;
						lx = l, rx = r, ly = bnds[i - 1] + 1, ry = bnds[i] - 1;
					}
				}
			}
		}
	}

	if (y[m - 1] > ans) {
		cout << y[m - 1] << "\n0 0\n1 " << m << "\n";
	} else {
		cout << ans << "\n" << lx + 1 << " " << rx + 1 << "\n" << ly + 1 << " " << ry + 1 << "\n";
	}

	return 0;
}
