#include <bits/stdc++.h>

using namespace std;

//struct Edge {
//    int u, v;
//    pair<long long, long long> w;
//
//    Edge(int u, int v, long long ww) : u(u), v(v) {
//        w.first = ww;
//        w.second = ww * ww;
//    }
//
//    Edge() {}
//};

const int MAXN = 10000;
int am[MAXN][MAXN];

const long long INF = 1000000000;
vector<long long> d1, d2;

long long sqr(int x) {
    return ((long long) x) * x;
}

int main() {
    int n, m;
    scanf("%d%d", &n, &m);
    d1.assign(n, INF);
    d2.assign(n, -INF * INF);
    for (int i = 0; i < n; i++) {
        fill(am[i], am[i] + n, MAXN * MAXN);
    }

    for (int i = 0; i < m; i++) {
        int s;
        scanf("%d", &s);
        vector<int> v(s + 1), t(s);
        scanf("%d", &v[0]);
        v[0]--;
        for (int j = 0; j < s; j++) {
            scanf("%d%d", &t[j], &v[j + 1]);
            v[j + 1]--;
        }

        for (int L = 0; L < s + 1; L++) {
            long long cur = 0;
            for (int R = L + 1; R < s + 1; R++) {
                cur += t[R - 1];
                if (cur > 10000000) {
                    break;
                }
                am[v[L]][v[R]] = min(am[v[L]][v[R]], (int) cur);
            }
        }
    }

    d1[0] = 0;
    d2[0] = 0;
    vector<bool> used(n);
    for (int i = 1; i < n; i++) {
        int mn_v = -1;
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                if (mn_v == -1 || d1[mn_v] > d1[j] || (d1[mn_v] == d1[j] && d2[mn_v] < d2[j])) {
                    mn_v = j;
                }
            }
        }

        int u = mn_v;
        used[u] = true;
        long long curd1 = d1[u];
        long long curd2 = d2[u];

        for (int v = 0; v < n; v++) {
            if (am[u][v] == MAXN * MAXN) continue;
            long long nd1 = curd1 + am[u][v];
            long long nd2 = curd2 + sqr(am[u][v]);
            if (d1[v] > nd1 || (d1[v] == nd1 && d2[v] < nd2)) {
                d1[v] = nd1;
                d2[v] = nd2;
            }
        }
    }

    cout << d1[n - 1] << " " << d2[n - 1] << endl;

    return 0;
}

/*

2 1
1 1 3 2

5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5

 */
