#include <bits/stdc++.h>

using namespace std;

typedef double ld;

const ld eps = 1e-9;

int n, x[5000], y[5000], q;
bool any[300][300][300];
pair<int,int> pt[5000];
ld d[300][300];
ld s[300][300][300];

inline bool eq(ld a, ld b)
{
    return abs(a - b) < eps;
}

int main()
{
    srand(time(NULL));
    cin >> n;
    for(int i = 0; i < n; i++) cin >> pt[i].first >> pt[i].second;
    random_shuffle(pt, pt + n);
    for(int i = 0; i < n; i++) x[i] = pt[i].first, y[i] = pt[i].second;
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            d[i][j] = d[j][i] = sqrt(.0 + (x[i]-x[j])*(x[i]-x[j]) + (y[i]-y[j])*(y[i]-y[j]));
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            for(int k = j + 1; k < n; k++)
            {
                ld p = (d[i][j] + d[j][k] + d[k][i]) / 2.0;
                s[i][j][k] = s[i][k][j] = s[j][i][k] = s[j][k][i] = s[k][i][j] = s[k][j][i] = sqrt(p*(p-d[i][j])*(p-d[j][k])*(p-d[k][i]));
            }
    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
            for(int k = j + 1; k < n; k++)
                for(int r = 0; r < n; r++)
                {
                    if(i == r || j == r || k == r) continue;
                    if(eq(s[i][j][k], s[i][j][r] + s[i][k][r] + s[j][k][r]))
                    {
                        any[i][j][k] = any[i][k][j] = any[j][i][k] = any[j][k][i] = any[k][i][j] = any[k][j][i] = true;
                        break;
                    }
                }
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        bool go = true;
        for(int i = 0; i < n && go; i++)
            for(int j = i + 1; j < n && go; j++)
                for(int k = j + 1; k < n && go; k++)
                {
                    if(any[i][j][k]) continue;
                    cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                    string ret;
                    cin >> ret;
                    if(ret == "Yes")
                    {
                        cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                        go = false;
                    }
                }
    }
}
