#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <map>

using namespace std;

const int MAX = (int)1e6 + 13;

int n, q;

int a[MAX];

int old_bit(int x, int y) {
	int ans = -1;
	for (int i = 0; i < 30; i++) {
		if ((x & (1 << i)) != (y & (1 << i)))
			ans = i;
	}
	return ans;
}

int solve() {
	map<int, int> mp;

	for (int i = 1; i < n; i++) {
		int x = a[i], y = a[i + 1];
		int b = old_bit(x, y);
		int need = (x > y);
		if (mp.find(b) != mp.end()) {
			if (mp[b] != need)
				return -1;
		}
		else {
			mp[b] = need;
		}
	}

	int ans = 0;

	for (auto it = mp.begin(); it != mp.end(); ++it) {
		ans += (1 << (it->first)) * it->second;
	}

	return ans;
}

int main() {
	//ifstream cin("tests.txt");
	
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}

	cout << solve() << endl;

	cin >> q;

	for (int i = 1; i <= q; i++) {
		int pos, val;
		cin >> pos >> val;
		a[pos] = val;
		cout << solve() << endl;
	}

	return 0;
}

