#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <map>

using namespace std;

const int MAX = 13;

int n, q;

struct point {
	long long x, y;
	point() {}
	point(long long a, long long b) {
		x = a;
		y = b;
	}
};

point p[MAX];

bool ask(int a, int b, int c) {
	cout << "? " << 3 << ' ' << a << ' ' << b << ' ' << c << endl;
	cout.flush();
	string ans;
	cin >> ans;
	cout.flush();
	return (ans == "Yes");
}

void out(int a, int b, int c) {
	cout << "! " << 3 << ' ' << a << ' ' << b << ' ' << c << endl;
	cout.flush();
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> p[i].x >> p[i].y;
	}

	cin >> q;

	for (; q > 0; q--) {
		int a, b, c;
		a = b = c = -1;
		for (int i = 1; i <= n && a == -1; i++) {
			for (int j = i + 1; j <= n && a == -1; j++) {
				for (int k = j + 1; k <= n && a == -1; k++) {
					if (ask(i, j, k)) {
						a = i;
						b = j;
						c = k;
					}
				}
			}
		}

		out(a, b, c);
	}
	return 0;
}

