#define _CRT_SECURE_NO_DEPRECATE

#include<cstring>
#include<string>
#include<vector>
#include<map>
#include<map>
#include<set>
#include<iostream>
#include<algorithm>

using namespace std;
typedef long long ll;
#define mp(x,y) make_pair(x, y)
void solve();
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();
}


int n, m;
const int maxn = 1000;
ll go[maxn][maxn];
pair<ll, ll> rs[maxn];
bool cmp(pair<ll, ll> lhs, pair<ll, ll> rhs) {
	if (lhs.first == rhs.first)return lhs.second > rhs.second;
	return lhs.first < rhs.first;
}
struct Z {
	pair<ll, ll> p;
	int second;
	Z(pair<ll, ll> p, int nom) :second(nom), p(p) {};
};
bool operator<(Z lhs, Z rhs) {
	if (lhs.p.first == rhs.p.first && lhs.p.second == rhs.p.second)return lhs.second < rhs.second;
	return cmp(lhs.p, rhs.p);
}
set<Z> s;
vector<int> p;
vector<ll> r;

void solve() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	memset(go, -1, sizeof(go));
	for (int i = 0; i < m; ++i) {
		int s;
		cin >> s;
		p.clear();
		r.clear();
		for (int t, i = 0; i < 2 * s + 1; ++i) {
			cin >> t;
			if (i & 1)r.push_back(t);
			else p.push_back(--t);
		}
		for (int i = 0; i < s; ++i) {
			ll rss = 0;
			for (int j = i + 1; j <= s; ++j) {
				rss += r[j - 1];
				if (go[p[i]][p[j]] == -1)
					go[p[i]][p[j]] = rss;
				else
					go[p[i]][p[j]] = min(go[p[i]][p[j]], rss);
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		rs[i].first = 1ll << 50;
		rs[i].second = 0;
		s.insert(Z(rs[i], i));
	}

	rs[0].first = 0;
	rs[0].second = 0;
	s.insert(Z(rs[0], 0));

	while (!s.empty()) {
		auto j = *s.begin();
		s.erase(s.begin());
		for (int i = 0; i < n; ++i)
			if (go[j.second][i] > -1) {
				rs[j.second].first += go[j.second][i];
				rs[j.second].second += go[j.second][i] * go[j.second][i];
				if (cmp(rs[j.second], rs[i])) {
					s.erase(Z(rs[i], i));
					rs[i].first = rs[j.second].first;
					rs[i].second = rs[j.second].second;
					s.insert(Z(rs[i], i));
				}
				rs[j.second].first -= go[j.second][i];
				rs[j.second].second -= go[j.second][i] * go[j.second][i];
			}
	}
	cout << rs[n - 1].first << ' ' << rs[n - 1].second << endl;
	exit(0);
}