#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <stack>
#include <set>
#include <algorithm>
#include <math.h>
#define p(x,y) pair<x,y>
#define p3(x,y,z) p(p(x,y),z)
#define X first
#define Y second
#define SZ(v) (int)v.size()
using namespace std;
typedef long long ll;
typedef long double ld;
void solve();
const long long INF = (1LL << 61);
const int inf = 2e9;
int main() {
#ifdef _DEBUG
//	freopen("input.txt", "r", stdin);
#endif
	solve();
}
const int N = 5005;
const int lg = 30;
int n, x, y, q, ind;
vector<p(ld, ld)> all;
vector<int> idx;
bool comp(int i, int j) {
	ld alpha = atan2(all[i].Y - all[ind].Y, all[i].X - all[ind].Y);
	ld beta = atan2(all[j].Y - all[ind].Y, all[j].X - all[ind].Y);
	return alpha > beta;
}
ld S(int i, int j, int k) {
	ld a = sqrt((all[i].X - all[j].X) * (all[i].X - all[j].X) + (all[i].Y - all[j].Y) * (all[i].Y - all[j].Y));
	ld b = sqrt((all[i].X - all[k].X) * (all[i].X - all[k].X) + (all[i].Y - all[k].Y) * (all[i].Y - all[k].Y));
	ld c = sqrt((all[k].X - all[j].X) * (all[k].X - all[j].X) + (all[k].Y - all[j].Y) * (all[k].Y - all[j].Y));
	ld p = (a + b + c) / 2.0;
	return p * (p - a) * (p - b) * (p - c);
}
void solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		all.push_back({ x,y });
	}
	cin >> q;
	while (q--) {
		ld best = 1e18;
		int a = -1, b = -1, c = -1;
		for (ind = 0; ind < n; ind++) {
			idx.clear();
			for (int i = 0; i < n; i++)if (ind != i)idx.push_back(i);
			sort(idx.begin(), idx.end());
			for (int j = 0; j < n - 1; j++) {
				int ind1 = idx[j];
				int ind2 = idx[(j + 1) % (n - 1)];
				ld SS = S(ind, ind1, ind2);
				cout << "? 3 " << ind + 1 << " " << ind1 + 1 << " " << ind2 + 1 << endl;
				string res;
				cin >> res;
				ld EPS = 1e-6;
				if (res == "Yes" && best > SS - EPS) {
					best = SS;
					a = ind + 1;
					b = ind2 + 1;
					c = ind1 + 1;
				}
			}
		}
		cout << "! 3 " << a << " " << b << " " << c << endl;
	}
}