#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define len(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < n; ++i)
#define int long long

using namespace std;

const double pi = acos(-1);
double EPS = 1e-7;

struct Point {
    int x, y;
    Point() = default;
    Point(int x, int y) : x(x), y(y) {}
};

struct Vector {
    int x, y;
    Vector() = default;
    Vector(int x, int y) : x(x), y(y) {}
    Vector(Point a, Point b) : x(b.x - a.x), y(b.y - a.y) {}
    int operator^(Vector b) { // скалярное
        return x * b.x + y * b.y;
    }
    int operator*(Vector b) { // векторное
        return x * b.y - y * b.x;
    }
};

double angle(Vector a, Vector b) {
    return atan2(a * b, a ^ b);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen(".in", "r", stdin);
    int n;
    cin >> n;
    vector<Point> a(n);
    forn(i, n) cin >> a[i].x >> a[i].y;
    vector<vector<int> > tr;
    forn(i, n) {
        forn(j, i) {
            forn(k, j) {
                bool fl = 1;
                forn(l, n) {
                    if (l == i || l == j || l == k) continue;
                    double an = 0;
                    an += angle(Vector(a[l], a[i]), Vector(a[l], a[k]));
                    an += angle(Vector(a[l], a[k]), Vector(a[l], a[j]));
                    an += angle(Vector(a[l], a[j]), Vector(a[l], a[i]));
                    if (fabs(an - 2 * pi) < EPS) {
                        fl = 0;
                        break;
                    }
                }
                //cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                tr.pb({i + 1, j + 1, k + 1});
            }
        }
    }
    int q;
    cin >> q;
    forn(i, q) {
        forn(j, len(tr)) {
            cout << "? " << tr[j][0] << ' ' << tr[j][1] << ' ' << tr[j][2] << endl;
            string s;
            cin >> s;
            if (s == "Yes") {
                cout << "! " << tr[j][0] << ' ' << tr[j][1] << ' ' << tr[j][2] << endl;
                break;
            }
        }
    }
    return 0;
}
