#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define len(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define int long long

using namespace std;

struct Segment {
    int l, r, t;
    Segment() = default;
    Segment(int l, int r, int t) : l(l), r(r), t(t) {}
    bool operator<(Segment x) const {
        return r - l < x.l - x.r;
    }
};


void solve() {
    string a, b;
    cin >> a >> b;
    int k = 0;
    int n = len(a);
    vector<Segment> p, q;
    a += '3';
    b += '3';
    forn(i, n + 1) {
        if (i == 0 || a[i] == a[i - 1]) {
            k++;
        }
        else {
            int t = 0;
            if (a[i - 1] == '+') t = 1;
            p.pb({i - k, i - 1, t});
            k = 1;
        }
    }
    k = 0;
    forn(i, n + 1) {
        if (i == 0 || b[i] == b[i - 1]) {
            k++;
        }
        else {
            int t = 0;
            if (b[i - 1] == '+') t = 1;
            q.pb({i - k, i - 1, t});
            k = 1;
        }
    }
    int i = 0;
    forn(j, len(q)) {
        int i0 = i;
        while (p[i].r < q[j].r) i++;
        if (p[i].r != q[j].r) {
            cout << "No" << endl;
            return;
        }
        int k = i - i0 + 1;
        int ma = -1, l, r;
        forn(h, k) {
            if (p[i0 + h].t == q[j].t && p[i0 + h].r - p[i0 + h].l + 1 > ma) {
                ma = p[i0 + h].r - p[i0 + h].l + 1;
                l = h;
                r = h;
            }
        }
        if (ma == -1) {
            cout << "No" << endl;
            return;
        }
        int sz = ma;
        while (l > i0 || r < i) {
            if (l > i0 && p[l - 1].t == q[j].t) {
                l--;
                sz += p[l].r - p[l].l + 1;
            }
            else if (l > i0 && p[l - 1].t != q[j].t && p[l - 1].r - p[l - 1].l + 1 < sz) {
                l--;
                sz += p[l].r - p[l].l + 1;
            }
            else if (r < i && p[r + 1].t == q[j].t) {
                r++;
                sz += p[r].r - p[r].l + 1;
            }
            else if (r < i && p[r + 1].t != q[j].t && p[r + 1].r - p[r + 1].l + 1 < sz) {
                r++;
                sz += p[r].r - p[r].l + 1;
            }
            else {
                //cout << l << ' ' << r << ' ' << sz << endl;
                cout << "No" << endl;
                return;
            }
        }
        if (i < len(p) - 1) {
            if (p[i + 1].t == q[j].t) {
                cout << "No" << endl;
                return;
            }
        }

    }
    cout << "Yes" << endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    //freopen("a.in", "r", stdin);
    //freopen(".out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
