#include <iostream>

using namespace std;

int different_bit(int a, int b, int val) {
  a ^= val;
  b ^= val;
  for (int i = 30; i >= 0; i--) {
    int A = ((a >> i) & 1), B = ((b >> i) & 1);
    if (A != B) return i;
  }
  return -1;
}

int n = 0;
int *arr;
int getNumber() {
  int number = 0;
  for (int j = n - 2; j >= 0; j--) {
      if (arr[j] > arr[j + 1]) {
        int bit = different_bit(arr[j], arr[j + 1], number);

        if (number == -1) {
          number = (1 << bit);
        } else {
          if (((number >> bit) & 1 == 1)) return -1;
          number |= (1 << bit);
        }
      }
  }

  for (int j = 0; j < n - 1; j++) {
    if ((arr[j] ^ number) > (arr[j + 1] ^ number))
        return -1;
  }

  return number;
}

int main() {
  cin >> n;
  arr = new int[n];
  for (int i = 0; i < n; i++) cin >> arr[i];
  cout << getNumber() << endl;
  int q = 0;
  cin >> q;
  for (int i = 0; i < q; i++) {
    int p, v;
    cin >> p >> v;
    arr[p - 1] = v;
    cout << getNumber() << endl;
  }
  return 0;
}
