#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "internship"
#define inb push_back
#define X first
#define Y second

const int M = 5e5 + 5;
int n, m;
int a[M], x[M], b[M], y[M];
ll px[M], py[M];
map<int, int> z;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	for (int i = 1; i <= n; ++i)
		cin >> x[i];
	for (int i = 1; i <= n; ++i)
		px[i] = px[i - 1] + x[i];
	for (int i = 1; i <= m; ++i)
		cin >> b[i], z[b[i]] = i;
	for (int i = 1; i <= m; ++i)
		cin >> y[i];
	for (int i = 1; i <= m; ++i)
		py[i] = py[i - 1] + y[i];
	ll ans = px[M], l1 = 1, r1 = n, l2 = 0, r2 = 0;
	if (py[m] > ans)
		ans = py[m], l1 = r1 = 0, l2 = 1, r2 = m;
	for (int i = 1; i <= n; ++i)
		for (int j = i; j <= n; ++j)
		{
			vector<int> d;
			for (int k = i; k <= j; ++k) d.inb(z[a[k]]);
			sort(d.begin(), d.end());
			for (int k = 0; k < d.size(); ++k)
			{
				if (!k && py[d[k] - 1] + px[j] - px[i - 1] > ans)
					ans = py[d[k] - 1], l1 = i, r1 = j, l2 = 1, r2 = d[k] - 1;
				if (k && py[d[k] - 1] - py[d[k - 1]] + px[j] - px[i - 1] > ans)
					ans = py[d[k] - 1] - py[d[k - 1]] + px[j] - px[i - 1], l1 = i, r1 = j, l2 = d[k - 1] + 1, r2 = d[k] - 1;
				if (k == d.size() - 1 && py[m] - py[d[k]] + px[j] - px[i - 1] > ans)
					ans = py[m] - py[d[k]] + px[j] - px[i - 1], l1 = i, r1 = j, l2 = d[k] + 1, r2 = m;
			}
		}
	cout << ans << '\n' << l1 << ' ' << r1 << '\n' << l2 << ' ' << r2;
}