#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <algorithm>
#define ll long long
#define mp make_pair
#define MOD 1000000007

using namespace std;

struct vect {
    ll x, y;
};

const int mx = 500;
ll n, q;
vector<vect> p;

vect make_point(ll x, ll y) {
    vect res;
    res.x = x;
    res.y = y;
    return res;
}

vect make_vector(vect p1, vect p2) {
    vect res;
    res.x = p2.x - p1.x;
    res.y = p2.y - p1.y;
    return res;
}

ll p_scal(vect v1, vect v2) {
    return v1.x*v2.x + v1.y*v2.y;
}

ll p_vect(vect v1, vect v2) {
    return v1.x*v2.y - v1.y*v2.x;
}

bool inside(vect p1, vect p2, vect p3, vect pp) {
    ll vct1 = p_vect(make_vector(p1, p2), make_vector(p1, pp));
    ll vct2 = p_vect(make_vector(p2, p3), make_vector(p2, pp));
    ll vct3 = p_vect(make_vector(p3, p1), make_vector(p3, pp));
    if ((vct1 > 0) && (vct2 > 0) && (vct3 > 0))
        return 1;
    if ((vct1 < 0) && (vct2 < 0) && (vct3 < 0))
        return 1;
    return 0;
}

int main()
{
    string s;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    ll x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        p.push_back(make_point(x, y));
    }
    cin >> q;
    for (int h = 0; h < q; ++h) {
        bool B = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = (i+1); j < n; ++j) {
                for (int i1 = (j+1); i1 < n; ++i1) {
                    bool b = 1;
                    for (int i2 = 0; i2 < n; ++i2) {
                        if (inside(p[i], p[j], p[i1], p[i2])) {
                            b = 0;
                            break;
                        }
                    }
                    if (b == 1) {
                        cout << "? 3 " << i+1 << " " << j+1 << " " << i1+1 << endl;
                        cin >> s;
                        if (s == "Yes") {
                            cout << "! 3 " << i+1 << " " << j+1 << " " << i1+1 << endl;
                            B = 1;
                            break;
                        }
                    }
                }
                if (B == 1)
                    break;
            }
            if (B == 1)
                break;
        }
    }
    return 0;
}
