#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

#define int int64_t

const int MAXN = 2e5;

int l[MAXN], r[MAXN], t[MAXN];
int n;

int dpl[MAXN];
int dpr[MAXN];

int ansl[MAXN], ansr[MAXN];

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < n - 1; i++)
        cin >> l[i] >> r[i];
    dpl[n - 1] = 0;
    dpr[n - 1] = 1e9;

    for (int i = n - 2; i >= 0; i--) {
        int q = dpl[i + 1], w = dpr[i + 1];
        dpl[i] = max(l[i] - t[i], max(q, l[i]));
        dpr[i] = min(r[i], w);
        if (q <= l[i] && l[i] <= w)
            dpl[i] = min(dpl[i], l[i] - t[i]), dpr[i] = max(dpr[i], l[i]);
    }

    for (int i = 0; i < n; i++)
        ansl[i] = dpl[i], ansr[i] = dpr[i];

    dpl[0] = 0, dpr[0] = 1e9;
    for (int i = 1; i < n; i++) {
        int q = dpl[i - 1], w = dpr[i - 1];
        dpl[i] = max(l[i - 1] - t[i], max(q, l[i - 1]));
        dpr[i] = min(r[i - 1], w);
        if (q <= l[i - 1] && l[i - 1] <= w)
            dpl[i] = min(dpl[i], l[i - 1] - t[i]), dpr[i] = max(dpr[i], l[i - 1]);
    }

    for (int i = 0; i < n; i++) {
        ansl[i] = max(ansl[i], dpl[i]);
        ansr[i] = min(ansr[i], dpr[i]);
    }

    for (int i = 0; i < n; i++) {
        if (ansl[i] > ansr[i])
            cout << -1 << endl;
        else
            cout << ansl[i] << endl;
    }

    return 0;
}
