#include<iostream>
#include<vector>
#include<string>
#include<queue>
#include<map>

using namespace std;

#define int long long

const int d = 1e9;
const int inf = 4e18;
map<pair<int, int>, int> ff;
vector<int> l, r, c;
int n, lim;

int f(int w, int cc) {
	if (ff.count({ w, cc }))
		return ff[{w, cc}];
	int mx = w * d - cc;
	for (int i = 0; i < n; i++) {
		if (w + r[i] > lim)
			continue;
		int mn = inf;
		for (int x = l[i]; x <= r[i]; x++)
			mn = min(mn, f(w + x, cc + c[i]));
		mx = max(mx, mn);
	}
	ff[{w, cc}] = mx;
	return mx;
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	ios_base::sync_with_stdio(false);
	cin >> n >> lim;
	l.resize(n);
	r.resize(n);
	c.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> c[i];
	}
	cout << f(0, 0);
}