#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e6, logn = 30;

struct vertex{
    multiset<int> s;
    vertex* to[2] = {0};
};

int mn(vertex *v){
    return *(v->s.begin());
}

int mx(vertex *v){
    return *(v->s.rbegin());
}

int f1[logn], f0[logn];
int bad = 0;

vertex *root = new vertex;

void check(vertex *v, int p, int k){
    vertex *l = v->to[0], *r = v->to[1];
    if(!l || !r || l->s.empty() || r->s.empty()) return;
    //cerr << "# " << p << " " << k << " : " << mn(l) << " " << mx(l) << " " << mn(r) << " " << mx(r) << endl;
    if(mn(l) < mn(r)){
        f0[p] += k;
        if(mx(l) > mn(r)) bad += k;
    }
    else{
        f1[p] += k;
        if(mx(r) > mn(l)) bad += k;
    }
}

int upd(int x, int y, int k){
    vertex *v = root;
    for(int i = logn-1; i >= 0; i--){
        check(v, i, -1);
        bool p = x>>i&1;
        if(!v->to[p]) v->to[p] = new vertex;
        vertex *u = v->to[p];
        if(k > 0) u->s.insert(y);
        else u->s.erase(y);
        check(v, i, 1);
        //cerr << x << " " << y << " " << k << " : " << i << " " << p << " " << bad << endl;
        v = u;
    }
}

int a[maxn];

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n; i++)
        cin >> a[i], upd(a[i], i, 1);

    int q;
    cin >> q;

    for(int j = 0; j <= q; j++){
        int k = 0, x = a[0];
        if(j > 0){
            cin >> k >> x;
            k--;
        }
        upd(a[k], k, -1);
        upd(x, k, 1);
        a[k] = x;
        int ans = 0;
        bool good = 1;
        for(int i = 0; i < logn; i++){
            if(f1[i] && f0[i]) good = 0;
            if(f1[i]) ans ^= (1<<i);
        }
        if(good && bad == 0) cout << ans << "\n";
        else cout << "-1\n";
        //cerr << "# " << bad << endl;
    }

    return 0;
}
