#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int N = 2e6 + 1;
const int M = 1e2 + 1;

ll dp[N];

struct lol
{
    int l, r, c;
};

vector <lol> e;

struct min_stack
{
    stack <int> st;
    stack <int> mn;
    void push(int x)
    {
        if (st.size() == 0)
        {
            st.push(x);
            mn.push(x);
        }
        else
        {
            st.push(x);
            mn.push((dp[x] < dp[mn.top()] ? x : mn.top()));
        }
    }
    void pop()
    {
        st.pop();
        mn.pop();
    }
};

struct min_qu
{
    min_stack in, out;
    void push(ll x)
    {
        in.push(x);
    }
    void pop()
    {
        if (out.st.size() == 0)
        {
            while (in.st.size() > 0)
            {
                out.push(in.st.top());
                in.pop();
            }
        }
        out.pop();
    }
    ll get()
    {
        int res = -1;
        if (in.st.size() > 0)
        {
            if (res == -1 || dp[in.mn.top()] < dp[res])
            {
                res = in.mn.top();
            }
        }
        if (out.st.size() > 0)
        {
            if (res == -1 || dp[out.mn.top()] < dp[res])
            {
                res = out.mn.top();
            }
        }
        return dp[res];
    }
};

min_qu s[M];

int main()
{
    ios::sync_with_stdio(0);
    int n, a;
    cin >> n >> a;
    for (int i = 0; i < n; i++)
    {
        int l, r, c;
        cin >> l >> r >> c;
        e.push_back({l, r, c});
    }
    vector <int> vl(n, -1), vr(n, - 1);
    for (int sum = a; sum >= 0; sum--)
    {
        dp[sum] = (ll) 1e9 * sum;
        for (int i = 0; i < n; i++)
        {
            int l = e[i].l, r = e[i].r, c = e[i].c;
            if (sum + r > a)
            {
                continue;
            }
            if (sum + r + 1 > a)
            {
                for (int j = r; j >= l; j--)
                {
                    s[i].push(sum + j);
                }
            }
            else
            {
                s[i].pop();
                s[i].push(sum + l);
            }
            dp[sum] = max(dp[sum], s[i].get() - (ll) 1e9 * sum - c + (ll) 1e9 * sum);
        }
    }
    cout << dp[0] << '\n';
}
