#include <cmath>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cstring>

#pragma warning( disable : 4996)

#define all(x) x.begin(),x.end()
#define forn(i_, s_, f_) for(int i_ = s_; i_  < f_; i_++)
#define ff first
#define ss second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int MAXN = 2 * 1e5 + 10;

int t[MAXN];
int l[MAXN];
int r[MAXN];
int n = 0;

bool check(int x, int m) {
	int time = m;
	forn(i, x, n - 1) {
		if (l[i] <= time && time <= r[i]) {
			continue;
		}
		if (time > r[i]) {
			return false;
		}
		int wait = l[i] - time;
		if (wait > t[i]) {
			return false;
		}
		time = l[i];
	}

	time = m;
	for (int i = x - 1; i >= 0; i--) {
		if (l[i] <= time && time <= r[i]) {
			continue;
		}
		if (time > r[i]) {
			return false;
		}
		int wait = l[i] - time;
		if (wait > t[i + 1]) {
			return false;
		}
		time = l[i];
	}

	return true;
}

int solve(int x) {
	int tm = -1;
	if (n > 500) {
		//forn(i, 0, 1) {
			if (check(x, 0)) {
				return (0);
			}
		//}
		return -1;
	}
	forn(i, 0, 500 + 1) {
		if (check(x, i)) {
			return (i);
		}
	}

	return tm;
}

int main() {
	freopen("servers.in", "r", stdin);
	freopen("servers.out", "w", stdout);
	scanf("%d", &n);
	
	forn(i, 0, n) {
		scanf("%d", &t[i]);
	}
	forn(i, 0, n - 1) {
		scanf("%d %d", &l[i], &r[i]);
	}

	forn(i, 0, n) {
		int ans = solve(i);
		printf("%d\n", ans);
	}
	//printf("\n");

	fclose(stdin);
	fclose(stdout);
	return 0;
}