#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>
#include <stack>
using namespace std;
/*
const int maxn = 10007;
struct dis
{
    int n;
    int r;
    dis(int n,int r ): n(n),r(r){}
    dis():n(),r(){}
};

dis a[maxn];
dis b[maxn];
bool used[maxn] = {0};
int64_t s[maxn] = {0};
void ob()
int main()
{
    freopen("internship.in","r",stdin);
    freopen("internship.out","w",stdout);
    int n;
    int m;
    cin >> n >> m;
    for(int i = 1; i <= n; ++i)
        scanf("%d",&a[i].n);
    for(int i = 1; i <= n; ++i)
        scanf("%d",&a[i].r);
    for(int i = 1; i <= m; ++i)
        scanf("%d",&b[i].n);
    for(int i = 1; i <= m; ++i)
        scanf("%d",&b[i].r);
    int la,ra,lb,rb;
    int64_t res = 0;
    int64_t t = 0;
    for(int i = 1; i <= n; ++i)
        t += a[i].r;
    if(res < t)
    {
        res = t;
        la = 1;
        ra = n;
        lb = 0;
        rb = 0;
    }
    t = 0;
    for(int i = 1; i <= m; ++i)
        t += b[i].r;
    if(res < t)
    {
        res = t;
        la = 0;
        ra = 0;
        lb = 1;
        rb = m;
    }
    for(int i = 1; i <= n; ++i)
    {
            int64_t t1 = 0;
            for(int i2 = i; i2 <= n; ++i2)
            {
                used[a[i2].n] = true;
                t1 += a[i2].r;
            }
            for(int i1 = 1; i1 <= m; ++i)
            {
                if(!used[i1])
                    s[i1] = b[i1].r;
            }
            t = 0;
            int st = 0;
            for(int i2 = 1; i2 <= m; ++i2)
            {
                if(used[b[i2].n])
                {
                    st = i2;
                    t = 0;
                }
                else
                {
                    t +=b[i2].r;
                    if(res < t+t1)
                    {
                        res = t+t1;
                        la = i;
                        ra = i1;
                        lb = st+1;
                        rb = i2;
                    }
                }

            }
            for(int i1 = 0; i1 <= n+m; ++i1)
                used[i1] = false;
        }
    cout << res << '\n' << la << ' ' << ra << '\n' << lb << ' ' << rb <<'\n';
    return 0;
}
*/
/*
7 5
3 1 4 8 6 9 2
2 7 4 10 1 5 3
9 2 11 3 8
3 5 3 4 12
*/

struct kol
{
    int v;
    int c;
    kol(int v,int c): v(v),c(c){}
    kol():v(0),c(0){}
    operator <(const kol &a)const
    {
        if(a.v != v)
            return v < a.v;
        return c > a.c;
    }
    operator >(const kol &a)const
    {
        if(a.v != v)
            return v > a.v;
        return c < a.c;
    }
};
struct op
{
    int l;
    int r;
    int c;
    op(int l,int r,int c): l(l),r(r),c(c){}
    op():l(0),r(0),c(0){}
};
const int maxd = 1024*1024;
const int maxn = 105;
kol dp[maxd/2];
op ex[maxn];
kol tr[maxd];
void ism(int n,kol x)
{
    tr[maxd/2-1+n] = x;
    for(int i = (maxd/2-1+n)/2;; i/=2)
    {
        tr[i] = min(tr[i*2+1],tr[i*2+2]);
        if(i == 0)
            break;
    }
}
kol men(int l,int r,int li,int ri,int i)
{
    if(li >= l && ri <= r)
        return tr[i];
    if(li > r || ri < l)
        return kol(maxd,0);
    int t = (li +ri)/2;
    return min(men(l,r,li,t,i*2+1),men(l,r,t+1,ri,i*2+2));
}
int main()
{
    freopen("anti.in","r",stdin);
    freopen("anti.out","w",stdout);
    int n,a;
    cin >> n >> a;
    for(int i = 0; i < n; ++i)
        scanf("%d%d%d",&ex[i].l,&ex[i].r,&ex[i].c);
    dp[a] = kol(a,0);
    ism(a,dp[a]);
    for(int i = a-1; i >= 0; --i)
    {
        dp[i] = kol(i,0);
        for(int i1 = 0; i1 < n; ++i1)
        {
            if(ex[i1].r+i <= a)
            {
                kol t = men(i+ex[i1].l,i+ex[i1].r,0,maxd/2-1,0);
                dp[i] = max(dp[i],kol(t.v,t.c+ex[i1].c));
            }
        }
        ism(i,dp[i]);
    }
    int64_t v = dp[0].v;
    int64_t c = dp[0].c;
    int64_t m = 1000000000;
    cout << v*m-c;
    return 0;
}



/*
const int maxn = 200005;
const int maxt = 1000000007;

struct pr
{
    int l;
    int r;
    pr(int l,int r):l(l),r(r){}
    pr():l(-1),r(-1){}
};

pr sl[maxn];
pr vp[maxn];
pr nas[maxn];
int h[maxn];


int main()
{
    freopen("servers.in","r",stdin);
    freopen("servers.out","w",stdout);
    int n;
    cin >> n;
    for(int i = 1; i <= n; ++i)
        scanf("%d",&h[i]);
    for(int i = 1; i <= n-1; ++i)
        scanf("%d%d",&sl[i].l,&sl[i].r);
    vp[n] = pr(0,maxt);
    nas[1] = pr(0,maxt);
    for(int i = n-1; i >= 1; --i)
    {
        if(vp[i+1].r == -1)
            vp[i] = pr(-1,-1);
        else if(sl[i].l > vp[i+1].r || sl[i].r < vp[i+1].l)
            vp[i] = pr(-1,-1);
        else
        {
            if(sl[i].l < vp[i+1].l)
                vp[i].l = vp[i+1].l;
            else
                vp[i].l = max(0,sl[i].l-h[i]);
            vp[i].r = min(sl[i].r,vp[i+1].r);
        }
    }
    for(int i = 2; i <= n; ++i)
    {
        if(nas[i-1].r == -1)
            nas[i] = pr(-1,-1);
        else if(sl[i-1].l > nas[i-1].r || sl[i-1].r < nas[i-1].l)
            nas[i] = pr(-1,-1);
        else
        {
            if(sl[i-1].l < nas[i-1].l)
                nas[i].l = nas[i-1].l;
            else
                nas[i].l = max(0,sl[i-1].l-h[i]);
            nas[i].r = min(sl[i-1].r,nas[i-1].r);
        }
    }
    for(int i = 1; i <= n; ++i)
    {
        int t = 0;
        if(nas[i].r == -1 || vp[i].r == -1)
            t = -1;
        else if(nas[i].l > vp[i].r || nas[i].r < vp[i].l)
            t = -1;
        else
            t = max(vp[i].l,nas[i].l);
        printf("%d\n",t);
    }
    return 0;
}
*/


/*
const int maxn = 1000005;
bool ism[maxn] = {0};
int dl[maxn] = {0};
int nex[maxn] = {0};
int pred[maxn] = {0};
char polog[maxn] = {0};
stack<int> men;

bool obied(int v,int yk)
{
    if(nex[v] > yk || nex[v] < 0 || nex[nex[v]] < 0)
        return false;
    if(ism[v] == ism[nex[v]])
        return false;
    if(ism[v] && dl[v] < dl[nex[v]])
        return true;
    if(!ism[v] && dl[v] > dl[nex[v]])
        return true;
    return false;
}

void obrpos(int yk)
{
    int v = men.top();
    men.pop();
    //cout << v << ' ';
    if(!obied(v,yk))
        return;
    if(ism[v])
    {
        polog[v] = polog[nex[v]];
        ism[v] = false;
        dl[v] += dl[nex[v]];
        if(pred[v] >= 0 && nex[pred[v]] == v)
        {
            dl[v] += dl[pred[v]];
            int p = pred[v];
            pred[v] = pred[pred[v]];
            nex[p] = -1;
        }
        int n = nex[v];
        nex[v] = nex[nex[v]];
        nex[n] = -1;
        if(nex[v] <= yk)
            pred[nex[v]] = v;
        if(pred[v] >= 0)
            nex[pred[v]] = v;
    }
    else
    {
        v = nex[v];
        polog[v] = polog[pred[v]];
        ism[v] = false;
        dl[v] += dl[pred[v]];
        if(nex[v] <= yk)
        {
            dl[v] += dl[nex[v]];
            int n = nex[v];
            nex[v] = nex[nex[v]];
            nex[n] = -1;
        }
        int p = pred[v];
        pred[v] = pred[pred[v]];
        nex[p] = -1;
        if(nex[v] <= yk)
            pred[nex[v]] = v;
        if(pred[v] >= 0)
            nex[pred[v]] = v;
    }
    if(obied(v,yk))
        men.push(v);
    if(pred[v] >= 0 && obied(pred[v],yk))
        men.push(pred[v]);
}
int main()
{
    freopen("storage.in","r",stdin);
    freopen("storage.out","w",stdout);
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        string s;
        string t;
        cin >> s >> t;
        int yk = 0;
        for(int i1 = 0; i1 < s.size();++i1)
        {
            if(i1 == 0)
            {
                polog[yk] = s[i1];
                dl[yk] = 1;
                nex[yk] = yk+1;
                pred[yk] = yk-1;
            }
            else
            {
                if(s[i1] != s[i1-1])
                    ++yk;
                polog[yk] = s[i1];
                nex[yk] = yk+1;
                pred[yk] = yk-1;
                dl[yk]++;
            }
        }
        bool good = true;
        int yk2 = 0;
        for(int i1 = 0; i1 <= yk; ++i1)
        {
            ism[i1] = (s[yk2] != t[yk2]);
            for(int i2 = 1; i2 < dl[i1]; ++i2)
                if(ism[i1] != (s[yk2+i2] != t[yk2+i2]))
                    good = false;
            yk2+=dl[i1];
        }
        if(!good)
            printf("No\n");
        else
        {
            for(int i1 = 0; i1 <= yk; ++i1)
                if(obied(i1,yk))
                    men.push(i1);
            while(!men.empty())
            {
                obrpos(yk);
            }
            for(int i1 = 0; i1 <= yk; ++i1)
                if(ism[i1])
                    good = false;
            if(good)
                printf("Yes\n");
            else
                printf("No\n");
        }
        for(int i1 = 0; i1 <= yk; ++i1)
            dl[i1] = 0;
    }
    return 0;
}
*/
