#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define endl '\n'

const bool judge = true, stress = false;

int cnt_tests = 1;

typedef long long llong;

const int INF = 2e9 + 29;
const llong LINF = 4e18 + 17;

// JUST DO IT!

// Code below

int n, m;

const int N = 1002;

vector<pair<int, llong> > graph[N];

void inp() {
    cin >> n >> m;
    int cnt, prev, x;
    llong val;
    for (int i = 0; i < m; i++) {
        cin >> cnt;
        cin >> prev;
        for (int j = 0; j < cnt; j++) {
            cin >> val >> x;
            graph[prev].pb({x, val});
            prev = x;
        }
    }
}

pair<llong, llong> dist[N];
bool used[N];

void solve() {
    for (int i = 0; i < N; i++) {
        dist[i] = {LINF, -LINF};
    }
    dist[1] = {0, 0};
    for (;;) {
        int v = -1;
        for (int j = 1; j <= n; j++) {
            if (!used[j]) {
                if (v == -1) {
                    v = j;
                } else {
                    if (dist[j].fi < dist[v].fi) {
                        v = j;
                    } else if (dist[j].fi == dist[v].fi && dist[j].se > dist[v].se) {
                        v = j;
                    }
                }
            }
        }
        if (v == -1) {
            break;
        }
        used[v] = true;
        for (auto u: graph[v]) {
            if (dist[u.fi].fi > dist[v].fi + u.se) {
                dist[u.fi].fi = dist[v].fi + u.se;
                dist[u.fi].se = dist[v].se + u.se * u.se;
            } else if (dist[u.fi].fi == dist[v].fi + u.se && dist[u.fi].se < dist[v].se + u.se * u.se) {
                dist[u.fi].fi = dist[v].fi + u.se;
                dist[u.fi].se = dist[v].se + u.se * u.se;
            }
        }
    }
    cout << dist[n].fi << ' ' << dist[n].se << endl;
}

void run() {
    if (!stress) {
        inp();
        solve();
        cout << endl;
    }
}

int main() {
    srand(time(0));
    if (!judge) {
        freopen("input.txt", "r", stdin);
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    }
    for (int i = 0; i < cnt_tests; i++) {
        run();
    }
}
