#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)2e5 + 7;
const int inf = (int)1e9 + 7;

int t[dd];
pair<int, int> P[dd], L[dd];
pair<int, int> R[dd], Le[dd];
int okR[dd], okL[dd];

int solve() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", &t[i]);
	for (int i = 0; i < n - 1; ++i) {
		int l, r;
		scanf("%d %d", &l, &r);
		P[i + 1] = { l, r };
		L[i] = { l, r };
	}
	R[n - 1] = { 0, inf };
	okR[n - 1] = 1;

	for (int i = n - 2; i >= 0; --i) {
		okR[i] = okR[i + 1];
		int l = L[i].first, r = L[i].second;
		if (R[i + 1].first >= l)
			if (R[i + 1].first > r)
				okR[i] = 0;
			else
				R[i] = { R[i + 1].first, min(r, R[i + 1].second) };
		else
			if (R[i + 1].second < l)
				okR[i] = 0;
			else
				R[i] = { max(0, l - t[i]), min(r, R[i + 1].second) };
	}

	Le[0] = { 0, inf };
	okL[0] = 1;
	for (int i = 1; i < n; ++i) {
		okL[i] = okL[i - 1];
		int l = P[i].first, r = P[i].second;
		if (Le[i - 1].first >= l)
			if (Le[i - 1].first > r)
				okL[i] = 0;
			else
				Le[i] = { Le[i - 1].first, min(r, Le[i - 1].second) };
		else
			if (Le[i - 1].second < l)
				okL[i] = 0;
			else
				Le[i] = { max(0, l - t[i]), min(r, Le[i - 1].second) };
	}

	for (int i = 0; i < n; ++i) {
		int l = max(Le[i].first, R[i].first);
		int r = min(Le[i].second, R[i].second);
		if (okL[i] && okR[i] && l <= r)
			printf("%d\n", max(R[i].first, Le[i].first));
		else
			puts("-1");
	}
	return 0;
}