#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)1e2 + 7;
const int sz = (int)1e5;

int l[dd], r[dd], c[dd];
ll ans[(int)2e6];

inline ll min(ll a, ll b) {
	return a < b ? a : b;
}
inline ll max(ll a, ll b) {
	return a < b ? b : a;
}
inline void uax(ll &a, ll b) {
	if (a < b) a = b;
}

struct que {
	int iL, iR;
	ll A[sz];
	que() { iL = iR = 0; }
	void push(ll c) {
		while (iR != iL && A[(iR == 0 ? sz - 1 : iR - 1)] > c) iR = (iR == 0 ? sz - 1 : iR - 1);
		A[iR] = c;
		iR = (iR == sz - 1 ? 0 : iR + 1);
	}
	void pop(ll c) {
		if (A[iL] == c)
			iL = (iL == sz - 1 ? 0 : iL + 1);
	}
	ll get() {
		return A[iL];
	}
} Q[101];

int solve() {
	int n, a;
	scanf("%d %d", &n, &a);
	for (int i = 0; i < n; ++i)
		scanf("%d %d %d", &l[i], &r[i], &c[i]);

	for (int i = 0; i <= a; ++i)
		ans[i] = (ll)1e9 * i;
	for (int i = a - 1; i >= 0; --i) {
		ll O = 0;
		for (int j = 0; j < n; ++j) {
			if (i + r[j] + 1 <= a) Q[j].pop(ans[i + r[j] + 1]);
			if (i + l[j] <= a) Q[j].push(ans[i + l[j]]);
		}
		for (int j = 0; j < n; ++j)
			if (i + r[j] <= a)
				O = max(O, Q[j].get() - c[j]);
		uax(ans[i], O);
	}
	printf("%lld", ans[0]);
	return 0;
}