#define _CRT_SECURE_NO_WARNINGS

#include<vector>
#include<string>
#include<iostream>
#include<queue>

using namespace std;

#define X first
#define Y second

const long long MAXN = 200000 + 100, INF = (1ll << 62);
long long n, m, s, a, b, c, to, v;
vector< pair< pair<long long, long long>, long long> > g[MAXN];
long long d[MAXN], ans = 0;
bool used[MAXN];
vector< pair< long long, pair<long long, long long> > > pu[MAXN];
vector<pair<long long, pair< long long, long long> > > pr[MAXN];
pair< long long, pair<long long, long long> > tec;

void dei()
{
	priority_queue< pair<long long, long long> > q;
	q.push( {0, 0} );
	for (long long i = 0; i < n; i++)
	{
		d[i] = INF;
	}
	d[0] = 0;
	pu[0].push_back({ 0, {0, 0} });
	while (q.size())
	{
		v = q.top().Y;
		q.pop();
		if (used[v])
			continue;
		used[v] = true;
		ans = -1;
		for (long long i = 0; i < pr[v].size(); i++)
		{
			ans = -1;
			for (long long j = 0; j < pu[pr[v][i].X].size(); j++)
			{
				tec = pu[pr[v][i].X][j];
				if (tec.X == pr[v][i].Y.X)
				{
					pu[v].push_back({ pr[v][i].Y.X, {tec.Y.X + pr[v][i].Y.Y, tec.Y.Y} });
				}
				else
				{
					ans = max(ans, tec.Y.Y + tec.Y.X * tec.Y.X);
				}
			}
			if (ans != -1)
			{
				pu[v].push_back({ pr[v][i].Y.X,{ pr[v][i].Y.Y,  ans } });
			}
		}
		for (long long i = 0; i < g[v].size(); i++)
		{
			to = g[v][i].X.X;
			if (d[to] > d[v] + g[v][i].X.Y)
			{
				pr[to].clear();
				pr[to].push_back({ v, {g[v][i].Y, g[v][i].X.Y } });
				d[to] = d[v] + g[v][i].X.Y;
				q.push({ -d[to], to });
			}
			else if (d[to] == d[v] + g[v][i].X.Y)
			{
				pr[to].push_back({ v,{ g[v][i].Y, g[v][i].X.Y } });
			}
		}
	}
	v = n - 1;
	ans = 0;
	for (long long i = 0; i < pr[v].size(); i++)
	{
		for (long long j = 0; j < pu[pr[v][i].X].size(); j++)
		{
			tec = pu[pr[v][i].X][j];
			if (tec.X == pr[v][i].Y.X)
			{
				ans = max(ans, (tec.Y.X + pr[v][i].Y.Y) * (tec.Y.X + pr[v][i].Y.Y) + tec.Y.Y);
			}
			else
			{
				ans = max(ans, pr[v][i].Y.Y * pr[v][i].Y.Y + tec.Y.Y + tec.Y.X * tec.Y.X);
			}
		}
	}
	cout << d[n - 1] << " " << ans;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
#endif
	cin >> n >> m;
	for (long long i = 0; i < m; i++)
	{
		cin >> s >> a;
		a--;
		for (long long j = 0; j < s; j++)
		{
			cin >> c >> b;
			b--;
			g[a].push_back({ { b, c }, i + 1 });
			a = b;
		}
	}
	dei();
	return 0;
}