#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(a) (int(a.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

struct pt
{
    llong x, y;
    int i;
    pt() { }
    pt(llong x, llong y) : x(x), y(y) { }
    pt(pt a, pt b) : x(b.x - a.x), y(b.y - a.y) { }
};

mt19937 rnd(time(nullptr));
int n, q;
pt P;
pt p[maxn];

bool read()
{
    if (scanf("%d", &n) != 1)
        return false;

    return true;
}

llong cross(pt a, pt b) { return a.x * b.y - b.x * a.y; }
bool cmp(pt a, pt b) { return cross(pt(P, a), pt(P, b)) > 0; }

void solve()
{
    scanf("%d", &n);
    int p0 = 0;

    for (int i = 0; i < n; ++i)
    {
        scanf("%lld %lld", &p[i].x, &p[i].y);
        p[i].i = i + 1;

        if (p[i].x < p[p0].x || (p[i].x == p[p0].x && p[i].y < p[p0].y))
            p0 = i;
    }

    swap(p[0], p[p0]);
    P = p[0];
    sort(p + 1, p + n, cmp);
    scanf("%d", &q);

    for (int jj = 0; jj < q; ++jj)
    {
        bool good = false;

        for (int i = 1; i < n - 1; ++i)
        {
            printf("? 3 %d %d %d\n", p[0].i, p[i + 1].i, p[i].i);
            fflush(stdout);
            scanf("%s", buff);

            if (buff[0] == 'Y')
            {
                printf("! 3 %d %d %d\n", p[0].i, p[i + 1].i, p[i].i);
                fflush(stdout);
                good = true;
                break;
            }
        }

        assert(good);
    }
}


int main()
{
#ifdef SEREZHKA
    ///freopen("file.in", "r", stdin);
#endif // SEREZHKA

    //while (read())
        solve();

    return 0;
}
