#include <bits/stdc++.h>

#define X first
#define Y second
#define pb push_back
#define REP(i, a, b) for (int  i = (a); i <= (b); ++i)
#define sz(v) int((v).size())
#define all(v) (v).begin(), (v).end()

using namespace std;

typedef long long ll;
typedef pair <int, ll> pii;

int n, m;

const int maxn = 1000;

void upd(pair <ll, ll> &x, pair <ll, ll> y, ll c)
{
    if (x.X > y.X + c)
    {
        x.X = y.X + c;
        x.Y = y.Y + c*c;
    }
    if (x.X == y.X + c)
    {
        x.Y = max(x.Y, y.Y + c*c);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    vector < pair <pair <int, int>, ll> > ed(m);

    REP (i, 0, m - 1)
    {
        int k;
        cin >> k;

        assert(k == 1);
        cin >> ed[i].X.X >> ed[i].Y >> ed[i].X.Y;
        ed[i].X.X--;
        ed[i].X.Y--;
    }

    vector <pair <ll, ll> > dp(n, {1e18, 0});

    dp[0] = {0, 0};

    REP (i, 0, n)
    {
        for (auto e : ed)
        {
            upd(dp[e.X.Y], dp[e.X.X], e.Y);
        }
    }
    cout << dp[n - 1].X << ' ' << dp[n - 1].Y << '\n';
    return 0;
}
