#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <set>
#include <queue>
#include<cstdio>

using namespace std;

const int MX = 30;
set< long long > s;
int b;
int change[MX + 1];
int lvl = 0;

struct vert {
	int l, r, sz, push;
};

const int SZ = 5e7;
vert arr[SZ];
int cnt = 1;

inline bool add(int is, int val, int pos, int numb) {
	if (val == 0) {
		arr[pos].sz++;
		return 1;
	}
	lvl++;
	if ((arr[pos].push & val) ^ (b & val)) {
		swap(arr[pos].l, arr[pos].r);
		arr[pos].push ^= val;
	}
	if (arr[pos].r == -1) {
		arr[cnt] = { -1, -1, 0, b };
		arr[pos].r = cnt++;
	}
	if (arr[pos].l == -1) {
		arr[cnt] = { -1, -1, 0, b };
		arr[pos].l = cnt++;
	}

	int l = arr[pos].l, r = arr[pos].r;
	bool ans = 0;
	bool ok = 0;
	if (arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0) {
		ok = 1;
	}
	if (is & val) {
		if (arr[l].sz <= numb) {
			if (add(is, val >> 1, arr[pos].r, numb - arr[l].sz)) {
				arr[pos].sz++;
				ans = 1;
			}

		}
		else {
			if (numb == 0 && change[lvl] == (1 << lvl)) {
				swap(arr[pos].r, arr[pos].l);
				b ^= val;
				is ^= val;
				arr[pos].push ^= val;
				if (add(is, val >> 1, arr[pos].l, numb - arr[r].sz)) {
					arr[pos].sz++;
					ans = 1;
				}
				else {
					swap(arr[pos].r, arr[pos].l);
					b ^= val;
					is ^= val;
					arr[pos].push ^= val;

				}
			}


		}

	}
	else {
		if (arr[l].sz >= numb) {
			if (add(is, val >> 1, arr[pos].l, numb)) {
				arr[pos].sz++;
				ans = 1;
			}

		}
		else {
			if (numb == arr[r].sz && change[lvl] == 1 << lvl) {
				swap(arr[pos].r, arr[pos].l);
				b ^= val;
				is ^= val;
				arr[pos].push ^= val;
				if (add(is, val >> 1, arr[pos].r, 0)) {
					arr[pos].sz++;
					ans = 1;
				}
				else {
					swap(arr[pos].r, arr[pos].l);
					b ^= val;
					is ^= val;
					arr[pos].push ^= val;

				}
			}

		}
	}

	if (ok && !(arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0)) {
		change[lvl]--;
	}
	lvl--;
	return ans;

}

void get_out(int is, int val, int pos) {
	if (val == 0) {
		arr[pos].sz--;
		return;
	}
	lvl++;
	if (arr[pos].r == -1) {
		arr[cnt] = { -1, -1, 0, b };
		arr[pos].r = cnt++;
	}
	if (arr[pos].l == -1) {
		arr[cnt] = { -1, -1, 0, b };
		arr[pos].l = cnt++;
	}
	if (arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0) {
		change[lvl]--;
	}
	if ((arr[pos].push & val) ^ (b & val)) {
		swap(arr[pos].l, arr[pos].r);
		arr[pos].push ^= val;
	}
	if (is & val) {
		get_out(is, val >> 1, arr[pos].r);
	}
	else {
		get_out(is, val >> 1, arr[pos].l);
	}
	arr[pos].sz--;
	if (arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0) {
		change[lvl]++;
	}
	lvl--;

	return;
}

int main() {
	int n;
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
	scanf("%d", &n);
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
	int val = 1 << (MX - 1);
	arr[0] = { -1, -1, 0, b };
	for (int i = 0; i <= MX; i++)
		change[i] = 1 << i;
	for (int i = 0; i < n; i++) {
		lvl = 0;
		if (!add(a[i] ^ b, 1 << (MX - 1), 0, i)) {
			s.insert(i * 1ll * 1e10 + a[i]);
		}
	}

	val = 1 << (MX - 1);
	for (int i = 1; i <= MX; i++) {
		if ((b & val) && (change[i] == (1 << (i))))
			b ^= val;
		val >>= 1;
	}
	if (s.empty())
		printf("%d\n", b);
	else
		printf("-1\n");

	int q;
	cin >> q;
	const long long M = 1e10;
	while (q--) {
		int pos, is;
		scanf("%d%d", &pos, &is); pos--;
		if (s.find(pos * 1ll * M + a[pos]) == s.end()) {
			lvl = 0;
			get_out(a[pos] ^ b, 1 << (MX - 1), 0);
		}
		else
			s.erase(pos * 1ll * M + a[pos]);
		a[pos] = is;
		s.insert(pos * 1ll * M + a[pos]);
		while (!s.empty()) {
			auto j = s.begin();
			long long v = (*j);
			lvl = 0;
			if (!add((v % M) ^ b, 1 << (MX - 1), 0, v / M)) {
				break;
			}
			s.erase(j);
		}
		val = 1 << (MX - 1);
		for (int i = 1; i <= MX; i++) {
			if ((b & val) && (change[i] == (1 << (i))))
				b ^= val;
			val >>= 1;
		}
		if (s.empty())
			printf("%d\n", b);
		else
			printf("-1\n");
	}
	return 0;
}
