#include <iostream>
#include <math.h>

using namespace std;

const long double eps = 0.0001;

pair <long long, long long>  coors[3000];

long double sqr(int a, int b, int c) {
    long double l1, l2, l3, p;
    l1 = sqrt((coors[a].first - coors[b].first) * (coors[a].first - coors[b].first) + (coors[a].second - coors[b].second) * (coors[a].second - coors[b].second));
    l2 = sqrt((coors[a].first - coors[c].first) * (coors[a].first - coors[c].first) + (coors[a].second - coors[c].second) * (coors[a].second - coors[c].second));
    l3 = sqrt((coors[b].first - coors[c].first) * (coors[b].first - coors[c].first) + (coors[b].second - coors[c].second) * (coors[b].second - coors[c].second));
    //cout << a << b << c << " ===== " << l1 << l2 << l3 << endl;
    p = (l1 + l2 + l3) / 2;
    return sqrt(p * (p - l1) * (p - l2) * (p - l3));
}

bool into(int a, int b, int c, int d) {
    //cout << sqr(a, b, d) << ' ' << sqr(a, c, d) << ' ' << sqr(b, c, d) << ' ' << sqr(a, b, c) << ' ';
    return (abs(sqr(a, b, d) + sqr(a, c, d) + sqr(b, c, d) - sqr(a, b, c)) < eps);
}

int main() {
    int n, q;
    long long x, y;
    cin >> n;
    for (int i = 1; i <= n; i ++) {
        cin >> x >> y;
        coors[i] = pair <long long, long long> (x, y);
    }
    cin >> q;
    string ans;
    bool poss;
    int cnt;
    for (int i = 0; i < q; i ++) {
        poss = false;
        for (int a = 1; a <= n; a ++) {
            if (poss) {
                break;
            }
            for (int b = a + 1; b <= n; b ++) {
                if (poss) {
                    break;
                }
                for (int c = b + 1; c <= n; c ++) {
                    cnt = 0;
                    for (int d = 1; d <= n; d ++) {
                        if (into(a, b, c, d)) {
                            cnt ++;
                        }
                    }
                    if (cnt > 3) {
                        continue;
                    }
                    cout << "? 3 " << a << ' ' << b << ' '  << c << endl;
                    cin >> ans;
                    if (ans == "Yes") {
                        cout << "! 3 " << a << ' ' << b << ' ' << c << endl;
                        poss = true;
                        break;
                    }
                }
            }
        }
    }
    return 0;
}
