#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
int n, mx = -1;
int a[1000100];

int solve() {
	int res = -1;
	for (int i = 0; i <= mx; i++) {
		int prev = a[0] ^ i;
		bool able = true;
		for (int p = 1; p < n; p++) {
			if (prev > (a[p] ^ i)) {
				able = false;
			}
			else {
				prev = (a[p] ^ i);
			}
		} 
		//cout << "for magic " << i << " it is so:\n";
		//for (int p = 0; p < n; p++) cout << (a[p] ^ i) << " ";
		//cout << endl;
		if (able && res == -1) res = i;
	}
	return res;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mx = max(mx, a[i]);
	}
	cout << solve() << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int pos, val;
		cin >> pos >> val;
		a[pos - 1] = val;
		cout << solve() << '\n';
	}
}