#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

struct ex
{
    long long l, r;
    long long c;
};
inline bool operator<(ex a, ex b)
{
    long double g1 = (long double)a.c / a.r;
    long double g2 = (long double)b.c / b.r;
    return g1 < g2;
}

long long n, a, ans = 2e18;
vector <ex> v;
vector <long long> dp;

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> a;
    v.resize(n);
    dp.resize(a + 1, 2e18);
    dp[0] = 0;
    for (long long i = 0; i < n; i++)
    {
        cin >> v[i].l >> v[i].r >> v[i].c;
    }

    sort(v.begin(), v.end());

    for (long long i = 0; i <= a; i++)
    {
        for (long long j = 0; j < n; j++)
        {
            if (v[j].r + i <= a)
            {
                for (long long k = v[j].l; k <= v[j].r; k++)
                {
                    dp[i + k] = min(dp[i + k], dp[i] + k * (long long)1e9 - v[j].c);
                }
                break;
            }
            if (j == n - 1)
            {
                ans = min(ans, dp[i]);
                //cout << ans << ' ' << i << endl;
            }
        }
    }

    if (ans != 2e18)
        cout << ans;
    else
        cout << 0;
    return 0;
}

/*

1 17
4 6 10

2 11
2 2 100
3 5 5

*/
