#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <utility>
#include <iterator>
#include <sstream>
#include <fstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//SAY HELLO TO MY LIL' FRIEND

int n, m;
vector<vector<pii> > g;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	cin >> n >> m;

	g.resize(n);
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;

		int lst = -1, w = -1;
		for (int j = 0; j < s; j++) {
			int curr, nw;
			cin >> curr >> nw;
			curr--;

			if (lst != -1) {
				g[lst].push_back(mp(curr, w));
			}
			lst = curr, w = nw;
		}
		int curr;
		cin >> curr;
		g[lst].push_back(mp(curr - 1, w));
	}

	vector<pii> d(n, mp(INF, -INF));
	vector<bool> used(n, false);
	
	d[0] = mp(0, 0);
	for (int i = 0; i < n; i++) {
		int v = -1;
		for (int j = 0; j < n; j++) {
			if (!used[j]) {
				if (v == -1 || d[j] < d[v])
					v = j;
			}
		}
		if (v == -1)
			break;
		used[v] = true;

		for (pii to : g[v]) {
			int u = to.X, w = to.Y;

			if (!used[u]) {
				if (d[u].X > d[v].X + w) {
					d[u].X = d[v].X + w;
					d[u].Y = max(d[v].Y, w * w);
				}
				else if (d[u].X == d[v].X + w && w * w > d[u].Y) {
					d[u].Y = w * w;
				}
			}
		}
	}

	cout << d[n - 1].X << " " << d[n - 1].Y;

	return 0;
}