#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <time.h>
#include <assert.h>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 1e5 + 10;
const int INF = 1e9;

string s, t;
map<int, pair<char, int> > x, y, z;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("storage.in", "r", stdin);
	freopen("storage.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);

	int q;
	cin >> q;
	while (q--) {
		cin >> s >> t;

		y.clear();
		y[0] = { t[0], 1 };
		for (int i = 1; i < t.length(); i++)
			if (t[i] != y.rbegin()->second.first)
				y[i] = { t[i], 1 };
			else
				y.rbegin()->second.second++;

		z.clear();
		z[0] = { s[0], 1 };
		for (int i = 1; i < s.length(); i++)
			if (s[i] != z.rbegin()->second.first)
				z[i] = { s[i], 1 };
			else
				z.rbegin()->second.second++;

		bool ok = true;
		for (auto ee = y.begin(); ee != y.end(); ee++) {
			int l = ee->first,
				r = ee->first + ee->second.second;

			x.clear();
			x[l] = { s[l], 1 };
			for (int i = l + 1; i < r; i++)
				if (s[i] != x.rbegin()->second.first)
					x[i] = { s[i], 1 };
				else
					x.rbegin()->second.second++;

			auto f = ee;
			if (f != y.begin()) {
				f--;
				if (f->second.first == x.begin()->second.first)
					x.begin()->second.second += f->second.second;
			}
			x.rbegin()->second.second = z[x.rbegin()->first].second;

			if (ee->second.first == '+') {
				for (auto e = x.begin(); e != x.end(); e++) {
					if (e->second.first == '-')
						continue;
					while (true) {
						bool act = false;
						if (e != x.begin()) {
							auto f = e; f--;
							if (f->second.second < e->second.second) {
								e->second.second += f->second.second;
								if (f != x.begin()) {
									auto g = f; g--;
									e->second.second += g->second.second;
									x.erase(g);
								}
								x.erase(f);
								act = true;
							}
						}
						auto f = e; f++;
						if (f != x.end() && f->second.second < e->second.second) {
							e->second.second += f->second.second;
							auto g = f; g++;
							if (g != x.end()) {
								e->second.second += g->second.second;
								x.erase(g);
							}
							x.erase(f);
							act = true;
						}

						if (!act)
							break;
					}
				}
				if (!(x.size() == 1 && x.begin()->second.first == '+'))
					ok = false;

			} else {

				for (auto e = x.begin(); e != x.end(); e++) {
					if (e->second.first == '+')
						continue;
					while (true) {
						bool act = false;
						if (e != x.begin()) {
							auto f = e; f--;
							if (f->second.second < e->second.second) {
								e->second.second += f->second.second;
								if (f != x.begin()) {
									auto g = f; g--;
									e->second.second += g->second.second;
									x.erase(g);
								}
								x.erase(f);
								act = true;
							}
						}
						auto f = e; f++;
						if (f != x.end() && f->second.second < e->second.second) {
							e->second.second += f->second.second;
							auto g = f; g++;
							if (g != x.end()) {
								e->second.second += g->second.second;
								x.erase(g);
							}
							x.erase(f);
							act = true;
						}

						if (!act)
							break;
					}
				}
				if (!(x.size() == 1 && x.begin()->second.first == '-'))
					ok = false;
			}
		}

		cout << (ok ? "Yes\n" : "No\n");
	}

	return 0;
}