#include <iostream>
#include <vector>
#include <stdio.h>
#include <assert.h>
#include <set>
#include <map>
#include <time.h>
#include <string>
#include <algorithm>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 1e5 + 10;
const int INF = 1e9;

string sum(string a, string b) {
	string res = "";
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	while (a.length() < b.length())
		a += '0';
	while (b.length() < a.length())
		b += '0';
	int x = 0;
	for (int i = 0; i < a.length(); i++) {
		x += int(a[i] - '0') + int(b[i] - '0');
		res += char((x % 10) + '0');
		x /= 10;
	}
	if (x)
		res += char(x + '0');
	reverse(res.begin(), res.end());
	return res;
}

string diff(string a, string b) {
	string res = "";
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	while (a.length() < b.length())
		a += '0';
	while (b.length() < a.length())
		b += '0';
	bool x = false;
	for (int i = 0; i < a.length(); i++) {
		int e = int(a[i] - '0') - int(b[i] - '0') - int(x);
		x = false;
		if (e < 0) {
			e += 10;
			x = true;
		}
		res += char(e + '0');
	}
	while (res.length() > 1 && res.back() == '0')
		res.pop_back();
	reverse(res.begin(), res.end());
	return res;
}

bool isMore(string a, string b) {
	if (a.length() != b.length())
		return a.length() > b.length();
	return a > b;
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("sequence.in", "r", stdin);
	freopen("sequence.out", "w", stdout);
#endif

	ios::sync_with_stdio(false);

	vector<ll> xx;
	ll ee;
	while (cin >> ee)
		xx.push_back(ee);
	reverse(xx.begin(), xx.end());
	for (ll i : xx)
		cout << i << " ";
	return 0;

	string a, b;
	cin >> a >> b;
	
	bool negA = false, negB = false;
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	if (a.back() == '-') {
		a.pop_back();
		negA = true;
	}
	if (b.back() == '-') {
		b.pop_back();
		negB = true;
	}
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());

	if (!negA && !negB)
		return cout << sum(a, b), 0;
	if (negA && negB)
		return cout << "-" << sum(a, b), 0;
	if (negA && !negB) {
		swap(a, b);
		swap(negA, negB);
	}
	if (isMore(a, b))
		cout << diff(a, b);
	else
		cout << (diff(b, a) == "0" ? "" : "-") << diff(b, a);

	return 0;
}