#include <bits/stdc++.h>

using namespace std;

struct A
{
    long long val;
    int lb1, rb1;
    int lb2, rb2;

    A() {}
    A(long long v, int l1, int r1, int l2, int r2) : val(v), lb1(l1), rb1(r1), lb2(l2), rb2(r2) {}
};

vector< vector<long long> > sum;

struct cmp1
{
    bool operator () (pair<int, int> p1, pair<int, int> p2)
    {
        if (p1.first != p2.first)
            return (p1.first > p2.first);

        return (p1.second < p2.second);
    }
};

struct cmp2
{
    bool operator () (pair<int, int> p1, pair<int, int> p2)
    {
        return (sum[p1.first][p1.second] > sum[p2.first][p2.second]);
    }
};

int main()
{
    /// freopen("d.txt", "r", stdin);

    int n, m;
    cin >> n >> m;

    vector<int> a(n), b(m);
    vector<long long> x(n), y(m);
    map<int, int> pos2;
    sum.resize(m, vector<long long>(m));
    vector<int> pos1(n, -1);

    for (int i = 0; i < n; i++)
        cin >> a[i];

    long long S = 0;

    for (int i = 0; i < n; i++)
        cin >> x[i], S += x[i];

    for (int i = 0; i < m; i++)
    {
        cin >> b[i];
        pos2[b[i]] = i;
    }

    for (int i = 0; i < m; i++)
    {
        cin >> y[i];
        sum[i][i] = y[i];
    }

    for (int i = 0; i < n; i++)
    {
        if (pos2.find(a[i]) == pos2.end())
            continue;

        pos1[i] = pos2[a[i]];
    }

    for (int d = 1; d < m; d++)
        for (int i = 0; i + d < m; i++)
            sum[i][i + d] = sum[i][i + (d - 1)] + sum[i + d][i + d];

    A ans = A(sum[0][m - 1], 0, 0, 1, m);

    if (S > ans.val)
        ans = A(S, 1, n, 0, 0);

    set< pair<int, int>, cmp1 > rec;
    set< pair<int, int>, cmp2 > a2;
    long long val; pair<int, int> p;

    for (int i = 0; i < n; i++)
    {
        rec.clear(), a2.clear();

        rec.insert({0, m - 1});
        a2.insert({0, m - 1});
        val = 0;

        for (int j = i; j < n; j++)
        {
            val += x[j];

            if (pos1[j] != -1)
            {
                p = *rec.lower_bound({pos1[j], pos1[j]}); /*

                cout << pos1[j] << endl;
                cout << p.first << ' ' << p.second << endl;
                cout << endl; */

                rec.erase(p);
                a2.erase(p);

                if (p.first < pos1[j])
                {
                    rec.insert({p.first, pos1[j] - 1});
                    a2.insert({p.first, pos1[j] - 1});
                }

                if (pos1[j] < p.second)
                {
                    rec.insert({pos1[j] + 1, p.second});
                    a2.insert({pos1[j] + 1, p.second});
                }
            }

            if (a2.empty())
                break;

            if (val + sum[a2.begin()->first][a2.begin()->second] > ans.val)
            {
                ans.val = val + sum[a2.begin()->first][a2.begin()->second];
                ans.lb1 = i + 1, ans.rb1 = j + 1;
                ans.lb2 = a2.begin()->first + 1, ans.rb2 = a2.begin()->second + 1;
            }
        }
    }

    cout << ans.val << endl;
    cout << ans.lb1 << ' ' << ans.rb1 << endl;
    cout << ans.lb2 << ' ' << ans.rb2;

    return 0;
}
