#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<queue>

using namespace std;
int n;

void bfs(vector < vector<pair<int, int>>>&g) {
	vector<pair<int, int>>dist(n + 1, { 1e9,0 });
	dist[1] = { 0,0 };
	queue<int>q;
	q.push(1);
	while (!q.empty()) {
		int now = q.front();
		q.pop();
		for (auto to : g[now]) {
			if (dist[to.first].first > dist[now].first + to.second) {
				q.push(to.first);
				dist[to.first].second = dist[now].second + to.second*to.second;
				dist[to.first].first = dist[now].first + to.second;
				continue;
			}
			if (dist[to.first].first == dist[now].first + to.second && dist[to.first].second < dist[now].second + to.second*to.second) {
				 dist[to.first].second=dist[now].second + to.second*to.second;
				 dist[to.first].first = dist[now].first + to.second;
				q.push(to.first);
			}
		}
	}
	cout << dist[n].first << ' ' << dist[n].second;
}

int main()
{
	cin >> n;
	int m;
	cin >> m;
	vector < vector<pair<int,int>>>g(n + 1);
	for (int i = 0; i < m; i++) {
		int cnt;
		cin >> cnt;
		vector<int>v(cnt + 1);
		vector<int>price(cnt + 1);
		cin >> v[0];
		for (int j = 1; j <=  cnt; j++) {
			cin >> price[j];
			cin >> v[j];
		}
		for (int i1 = 0; i1 <= cnt; i1++) {
			int sum = 0;
			for (int j1 = i1 + 1; j1 <= cnt; j1++) {
				sum += price[j1];
				g[v[i1]].push_back({v[j1], sum });
			}
		}
	}
	bfs(g);
	return 0;
}