#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int main() {
    vector<pair<char, int>> segStack;

    ifstream fin("storage.in");
    int q;
    fin >> q;
    for (int i = 0; i < q; i++) {
        string s, t;
        fin >> s >> t;
        int n = s.size();
        //cout << s << endl;
        segStack.clear();
        int left = 0;
        int right = 0;
        while (left < n) {
            while (right < n && s[left] == s[right])
                right++;

            int len = right - left;
            //cout << "new: " << s[left] << " " << len << endl;
            segStack.push_back(make_pair(s[left], len));

            int sz = segStack.size();
            while (sz >= 2) {
                pair<char, int> &curr = segStack[sz - 1];
                pair<char, int> &prev = segStack[sz - 2];
                if ((curr.first == '-' && prev.second > curr.second) ||
                    (curr.first == '+' && prev.first == '+')) {
                    prev.second += curr.second;
                    segStack.pop_back();
                    sz--;
                } else if (curr.first == '+' && curr.second > prev.second) {
                    prev.first = '+';
                    prev.second += curr.second;
                    segStack.pop_back();
                    sz--;
                } else {
                    break;
                }
            }
            /*
            for (auto x : segStack)
                cout << x.first << x.second << " ";
            cout << endl;
            */
            left = right;
        }
        if (segStack.size() == 1)
            cout << "Yes";
        else
            cout << "No";
        cout << endl;
    }
}
