#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-5;

struct P {
    ll x, y;
    P(ll x, ll y) : x(x), y(y) {}

    ll operator^(P b) {
        return x * b.y - y * b.x;
    }

    P operator-(P b) {
        return P(x - b.x, y - b.y);
    }
};

vector<P> p;

bool check(int x, int a, int b, int c) {
    if (x == a || x == b || x == c) {
        return false;
    }

    ll now = abs((p[a] - p[x]) ^ (p[c] - p[x])) + abs((p[a] - p[x]) ^ (p[b] - p[x])) + abs((p[b] - p[x]) ^ (p[c] - p[x]));
    ll real = abs(fabs((p[a] - p[b]) ^ (p[c] - p[b])));

    if (now == real) {
        return true;
    }
    return false;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    ll x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        p.push_back(P(x, y));
    }
    int q;
    cin >> q;
    for (int f = 0; f < q; ++f) {
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool flag = true;
                for (int c = 0; c < n; ++c) {
                    if (check(c, i, j, k)) {
                        flag = false;
                    }
                }

                if (flag) {
                    cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
                    string res;
                    cin >> res;
                    if (res == "Yes") {
                        cout << "! 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
                    }
                }
            }
        }
    }
    }

    return 0;
}
