#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;

void run();

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = 1e6 + 123;

int n, m;
vector<pair<int, pair<ll, ll>>> g[N];
pair<ll, ll> dist[N];
bool vis[N];

vector<int> t[N], v[N];

void run() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;
		for (int j = 0; j < s; j++) {
			int x, y;
			cin >> x >> y;
			v[i].push_back(x);
			t[i].push_back(y);
		}
		int x;
		cin >> x;
		v[i].push_back(x);
		
		for (int j = 0; j < s; j++) {
			ll len = 0;
			int from = v[i][j];
			for (int k = j + 1; k <= s; k++) {
				len += t[i][k - 1];
				int to = v[i][k];
				g[from].push_back({to, {len, len * len}});
			}
		}
	}
	
	fill(dist, dist + N, make_pair(LINF, LINF));
	dist[1] = {0, 0};
	priority_queue<pair<pair<ll, ll>, int>> q;
	q.push({{0, 0}, 1});
	
	while (!q.empty()) {
		int v = q.top().second;
		q.pop();
		if (vis[v]) continue;
		vis[v] = 1;
		
		for (auto &e : g[v]) {
			int to = e.first;
			ll nlen = dist[v].first + e.second.first;
			ll nlen2 = dist[v].second + e.second.second;
			
			if (nlen < dist[to].first || (nlen == dist[to].first && nlen2 > dist[to].second)) {
				dist[to] = {nlen, nlen2};
				q.push({{-nlen, nlen2}, to});
			}
		}
	}
	
	cout << dist[n].first << " " << dist[n].second << "\n";
}
