import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {
    public void solve() throws IOException {
        int x = 0;
        long[] a = new long[3000000];
        while (hasnext()){
            a[x] = nextLong();
            x++;
        }
        for(int i = x - 1; i >= 0; i--){
            out.print(a[i] + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }
    public boolean hasnext() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return false;
            }
        }
        return true;
    }
    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
//            br = new BufferedReader(new InputStreamReader(System.in));
//            out = new PrintWriter(System.out);
            br = new BufferedReader(new FileReader("sequence.in"));
            out = new PrintWriter(new File("secuence.out"));
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}