#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

int main() {
    int n, q;
    cin >> n;
    vector <int> a(n);
    vector < bitset<9> > ab(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        for (int j = 0; j < 9; j++){
            ab[i][8 - j] = (a[i] >> j) & 1;
            //cout << ab[i][8 - j];
        }
        //cout << endl;
    }
    vector <pair <bool, bool> > res(9, {false, false});
    bool flag = true;
    for (int i = 0; i < n - 1; i++){
        for (int j = 0; j < 9; j++){
            if (ab[i][j] ^ ab[i + 1][j]){
                if (res[j].second && res[j].first != ab[i][j]) {
                    cout << -1 << endl;
                    j = 9;
                    i = n;
                    flag = false;
                }
                else {
                    res[j] = make_pair(ab[i][j], true);
                    j = 9;
                }
            }
        }
    }
    if (flag){
        int res2 = 0;
        for (int j = 0; j < 9; j++){
            res2 = res2 * 2 + ((int) res[j].first);
        }
        cout << res2 << endl;
    }
    cin >> q;
    for (int t = 0; t < q; t++){
        int u, v;
        cin >> u >> v;
        u--;
        a[u] = v;
        for (int j = 0; j < 9; j++){
            ab[u][8 - j] = (a[u] >> j) & 1;
            //cout << ab[u][8 - j];
        }
        flag = true;
        res.assign(9, make_pair(0, 0));
        for (int i = 0; i < n - 1; i++){
            for (int j = 0; j < 9; j++){
                if (ab[i][j] ^ ab[i + 1][j]){
                    if (res[j].second && res[j].first != ab[i][j]) {
                        cout << -1 << endl;
                        j = 9;
                        i = n;
                        flag = false;
                    }
                    else {
                        res[j] = make_pair(ab[i][j], true);
                        j = 9;
                    }
                }
            }
        }
        if (flag){
            int res2 = 0;
            for (int j = 0; j < 9; j++){
                res2 = res2 * 2 + ((int) res[j].first);
            }
            cout << res2 << endl;
        }
    }
    return 0;
}