#include <iostream>
#include <cstdlib>
#include <vector>
#include <bitset>
#include <set>
#include <fstream>

using namespace std;

//ifstream cin("order.cin");
ofstream out("order.out");

int read_int(){
    int ret = 0;
    char c = '-';
    while (c > '9' || c < '0'){
        c = getchar();
    }
    while ('0' <= c && c <= '9'){
        ret = ret * 10 + (c - '0');
        c = getchar();
    }
    //cout << ret << endl;
    return ret;
}

int main() {
    int n, q;
    n = read_int();
    vector <int> a(n);
    vector < bitset<30> > ab(n);
    for (int i = 0; i < n; i++){
        a[i] = read_int();
        for (int j = 0; j < 30; j++){
            ab[i][29 - j] = (a[i] >> j) & 1;
        }
    }
    vector <pair <multiset<int>, multiset<int> > > res(30);
    vector <int> res2(n - 1, -1);
    for (int i = 0; i < n - 1; i++){
        for (int j = 0; j < 30; j++) {
            if (ab[i][j] ^ ab[i + 1][j]) {
                res2[i] = j;
                if (ab[i][j]) {
                    res[j].second.insert(i);
                }
                else {
                    res[j].first.insert(i);
                }
                j = 30;
            }
        }
    }
    bool flag = true;
    int res3 = 0;
    for (int j = 0; j < 30; j++){
        //out << res[j].first.size() << " " << res[j].second.size() << endl;
        if (res[j].first.size() != 0 && res[j].second.size() != 0){
            flag = false;
        }
        else if (res[j].second.size() != 0){
            res3 = res3 * 2 + 1;
        }
        else {
            res3 = res3 * 2;
        }
    }
    if (flag){
        out << res3 << endl;
    }
    else {
        out << -1 << endl;
    }
    cin >> q;
    for (int t = 0; t < q; t++){
        int u, v;
        u = read_int();
        v = read_int();
        u--;
        for (int j = 0; j < 30; j++){
            ab[u][29 - j] = (v >> j) & 1;
        }
        if (n == 1){
            out << 0 << endl;
            continue;
        }
        if (u != n - 1){
            if (res2[u] != -1) {
                res[res2[u]].first.erase(u);
                res[res2[u]].second.erase(u);
                res2[u] = -1;
            }
            for (int j = 0; j < 30; j++){
                if (ab[u][j] ^ ab[u + 1][j]){
                    res2[u] = j;
                    if (ab[u][j]) {
                        res[j].second.insert(u);
                    } else {
                        res[j].first.insert(u);
                    }
                    j = 30;
                }
            }
        }
        if (u != 0) {
            u--;
            if (res2[u] != -1) {
                res[res2[u]].first.erase(u);
                res[res2[u]].second.erase(u);
                res2[u] = -1;
            }
            for (int j = 0; j < 30; j++){
                if (ab[u][j] ^ ab[u + 1][j]){
                    res2[u] = j;
                    if (ab[u][j]) {
                        res[j].second.insert(u);
                    } else {
                        res[j].first.insert(u);
                    }
                    j = 30;
                }
            }
        }
        flag = true;
        res3 = 0;
        for (int j = 0; j < 30; j++){
            //out << res[j].first.size() << " " << res[j].second.size() << endl;
            if (res[j].first.size() != 0 && res[j].second.size() != 0){
                flag = false;
            }
            else if (res[j].second.size() != 0){
                res3 = res3 * 2 + 1;
            }
            else {
                res3 = res3 * 2;
            }
        }
        if (flag){
            out << res3 << endl;
        }
        else {
            out << -1 << endl;
        }
    }
    return 0;
}