#include <algorithm>
#include <iostream>
#include <iterator>
#include <cstdio>
#include <vector>
#include <set>
using namespace std;
#define int long long
const int INF = 1e10;



signed main() {
	freopen("servers.in", "r", stdin);
	freopen("servers.out", "w", stdout);

	int n;
	cin >> n;
	
	vector <int> buffer(n);
	for (int i = 0; i < n; i++) {
		cin >> buffer[i];
	}
	vector <pair <int, int> > lim(n - 1);
	for (int i = 1; i < n; i++) {
		cin >> lim[i - 1].first >> lim[i - 1].second;
	}
	
	int MAXN = 5500;
	vector <vector <bool> > dp_right(n, vector <bool> (MAXN, false));
	for (int i = 0; i < MAXN; i++) {
		dp_right[n - 1][i] = true;
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int t = 0; t < MAXN; t++) {
			if (t > lim[i].second || (t + buffer[i]) < lim[i].first) {
				dp_right[i][t] = false;
			} else if (t <= lim[i].second && t >= lim[i].first) {
				dp_right[i][t] = dp_right[i + 1][t];
			} else {
				dp_right[i][t] = dp_right[i + 1][lim[i].first];
			}
		}
	}
	vector <pair <int, int> > dp_right_2(n);
	for (int i = 0; i < n; i++) {
		if (count(dp_right[i].begin(), dp_right[i].end(), true) == 0) {
			dp_right_2[i] = {-1, -1};
		} else {
			for (int j = 0; j < MAXN; j++) {
				if (dp_right[i][j] == true) {
					dp_right_2[i].first = j;
					break;
				}
			}
			for (int j = 0; j < MAXN; j++) {
				if (dp_right[i][j] == true) {
					dp_right_2[i].second = j;
				}
			}
		}
		// cout << dp_right_2[i] << " ";
	}
	// cout << endl;

	reverse(buffer.begin(), buffer.end());
	reverse(lim.begin(), lim.end());

	for (auto x : dp_right) {
		for (auto y : x) {
			// cout << y << " ";
		}
		// cout << endl;
	}


	vector <vector <bool> > dp_left(n, vector <bool> (MAXN, false));
	for (int i = 0; i < MAXN; i++) {
		dp_left[n - 1][i] = true;
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int t = 0; t < MAXN; t++) {
			if (t > lim[i].second || t + buffer[i] < lim[i].first) {
				dp_left[i][t] = false;
			} else if (t <= lim[i].second && t >= lim[i].first) {
				dp_left[i][t] = dp_left[i + 1][t];
			} else {
				dp_left[i][t] = dp_left[i + 1][lim[i].first];
			}
		}
	}
	vector <pair <int, int> > dp_left_2(n);
	for (int i = 0; i < n; i++) {
		if (count(dp_left[i].begin(), dp_left[i].end(), true) == 0) {
			dp_left_2[i] = {-1, -1};
		} else {
			for (int j = 0; j < MAXN; j++) {
				if (dp_left[i][j] == true) {
					dp_left_2[i].first = j;
					break;
				}
			}
			for (int j = 0; j < MAXN; j++) {
				if (dp_left[i][j] == true) {
					dp_left_2[i].second = j;
				}
			}
			bool flag = true;
			for (int j = dp_left_2[i].first; j <= dp_left_2[i].second; j++) {
				flag &= dp_left[i][j];
			}
			if (!flag) {
				return 0;
			}
		}
	}
	reverse(dp_left_2.begin(), dp_left_2.end());
	reverse(dp_left.begin(), dp_left.end());

	for (int i = 0; i < n; i++) {
		int ans = -1;
		if (dp_right_2[i] == make_pair(-1LL, -1LL) || dp_left_2[i] == make_pair(-1LL, -1LL)) {
			cout << -1 << endl;
		} else if (dp_right_2[i].second < dp_left_2[i].first || dp_left_2[i].second < dp_right_2[i].first) {
			cout << -1 << endl;
		} else {
			cout << max(dp_left_2[i].first, dp_right_2[i].first) << endl;
		}
	}


	fclose(stdin);
	fclose(stdout);
	return 0;
}