#include <iostream>
#include <string>
#include <vector>

#pragma warning(disable:4996)

using namespace std;

string f, s;
int q, n, m;
vector < int > pr, a;

int get_pr(int v) {
	if (pr[v] == v) return v;
	return pr[v] = get_pr(pr[v]);
}

string solve() {
	int l = 0;
	pr.clear();
	a.clear();
	bool t = f[0] == '+';
	while (l < n) {
		int r = l;
		while (r < n && f[l] == f[r]) r++;
		a.push_back(r - l);
		l = r;
		pr.push_back(pr.size());
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < a.size(); j++) {
			if ((j + t) % 2 == 0) {
				if (j == 0) {
					if (a[get_pr(1)] > a[get_pr(0)]) {
						a[get_pr(0)] += a[get_pr(1)];
						pr[get_pr(1)] = get_pr(0);
					}
				}
				else if (j + 1 == a.size()) {
					if (a[get_pr(j - 1)] > a[get_pr(j)]) {
						a[get_pr(j - 1)] += a[get_pr(j)];
						pr[get_pr(j)] = get_pr(j - 1);
					}
				}
				else if (a[get_pr(j - 1)] > a[get_pr(j)] || a[get_pr(j + 1)] > a[get_pr(j)]) {
					a[get_pr(j - 1)] += a[get_pr(j)] + a[get_pr(j + 1)];
					pr[get_pr(j)] = get_pr(j - 1);
					pr[get_pr(j + 1)] = get_pr(j - 1);
				}
			}
		}
	}
	if (a[0] != f.size()) {
		return "No\n";
	}
	else {
		return "Yes\n";
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> q;
	while (q--) {
		cin >> f >> s;
		n = f.size();
		m = s.size();
		cout << solve();
	}
	return 0;
}