#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <iostream>
#include <stack>

using namespace std;

bool p1(string l, int beg, int e) {
	stack <int> a, b;
	int len = 0;
	vector <pair <int, char> > s;
	for (int i = beg; i < e; i++) {
		if (l[i] == l[i + 1]) {
			len++;
		}
		else {
			s.push_back({ len + 1, l[i] });
			len = 0;
		}
	}
	s.push_back({ len + 1, l[e] });
	int k = s.size();
	for (int i = 0; i < k; i++) {
		auto c = s[i];
		int n = c.first;
		char ch = c.second;
		if (ch == '+') {
			while (!b.empty() && n > b.top()) {
				n += b.top();
				b.pop();
				if (!a.empty()) {
					n += a.top();
					a.pop();
				}
			}
			a.push(n);
		}
		else {
			if (a.empty() || a.top() <= n) {
				b.push(n);
				continue;
			}
			n += a.top();
			a.pop();
			i++;
			if (i < k) {
				n += s[i].first;
			}
			while (!b.empty() && n > b.top()) {
				n += b.top();
				b.pop();
				if (!a.empty()) {
					n += a.top();
					a.pop();
				}
			}
			a.push(n);
		}
	}
	return b.empty();
}

bool p2(string l, int beg, int e) {
	stack <int> a, b;
	int len = 0;
	vector <pair <int, char> > s;
	for (int i = beg; i < e; i++) {
		if (l[i] == l[i + 1]) {
			len++;
		}
		else {
			s.push_back({ len + 1, l[i] });
			len = 0;
		}
	}
	s.push_back({ len + 1, l[e] });
	int k = s.size();
	for (int i = 0; i < k; i++) {
		auto c = s[i];
		int n = c.first;
		char ch = c.second;
		if (ch == '-') {
			while (!b.empty() && n > b.top()) {
				n += b.top();
				b.pop();
				if (!a.empty()) {
					n += a.top();
					a.pop();
				}
			}
			a.push(n);
		}
		else {
			if (a.empty() || a.top() <= n) {
				b.push(n);
				continue;
			}
			n += a.top();
			a.pop();
			i++;
			if (i < k) {
				n += s[i].first;
			}
			while (!b.empty() && n > b.top()) {
				n += b.top();
				b.pop();
				if (!a.empty()) {
					n += a.top();
					a.pop();
				}
			}
			a.push(n);
		}
	}
	return b.empty();
}

void f() {
	string have, need;
	cin >> have >> need;
	int n = have.size();
	vector <pair <int, char> > a;
	int len = 0;
	for (int i = 0; i < n - 1; i++) {
		if (have[i] == have[i + 1] && need[i] != need[i + 1]) {
			cout << "No" << endl;
			return;
		}
		if (need[i] != need[i + 1]) {
			a.push_back({ len + 1, need[i] });
			len = 0;
		}
		else {
			len++;
		}
	}
	a.push_back({ len + 1, need[n - 1] });
	int beg = 0;
	for (auto c : a) {
		if (c.second == '+' && !p1(have, beg, beg + c.first - 1)) {
			cout << "No" << endl;
			return;
		}
		if (c.second == '-' && !p2(have, beg, beg + c.first - 1)) {
			cout << "No" << endl;
			return;
		}
		if (beg + c.first < n && have[beg + c.first] == c.second) {
			for (int i = beg; i < beg + c.first; i++) {
				have[i] = c.second;
				
			}
			continue;
		}
		beg += c.first;

	}
	cout << "Yes" << endl;
	return;
}

int main() {
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		f();
	}
	return 0;
}