#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <iostream>
#include <stack>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

int n, m;
vector <int> a, da, b, db;
map <int, int> finda, findb;
ll ansSum = -1;
int ansLa = -1;
int ansRa = -1;
int ansLb = -1;
int ansRb = -1;

void f(int l) {
	set <int> s;
	ll sum = 0;
	for (int i = l; i < n; i++) {
		sum += da[i];
		s.insert(a[i]);
		ll maxSum = -1;
		int maxL = -1;
		int maxR = -1;
		ll nowSum = -1;
		int prev = 0;
		for (int j = 0; j < m; j++) {
			if (s.find(b[j]) != s.end()) {
				if (maxSum < nowSum) {
					maxL = prev;
					maxR = j - 1;
					maxSum = nowSum;
				}
				prev = j + 1;
				nowSum = 0;
			}
			else {
				nowSum += db[j];
			}
		}
		if (maxSum < nowSum) {
			maxL = prev;
			maxR = m - 1;
			maxSum = nowSum;
		}
		if (maxSum + sum > ansSum) {
			ansSum = maxSum + sum;
			ansLa = l;
			ansRa = i;
			ansLb = maxL;
			ansRb = maxR;
		}
	}
}

int main() {
	cin >> n >> m;
	a.resize(n);
	da.resize(n);
	b.resize(m);
	db.resize(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		finda[a[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		cin >> da[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> b[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> db[i];
		findb[b[i]] = i;
	}

	for (int i = 0; i < n; i++) {
		f(i);
	}

	ll newSum = 0;
	for (int i = 0; i < m; i++) {
		newSum += db[i];
	}
	if (newSum > ansSum) {
		cout << newSum << endl;
		cout <<0 << " " << 0 << endl;
		cout << 1 << " " << m << endl;
		return 0;
	}
	cout << ansSum << endl;
	cout << ansLa + 1 << " " << ansRa + 1 << endl;
	cout << ansLb + 1 << " " << ansRb + 1 << endl;
	return 0;
}