#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cmath>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;
struct VECTOR {
	ll x, y;
	VECTOR(pii a, pii b) {
		x = b.first - a.first;
		y = b.second - a.second;
	}
};
ll mult(VECTOR v1, VECTOR v2) {
	return v1.x * v2.y - v1.y * v2.x;
}
vector<pii> coor;
ll area(pii a, pii b, pii c) {
	VECTOR v1(a, b);
	VECTOR v2(a, c);
	return abs(mult(v1, v2));
}
bool check(int a, int b, int c) {
	ll s = area(coor[a], coor[b], coor[c]);
	rep(i, coor.size()) {
		if (i == a || i == b || i == c) continue;
		ll s1 = area(coor[a], coor[b], coor[i]);
		ll s2 = area(coor[b], coor[c], coor[i]);
		ll s3 = area(coor[a], coor[c], coor[i]);
		if (s1 + s2 + s3 <= s) return 0;
	}
	return 1;
}
int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	coor.resize(n);
	rep(i, n) cin >> coor[i].first >> coor[i].second;
	int w;
	cin >> w;
	while (w--) {
		vector<int> perm(n);
		bool b = 0;
		rep(i, n) {
			repp(j, i + 1, n) {
				repp(q, j + 1, n) {
					if (!check(i, j, q)) continue;
					cout << "? 3 " << i + 1 << " " << j + 1 << " "
						<< q + 1 << endl;
					string s;
					cin >> s;
					if (s == "Yes") {
						cout << "! 3 " << i + 1 << " " << j + 1 << " "
							<< q + 1 << endl;
						b = 1;
						break;
					}
				}
				if (b) break;
			}
			if (b) break;
		}
	}
}