from collections import deque

n, m = map(int, input().split())
inf = 10 ** 20

g = [[] for i in range(n)]
times = [[inf for j in range(n)] for i in range(n)]

for i in range(m):
    _, a, t, b = map(int, input().split())
    g[a - 1].append((b - 1, t, t * t))


q = [deque() for i in range(1001)]
q[0].append(0)
used = [False for i in range(n)]
ssq = [-1 for i in range(n)]
dist = [inf for i in range(n)]
ssq[0] = dist[0] = 0

mindist = inf
maxsq = -1

while True:
    f = -1
    for j in range(1001):
        if q[j]:
            f = j
            break
    if f == -1:
        break
    v = q[f].popleft()
    if v == n - 1:
        if dist[v] == mindist:
            maxsq = max(maxsq, ssq[v])
        elif dist[v] < mindist:
            mindist = dist[v]
            maxsq = ssq[v]
        continue
    used[v] = True
    for u, t, sq in g[v]:
        if not used[u]:
            if dist[u] == dist[v] + t:
                ssq[u] = max(ssq[u], ssq[v] + sq)
            elif dist[u] > dist[v] + t:
                dist[u] = dist[v] + t
                ssq[u] = ssq[v] + sq
            q[t].append(u)

print(mindist, maxsq)
