#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <list>
#include <fstream>

using namespace std;

#define endl '\n'

int main()
{
	ios::sync_with_stdio(0);
	cin.tie();

	int q;
	cin >> q;

	while (q--)
	{
		string a, b;
		cin >> a >> b;

		int n = a.size();

		int i = 0;
		bool ok = 1;
		while (i != n)
		{
			list<pair<char, int>> l;
			do
			{	
				if (l.empty() || l.back().first != a[i])
					l.insert(l.end(), { a[i], 1 });
				else
					l.back().second++;

				i++;
			} while (i != n && b[i - 1] == b[i]);

			if (i != n  && a[i-1] == a[i])
			{
				cout << "No" << endl;
				ok = 0;
				break;
			}

			if (i != n && a[i - 1] != b[i - 1])
			{
				cout << "No" << endl;
				ok = 0;
				break;
			}
			
			bool no = 0;
			auto it = l.begin();
			while (it != l.end())
			{
				no = 0;
				if (it->first != b[i - 1])
				{
					++it;
					continue;
				}
				
				bool tape = 1;
				while (it != l.begin() && tape)
				{
					auto temp = it;
					--temp;
					
					tape = 0;

					if (temp->first == it->first)
					{
						it->second += temp->second;
						l.erase(temp);
						tape = 1;
						no = 1;
					}
					 else if (temp->second < it->second)
					{
						it->second += temp->second;
						l.erase(temp);
						tape = 1;
						no = 1;
					}

				}

				tape = 0;
				while (it != --l.end() && tape)
				{
					auto temp = it;
					++temp;
					
					tape = 0;

					if (temp->first == it->first)
					{
						it->second += temp->second;
						l.erase(temp);
						tape = 1;
						no = 1;
					}
					else if (temp->second < it->second)
					{
						it->second += temp->second;
						l.erase(temp);
						tape = 1;
						no = 1;
					}
				}
					
				if (!no) ++it;
			}

			if (l.size() > 1 || l.front().first != b[i - 1])
			{
				cout << "No" << endl;
				ok = 0;
				break;
			}

		}

		if (ok)
		cout << "Yes" << endl;
	}
}