#include <vector>
#include <algorithm>
#include <string>
#include <iostream>
#include <set>

using namespace std;

long long mn = 1000000000;
int n;
int a;

void solve2()
{
	vector<vector<int>> dp(n, vector<int>(a + 1, -mn));

	vector<vector<int>> arr(n);
	int i;
	for (i = 0; i < n; ++i)
	{
		int a, b, c;
		cin >> a >> b >> c;

		arr[i].push_back(a);
		arr[i].push_back(b);
		arr[i].push_back(c);
	}

	for (i = 0; i < n; ++i)
		dp[i][0] = 0;

	for (i = 0; i < n; ++i)
	{
		for (int j = 0; j < a + 1; ++j)
		{
			if (arr[i][0] > j) continue;

			if (i != 0 ) dp[i][j] = dp[i - 1][j];

			/*if (i != 0 && dp[i - 1][j - arr[i][0]] != -mn)
			{
				dp[i][j] = max(dp[i][j], dp[i - 1][j - arr[i][0]] - arr[i][2]);
			}*/

			if (dp[i][j - arr[i][0]] != -mn)
				dp[i][j] = max(dp[i][j], dp[i][j - arr[i][0]] - arr[i][2]);
		}
	}

	for (i = a; i >= 0; --i)
	{
		if (dp[n - 1][i] != -mn)
		{
			cout << i * 1LL * mn + dp[n - 1][i];
			system("pause");
			exit(0);
		}
	}
}
int main()
{
	cin >> n >> a;

	if (n > 1) solve2();

	vector<vector<int>> arr(n);
	int i;
	for (i = 0; i < n; ++i)
	{
		int a, b, c;
		cin >> a >> b >> c;

		arr[i].push_back(a);
		arr[i].push_back(b);
		arr[i].push_back(c);
	}

	vector<pair<int, int>>am(a + 1);
	am[0] = { 1, 0 };
	bool was = 1;

	while (was)
	{
		was = 0;
		vector<pair<int, int>>temp(a + 1);
		for (int i = 0; i < a + 1; ++i)
		{
			if (am[i].first && i + arr[0][1] <= a)
				for (int j = i + arr[0][0]; j <= i + arr[0][1]; ++j)
				{
					temp[j].first = 1;
					temp[j].second = am[i].second + 1;
					was = 1;
				}
			else if (am[i].first && temp[i].first == 0)
				temp[i] = am[i];

		}
		if (was) am = temp;
	}


	int lst = -1;
	for (int i = 0; i < a + 1; ++i)
	{
		if (am[i].first)
		{
			lst = i;
			break;
		}
	}

	cout << lst * 1LL * 1000000000 - (am[lst].second) * 1LL * arr[0][2];

	system("pause");
	return 0;
}