#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <fstream>

using namespace std;

int main()
{
	//ifstream cin("in.txt");

	int n, m;
	cin >> n >> m;

	vector<int> a(n);
	vector<int> b(m);
	vector<int> ac(n);
	vector<int> bc(m);
	vector<int> ptrb(m+n+1, 1000000000);


	int i;

	for (i = 0; i < n; ++i)
		cin >> a[i];
	for (i = 0; i < n; ++i)
		cin >> ac[i];
	for (i = 0; i < m; ++i)
		cin >> b[i];
	for (i = 0; i < m; ++i)
		cin >> bc[i];

	for (i = 0; i < m; ++i)
		ptrb[b[i]] = i;

	int bst = -1000000000;
	int l0, r0, l1, r1;

	for (int i = 0; i < n; ++i)
	{
		long long cur = 0;
		for (int j = i; j < n; ++j)
		{
			cur += ac[j];
			int kek = ptrb[a[j]];
			if (kek < bc.size())
				bc[kek] *= -1;

			int temp = 0;
			int lst = 0;
			for (int k = 0; k < m+1; ++k)
			{
				if (k == m || bc[k] < 0)
				{
					if (temp + cur > bst)
					{
						l0 = i;
						r0 = j;
						l1 = lst;
						r1 = k - 1;
						bst = temp + cur;
					}

					temp = 0;
					lst = k + 1;
				}
				else
					temp += bc[k];
			}
		}

		for (int i = 0; i < m; ++i)
			if (bc[i] < 0)
				bc[i] *= -1;
	}


	long long tape = 0;
	
	if (bc[m - 1] < 0)
		bc[m - 1] *= -1;

	for (i = 0; i < m; ++i)
	{
		tape += bc[i];
	}

	if (tape > bst)
	{
		cout << tape << endl;
		cout << "0 0" << endl;
		cout << 1 << ' ' << m;
	}
	else
	{
		cout << bst << endl;
		cout << l0 + 1 << ' ' << r0 + 1 << endl;
		if (r1 < l1)
			cout << "0 0" << endl;
		else
			cout << l1 + 1<< ' ' << r1 + 1;
	}


	system("pause");

	return 0;
}