import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class A2 {

	private void solve() throws IOException {
		final int n = nextInt();
		final StringBuilder ans = new StringBuilder();
		final String open = "(", close = ")", yes = "Yes", qm = "? ", space = " ";
		ans.append(open);
		final int[] ds = new int[n];
		int d = 1;
		for (int i = 1; i < n; i++) {
			out.print(qm);
			out.print(ds[d] + 1);
			out.print(space);
			out.println(i + 1);
			out.flush();
			if (nextToken().equals(yes)) {
				ans.append(close);
				d--;
			} else {
				ans.append(open);;
				d++;
				ds[d] = i;
			}
		}
		out.print("! " + ans);
	}
	
	private final BufferedReader in;
	private final PrintWriter out;
	private StringTokenizer st;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private A2() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	public static void main(final String[] args) throws IOException {
		new A2();
	}

}
