import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class A {
	private final PrintWriter out;
	private final BufferedReader in;
	private StringTokenizer st;
	
	private void solve() throws IOException {
		out.print(new BigInteger(nextToken()).add(new BigInteger(nextToken())));
		final int n = 1312;
		final int[][] g = new int[n][n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j <= i; j++) {
				for (int k = 0; k < j; k++) {
					g[j][k] = Math.min(g[j][k], g[j][k] + g[i][k]);
				}
			}
		}
	}
	
	public static void main(String[] args) throws IOException {
		new A();
	}
	
	private A() throws IOException {
		out = new PrintWriter(System.out);
		in = new BufferedReader(new InputStreamReader(System.in));
		
		solve();
		
		out.close();
		in.close();
	}
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	/*
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}*/
}
