#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
using namespace std;

bool full(string &s) {
	for (int i = 0; i < s.length(); i++) {
		if (s[i] != '+')
			return false;
	}
	return true;
}

bool can(string &s, int L, int R, char c) {
	vector < pair < int, int > > v;
	for (int i = L; i < R; i++) {
		int pos = i;
		while (pos + 1 < R && s[pos] == s[pos + 1])
			pos++;
		v.push_back({ s[i] == '+' ? 1 : 0, pos - i + 1 });
		i = pos;
	}
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first == (c == '+' ? 1 : 0)) {
			int l = i - 1;
			int r = i + 1;
			int sz = v[i].second;
			while (true) {
				if (l < 0 && r >= v.size())
					break;
				if (l >= 0 && sz > v[l].second) {
					sz += v[l].second;
					l--;
					if (l >= 0)
						sz += v[l].second;
					l--;
					continue;
				}
				if (r < v.size() && sz > v[r].second) {
					sz += v[r].second;
					r++;
					if (r < v.size())
						sz += v[r].second;
					r++;
					continue;
				}
				break;
			}
			if (r >= v.size() && l < 0)
				return true;
		}
	}
	return false;
}

bool can(string &l, string &r) {
	if (full(r)) {
		return can(l, 0, l.size(), '+');
	}
	else {
		bool ok = true;
		for (int i = 0; i < r.size(); i++) {
			int pos = i;
			while (pos < r.size() && r[pos] == r[i])
				pos++;
			int lft = i, rgh = pos;
			if (!can(l, lft, rgh, r[i]))
				ok = false;

			i = pos - 1;
			if (i + 1 < r.size() && l[i + 1] == r[i] && r[i + 1] != l[i + 1])
				ok = false;
		}
		return ok;
	}
	return false;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("storage.in", "r", stdin);
	freopen("storage.out", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		string a, b;
		cin >> a >> b;
		if (can(a, b))
			cout << "Yes" << endl;
		else
			cout << "No" << endl;
	}
}