#include <iostream>
#include <vector>
#include <set>
#include <cmath>


using namespace std;

int n, m;
int inf = pow(10, 9);
int ans = inf;
int ans_kv = 0;


vector <pair<int, int> > g[1000];
set <int> my_set;


void dfs(int u, int sum, int kv) {
	if (u == n) {
		if (ans > sum || (ans == sum && kv > ans_kv)) {
			ans = sum;
			ans_kv = kv;
		}

		return;
	}

	for (auto edge : g[u]) {
		if (my_set.find(edge.second) == my_set.end()) {
			my_set.insert(u);
			dfs(edge.second, sum + edge.first, kv + edge.first * edge.first);
			my_set.erase(u);
		}
	}
}


int main() {
	cin >> n >> m;

	int u, v, c;
	int kek;
	for (int i = 0; i < m; ++i) {
		cin >> kek;
		cin >> u >> c >> v;

		g[u - 1].push_back({ c, v });
	}


	dfs(0, 0, 0);
	cout << ans << ' ' << ans_kv;
	return 0;
}