import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * Created by roi on 27.03.2017.
 */
public class Sequence {

    public static void main(String[] args) {
//        for (int i = 0; i < 300000; i++) {
//            System.out.println(i);
//        }
        new Thread(null, () -> new Sequence().run(), "", 1L << 25).start();
    }

    private ArrayList<Long> seq;
    private PrintWriter out;

    private void run() {
        FastScanner in = new FastScanner();
        seq = new ArrayList<>();

        while (true) {
            try {
                seq.add(in.nextLong());
            } catch (NullPointerException e) {
                break;
            }
        }

        out = new PrintWriter(System.out, false);
        reverse(seq.size() - 1);
        out.close();
    }

    private void reverse(int r) {
        out.print(seq.get(r) + " ");
        if (r > 0) {
            reverse(r - 1);
        }
    }

    private class FastScanner {

        BufferedReader br;
        StringTokenizer st;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        BigInteger nextBigInt() {
            return new BigInteger(next());
        }

    }

}
