#ifdef _DEBUG
#	include <iostream>
#	include <vector>
#	include <string>
#	include <list>
#	include <algorithm>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	ll n;
	cin >> n;

	vector<ll> t(n);
	for (ll i = 0; i < n; i++)
		cin >> t[i];

	vector<ll> l(n - 1), r(n - 1);
	for (ll i = 0; i < n - 1; i++)
		cin >> l[i] >> r[i];

	vector<ll> l_l(n, -1), l_r(n, -1), r_l(n, -1), r_r(n, -1);
	l_l[0] = 0;
	r_l[0] = (ll)1e18;
	for (ll j = 1; j < n - 1; j++)
	{
		l_l[j] = max(l_l[j - 1], l[j - 1]);
		r_l[j] = min(r_l[j - 1], r[j - 1]);

		if (r_l[j] < l_l[j])
		{
			r_l[j] = l_l[j] = -1;
			break;
		}

		if (l_l[j] == l[j - 1])
			l_l[j] = max((ll)0, l_l[j] - t[j]);
	}

	l_r[n - 1] = 0;
	r_r[n - 1] = (ll)1e18;
	for (ll j = n - 1; j > 1; j--)
	{
		l_r[j - 1] = max(l_r[j], l[j - 1]);
		r_r[j - 1] = min(r_r[j], r[j - 1]);

		if (r_r[j - 1] < l_r[j - 1])
		{
			r_r[j - 1] = l_r[j - 1] = -1;
			break;
		}

		if (l_r[j - 1] == l[j - 1])
			l_r[j - 1] = max((ll)0, l_r[j - 1] - t[j - 1]);
	}

	for (ll i = 0; i < n; i++)
	{
		//ll l_l = 0, r_l = (ll)1e18;

		if (i > 0)
		{
			if (l_l[i - 1] == -1)
			{
				cout << -1 << endl;
				continue;
			}

			if (i > 0)
			{
				l_l[i - 1] = max(l_l[i - 1], l[i - 1]);
				r_l[i - 1] = min(r_l[i - 1], r[i - 1]);

				if (r_l[i - 1] < l_l[i - 1])
				{
					cout << -1 << endl;
					continue;
				}

				if (l_l[i - 1] == l[i - 1])
					l_l[i - 1] = max((ll)0, l_l[i - 1] - t[i]);
			}
		}

		if (i + 1 < n)
		{
			if (l_r[i + 1] == -1)
			{
				cout << -1 << endl;
				continue;
			}

			if (i < n - 1)
			{
				l_r[i + 1] = max(l_r[i + 1], l[i]);
				r_r[i + 1] = min(r_r[i + 1], r[i]);

				if (r_r[i + 1] < l_r[i + 1])
				{
					cout << -1 << endl;
					continue;
				}

				if (l_r[i + 1] == l[i])
					l_r[i + 1] = max((ll)0, l_r[i + 1] - t[i]);
			}
		}
//			l_r = max((ll)0, l_r - t[i + 1]);

		int _l, _r;

		if (i == 0 && i == n - 1)
		{
			_l = _r = 0;
		}
		else if (i == 0)
		{
			_l = l_r[i + 1];
			_r = r_r[i + 1];
		}
		else if (i == n - 1)
		{
			_l = l_l[i - 1];
			_r = r_l[i - 1];
		}
		else
		{
			_l = max(l_l[i - 1], l_r[i + 1]);
			_r = min(r_l[i - 1], r_r[i + 1]);
		}

		if (_r < _l)
		{
			cout << -1 << endl;
			continue;
		}

		if ((i > 0 && _l == l[i - 1] || i == 0) && (i < n - 1 && _l == l[i] || i == n - 1))
			cout << max((ll)0, _l - t[i]) << endl;
		else
			cout << _l << endl;

//		cout << max((ll)0, max(l_l, l_r)) << endl;
	}
}