#include <iostream>
#include <vector>
using namespace std;

struct ex {
    int c, l, r;
};

int64_t anti1 = 1e9;

int main() {
    int n, a;
    cin >> n >> a;
    vector <ex> exs(n);
    for (int i = 0; i < n; i++) {
        cin >> exs[i].l >> exs[i].r >> exs[i].c;
    }
    int64_t prof[a + 1];
    for (int i = a; i >= 0; i--) {
        prof[i] = 0;
        for (ex e:exs) {
            if (i + e.r <= a) {
                int64_t cprof = anti1 * e.l - e.c + prof[i + e.l];
                for (int j = e.l + 1; j <= e.r; j++) {
                    cprof = min(cprof, anti1 * j - e.c + prof[i + j]);
                }
                prof[i] = max(prof[i], cprof);
            }
        }
    }
    cout << prof[0];
    return 0;
}
