#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 1005;
const ll INF = 1e18;

vector<pair<ll, ll>> edge[maxN];

pair<ll, ll> dist[maxN];

int main()
{
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    if(n > maxN) return -1;

    int m;
    cin >> m;

    for(int i = 0; i < m; i++)
    {
        int cnt;
        cin >> cnt;

        vector<ll> dist, vert;
        for(int k = 0; k < cnt; k++)
        {
            int v, d;
            cin >> v >> d;
            v--;
            vert.push_back(v);
            dist.push_back(d);
        }
        int v;
        cin >> v;
        v--;
        vert.push_back(v);

        for(int i = 0; i < vert.size(); i++)
        {
            ll sum = 0;
            for(int j = i + 1; j < vert.size(); j++)
            {
                sum += dist[j - 1];

                edge[vert[i]].push_back(make_pair(vert[j], sum));
            }
        }
    }

    for(int i = 0; i < n; i++) dist[i] = make_pair(INF, 0LL);

    dist[0] = make_pair(0, 0LL);

    set<pair<pair<ll, ll>, int>> s;
    s.insert(make_pair(dist[0], 0));

    while(s.size() > 0)
    {
        auto el = *s.begin(); s.erase(s.begin());

        int v = el.second;
        for(auto e : edge[v])
        {
            int u = e.first;

            if(dist[u] > make_pair(dist[v].first + e.second, dist[v].second - e.second * e.second))
            {
                s.erase(make_pair(dist[u], u));
                dist[u] = make_pair(dist[v].first + e.second, dist[v].second - e.second * e.second);
                s.insert(make_pair(dist[u], u));
            }
        }
    }

    cout << dist[n - 1].first << " " << -dist[n - 1].second << endl;

    return 0;
}
