#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int maxA = 200005;
const int maxN = 105;
const ll INF = 1e18;
const ll X = 1e9;

struct Query
{
    ll l, r, c;
};

Query arr[maxN];
ll dp[maxN];

struct Q
{
    vector<ll> st1;
    vector<ll> st2;
    vector<ll> m2;
    ll m;

    Q() {m = INF;}
};

Q qarr[maxN];

void add(ll x, int i)
{
    qarr[i].st1.push_back(x);
    qarr[i].m = min(qarr[i].m, x);
}

void pop(int i)
{
    if(qarr[i].st2.size() == 0)
    {
        for(int k = qarr[i].st1.size() - 1; k >= 0; k--)
        {
            qarr[i].st2.push_back(qarr[i].st1[k]);
            qarr[i].m2.push_back(qarr[i].st1[k]);
        }
        for(int k = 1; k < qarr[i].m2.size(); k++) qarr[i].m2[k] = min(qarr[i].m2[k], qarr[i].m2[k - 1]);
        qarr[i].st1.clear();
        qarr[i].m = INF;
    }

    qarr[i].st2.pop_back();
    qarr[i].m2.pop_back();
}

void print(int i)
{
    for(int k = qarr[i].st1.size() - 1; k >= 0; k--) cout << qarr[i].st1[k] << " ";
    for(int x : qarr[i].st2) cout << x << " ";
    cout << endl;
}

ll get(int i)
{
    return min(qarr[i].m, qarr[i].m2.size() > 0 ? qarr[i].m2.back() : INF);
}

int main()
{
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
        //freopen("in.out", "w", stdout);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, a;

    cin >> n >> a;

    for(int i = 0; i < n; i++)
    {
        cin >> arr[i].l >> arr[i].r >> arr[i].c;
    }

    for(int i = a; i >= 0; i--)
    {
        dp[i] = 0;
        for(int k = 0; k < n; k++)
        {
            if(i + arr[k].l <= a) add(dp[i + arr[k].l] + (i + arr[k].l) * X, k);
            if(i + arr[k].r < a) pop(k);

            //cout << i << " " << get(k) << ": ";
            //print(k);

            if(i + arr[k].r <= a)
            {
                dp[i] = max(dp[i], (get(k) - i*X) - arr[k].c);
            }
        }

    }

    //for(int i = 0; i <= a; i++) cout << dp[i] << " ";

    cout << dp[0] << endl;

    return 0;
}
