#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back

int n;
vec<int> arr;
vec<char> ch, nch;

int get_ans(int l, int r, int h) {
    if (l >= r || h == -1) { return 0; }

    int cnt[2] = {};
    for (int i = l; i < r; i++) {
        int v = (arr[i] >> h) & 1;
        if (i != l && ((arr[i - 1] >> h) & 1) == (v ^ 1)) { cnt[v] = 0; }
        cnt[v]++;
    }
    if (cnt[0] + cnt[1] != r - l) {
        return -1;
    }
    int f = (arr[l] == 0 ? cnt[0] : cnt[1]);

    int x = get_ans(l, l + f, h - 1);
    int y = get_ans(l + f, r, h - 1);
    if (x == -1 || y == -1) {
        return -1;
    }
    if (cnt[0] * cnt[1] == 0) { return 0; }

    ch[h] |= (((arr[l] >> h) & 1) == 1);
    nch[h] |= (((arr[l] >> h) & 1) == 0);
}

int call() {
    ch = nch = vec<char>(30);

    int x = get_ans(0, n, 30);
    if (x == -1) { return -1; }
    int res = 0;
    for (int k = 0; k < 30; k++) {
        if (ch[k] && nch[k]) { return -1; }
        else if (ch[k]) { res += (1 << k); }
    }
    return res;
}

int main() {
    freopen("order.in", "r", stdin);
    freopen("order.out", "w", stdout);

    cin >> n;
    arr.resize(n);
    for (int &k : arr) { cin >> k; }
    cout << call() << '\n';

    int q;
    cin >> q;
    for (int k = 0; k < q; k++) {
        int i, x;
        cin >> i >> x;
        arr[i - 1] = x;
        cout << call() << '\n';
    }
    return 0;
}
