#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
using namespace std;
int main()
{
	int n, m;
	cin >> n >> m;
	vector<int> a(n), x(n), b(m), y(m);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 0; i < n; ++i)
		cin >> x[i];
	for (int i = 0; i < m; ++i)
		cin >> b[i];
	for (int i = 0; i < m; ++i)
		cin >> y[i];
	map<int, int> bp;
	for (int i = 0; i < m; ++i)
		bp[b[i]] = i;
	vector<long long> bs(m + 1);
	for (int i = 1; i < m + 1; ++i)
		bs[i] = bs[i - 1] + y[i - 1];
	long long res = -1;
	int a1, a2, a3, a4;
	for (int i = 0; i < n; ++i) {
		set<int> g;
		g.insert(-1);
		g.insert(m);
		long long sum = 0;
		for (int j = i; j < n; ++j) {
			g.insert(bp[a[j]]);
			sum += x[j];
			long long mr = 0;
			for (auto k = next(g.begin()); k != g.end(); ++k) {
				int l = *prev(k);
				int r = *k;
				mr = max(mr, bs[r] - bs[l + 1]);
				if (mr + sum > res) {
					res = mr + sum;
					a1 = i + 1;
					a2 = j + 1;
					a3 = l + 2;
					a4 = r;
				}
			}
		}
	}
	long long s1 = accumulate(x.begin(), x.end(), 0ll);
	if (s1 >= res) {
		res = s1;
		a1 = 1;
		a2 = n;
		a3 = 0, a4 = 0;
	}
	s1 = accumulate(y.begin(), y.end(), 0ll);
	if (s1 >= res) {
		res = s1;
		a1 = 0;
		a2 = 0;
		a3 = 1, a4 = m;
	}
	cout << res << '\n' << a1 << ' ' << a2 << '\n' << a3 << ' ' << a4;
}
