#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <numeric>
#include <cassert>
#include <fstream>
#define map unordered_map
using namespace std;
ifstream in("internship.in");
ofstream out("internship.out");
#define cin in
#define cout out
int main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<int> a(n), x(n), b(m), y(m);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 0; i < n; ++i)
		cin >> x[i];
	for (int i = 0; i < m; ++i)
		cin >> b[i];
	for (int i = 0; i < m; ++i)
		cin >> y[i];
	map<int, int> bp;
	for (int i = 0; i < m; ++i)
		bp[b[i]] = i;
	vector<long long> bs(m + 1);
	for (int i = 1; i < m + 1; ++i)
		bs[i] = bs[i - 1] + y[i - 1];
	long long res = -1;
	int a1, a2, a3, a4;
	for (int i = 0; i < n; ++i) {
		set<int> g;
		g.insert(-1);
		g.insert(m);
		long long sum = 0;
		set<pair<long long, pair<int, int>>> q;
		q.insert({ bs.back(), {-1, m} }); 
		for (int j = i; j < n; ++j) {
			if (bp.count(a[j])) {
				auto y = g.upper_bound(bp[a[j]]);
				int l = *prev(y);
				int r = *y;
				long long x = bs[r] - bs[l + 1];
				q.erase({ x, {l, r} });
				int m = bp[a[j]];
				x = bs[m] - bs[l + 1];
				q.insert({ x, {l, m} });
				x = bs[r] - bs[m + 1];
				q.insert({ x,{ m, r } });
				g.insert(m);
			}
			sum += x[j];
			auto y = prev(q.end());
			if (y->first + sum > res) {
				res = y->first + sum;
				a1 = i + 1;
				a2 = j + 1;
				a3 = y->second.first + 2;
				a4 = y->second.second;
			}
		}
	}
	long long s1 = accumulate(x.begin(), x.end(), 0ll);
	if (s1 >= res) {
		res = s1;
		a1 = 1;
		a2 = n;
		a3 = 0, a4 = 0;
	}
	s1 = accumulate(y.begin(), y.end(), 0ll);
	if (s1 >= res) {
		res = s1;
		a1 = 0;
		a2 = 0;
		a3 = 1, a4 = m;
	}
	cout << res << '\n' << a1 << ' ' << a2 << '\n' << a3 << ' ' << a4;
}
